// $Date: 2001/11/12 17:55:45 $ $Author: stefanw $ $Revision: 1.1 $

// 
// patt, repl, OPT (wie fur match)
// 

Rule::ln:=
  [Rule(ln(X), hold(ln(op(X, 1)) - ln(op(X, 2))),
        Cond = {X -> type(X) = DOM_RAT}),
   Rule(ln(X), hold(op(X, 2)*ln(op(X, 1))),
        Cond = {X -> type(X) = "_power"
                and (op(X, 2) = 1/2
                     or is(op(X, 2), Type::Positive) = TRUE)}),
   
   Rule(ln(pr*r), hold(ln(numer(pr)) - ln(denom(pr)) + ln(r)),
        {pr -> is(pr, Type::PosRat) = TRUE}),
   Rule(ln(exp(real)*r), hold(real + ln(r)), {real -> is(real, Type::Real) = TRUE}),
   Rule(ln(pos^real*r), hold(real*ln(pos) + ln(r)),
        {pos -> is(pos, Type::Positive) = TRUE, real -> is(real, Type::Real) = TRUE}),
   Rule(ln(neg^even*r), even*ln(-neg) + ln(r),
        {neg -> is(neg, Type::Negative) = TRUE, even -> is(even, Type::Even) = TRUE}),
   Rule(ln(neg^odd*r), odd*ln(-neg) + ln(-r),
        {neg -> is(neg, Type::Negative) = TRUE, odd -> is(odd, Type::Odd) = TRUE}),
   Rule(ln(pos*r), ln(pos) + ln(r),
        {pos -> is(pos, Type::Positive) = TRUE}),
   Rule(ln(neg*r), ln(-neg) + ln(-r),
        {neg -> is(neg, Type::Negative) = TRUE}),
   Rule(ln(y^n), n*ln(y),
        Cond = {n -> (is(n, Type::Interval(-1, [1])) = TRUE
                      or n = -1 and is(y <= 0) = FALSE or
                      is(n, Type::Interval(-1, [1])) = TRUE
                      and is(Re(y) > 0) = TRUE)}),
   Rule(ln(exp(z)), z,
        Cond = {z -> is(Im(z), Type::Interval(-PI, [PI]))})]:

