// $Date: 2002/11/06 08:18:50 $ $Author: cube $ $Revision: 1.2.2.1 $

// 
// patt, repl, OPT (wie fur match)
// 
// 
// 
// 
// 


Simplify::ruleOld:=
  // call old simplify procedures
  table("All"   = [Rule(Z + sin(X)^2 + cos(X)^2, 1 + Z),
                   Rule(X, hold(simplify::exp(X)), {X -> has(X, hold(exp))}, 99),
                   Rule(X, hold(simplify::ln(X)), {X -> has(X, hold(ln))}, 99),
                   Rule(X, hold(simplify::sin(X)), {X -> has(X, hold(sin))}, 99),
                   Rule(X, hold(simplify::cos(X)), {X -> has(X, hold(cos))}, 99),
                   Rule(X, hold(simplify::sqrt(X)), {X -> has(X, hold(sqrt))}, 99),
                   Rule(X*Y, hold(_mult::simplify(X*Y)), {}, 99),
                   Rule(X^n, hold(map(X, _power, n)),
                        {X -> is(n, Type::Integer) = TRUE and type(X) = "_mult"}),
                
                   Rule(X, hold(expand(X)), {}, 99),
                   Rule(X, hold(normal(X)), {}, 99),
                   // too expensive:
                   // Rule(X, hold(radsimp(X)), {}, 99),
                   Rule(X, hold(expr(maprat(X, factor)), {}, 99),
                   //Rule(X, hold(map(X, Simplify)), {X->domtype(X) = DOM_EXPR}, 100),
                   Rule(X, hold(simplify(X)), {}, 100)
                   ]
        ):
  

Simplify::ruleExpand:=
  table("ln"     = [Rule(ln(X), hold(ln(op(X, 1)) - ln(op(X, 2))),
                         Cond = {X -> type(X) = DOM_RAT}),
                    Rule(ln(X), hold(op(X, 2)*ln(op(X, 1))),
                         Cond = {X -> type(X) = "_power"
                                 and (op(X, 2) = 1/2
                                      or is(op(X, 2), Type::Positive) = TRUE)})],
        "_power" = [Rule(sqrt(X), hold(sign(op(X, 1))*op(X, 1)),
                         Cond = {X -> type(X) = "_power"
                                 and is(op(X, 1), Type::Real) = TRUE
                                 and op(X, 2) = 2}),
                    
                    Rule(X^p, hold(exp(op(X)*p)), Cond = {X -> type(X) = "exp"}),
                    Rule(X^r, hold(op(X, 1)^(op(X, 2)*r)),
                         Cond = {r -> is(r, Type::Rational) = TRUE,
                                 X -> type(X) = "_power" and
                                 is(op(X, 1), Type::NonNegative) = TRUE and
                                 is(op(X, 2), Type::Rational) = TRUE})],
        "_and"   = [Rule(X and (Y or Z), X and Y or X and Z)],
        
        "All"    = [Rule(X, hold(expand(X)), {}, 99)]
         ):

Simplify::ruleRewrite:=
  table("cos"   = [Rule(cos(X)^2, 1 - sin(X)^2),
                   Rule(1 - cos(X)^2, sin(X)^2)
                   ],
        "sin"   = [Rule(sin(X)^2, 1 - cos(X)^2),
                   Rule(1 - sin(X)^2, cos(X)^2)
                   ],
        "tan"   = [
                   ],
        "cot"   = [
                   ],
        "_power"= [Rule(sqrt(X), hold(sign(op(X, 1))*op(X, 1)),
                       Cond = {X -> type(X) = "_power"
                               and is(op(X, 1), Type::Real) = TRUE
                               and op(X, 2) = 2})
                  ],
        "sqrt" = [
                  ],
        "_power"= [Rule(X^Y, hold(exp(Y*ln(X))),
           Cond = {Y -> not testtype(Y, Type::Constant),
                   // If X is non-zero or if it's not 
                   // determinable if X is non-zero (in 
                   // such a case is yields UNKNOWN)
                   // the rule is applied.
                   X -> is(X=0) <> TRUE }),
                  Rule(sin(X), hold(1/(2*I)*(exp(X*I)-exp(-X*I)))),
                  Rule(cos(X), hold(1/2*(exp(X*I)+exp(-X*I)))),
                  Rule(tan(X), hold(-I*(exp(X*I)^2-1)/(exp(X*I)^2+1)))
//                   hold(cot)   = (x -> I*(exp(x*I)^2+1)/(exp(x*I)^2-1)),
//                   hold(sinh)  = (x -> 1/2*(exp(x)-exp(-x))),
//                   hold(cosh)  = (x -> 1/2*(exp(x)+exp(-x))),
//                   hold(tanh)  = (x -> (exp(x)^2-1)/(exp(x)^2+1)),
//                   hold(coth)  = (x -> (exp(x)^2+1)/(exp(x)^2-1)),
//                   hold(arcsin)= (x -> -I*ln(I*x+sqrt(1-x^2))),
//                   hold(arccos)= (x -> -I*ln(x+I*sqrt(1-x^2))),
//                   hold(arctan)= (x -> I/2*(ln(1-I*x)-ln(1+I*x))),
//                   hold(arccot) = (x -> I/2*(ln(1-I/x)-ln(1+I/x))),
//                   hold(arcsinh)= (x -> ln(x+sqrt(x^2+1))),
//                   hold(arccosh)= (x -> ln(x+sqrt(x^2-1))),
//                   hold(arctanh)= (x -> 1/2*(ln(1+x)-ln(1-x))),
//                   hold(arccoth)= (x -> 1/2*(ln(1+1/x)-ln(1-1/x))),
//                // 2-argument version of arg is obsolete
//                // hold(arg)    = ((x, y) -> -I*ln((x+I*y)/abs(x+I*y)))
//                   hold(arg)    = (z -> -I*ln(z/abs(z)))
                  ],
        "not"   = [
                  ],
        "not"   = [Rule(not(X or Y), not(X) and not(Y))
                  ],
        "not"   = [Rule(not(X and Y), not(X) or not(Y))
                  ],
        "not"   = [
                  ]):

Simplify::ruleCompact:=
  table("_plus" = [Rule(Z + sin(X)^2 + cos(X)^2, 1 + Z)]
        ):

Simplify::ruleNormal:=
  table("All"   = [Rule(X, hold(normal(X)), {}, 99)]
        ):

Simplify::rule:=
  table(
        "ln"   = [Rule(ln(posint1/posint2*r), ln(posint1) - ln(posint2) + ln(r)),
                  Rule(ln(exp(real)*r), real + ln(r)),
                  Rule(ln(positive^real*r), real*ln(positive) + ln(r)),
                  Rule(ln(negative^even*r), even*ln(-negative) + ln(r)),
                  Rule(ln(negative^odd*r), odd*ln(-negative) + ln(-r)),
                  Rule(ln(positive*r), ln(positive) + ln(r)),
                  Rule(ln(negative*r), ln(-negative) + ln(-r)),
                  Rule(ln(y^n), n*ln(y),
                       Cond = {n -> (is(n, Type::Interval(-1, [1])) = TRUE
                                     or n = -1 and is(y <= 0) = FALSE or
                                     is(n, Type::Interval(-1, [1])) = TRUE
                                     and is(Re(y) > 0) = TRUE)}),
                  Rule(ln(exp(z)), z,
                       Cond = {z -> is(Im(z), Type::Interval(-PI, [PI]))})
                  ]
        ):

 
