/*****************************************************************************
  $Id: modStirling.mu,v 1.2 2001/12/03 15:40:07 nthiery Exp $
  File:		lib/COMBINAT/modStirling.mu
  Authors:	Werner M. Seiler, Uni Karlsruhe/Mannheim
		(wms@ira.uka.de, seiler@euler.math.uni-mannheim.de)
  Purpose:	Function 'combinat::modStirling': modified Stirling numbers
  Taken from:	MuPAD 2.0.0, 26/02/2001
  Last update: 	Tue Jan  4 10:35:49 2000
  Created: 	Fri Nov  5 19:12:16 1999
  License:	LGPL
*****************************************************************************/

/// combinat::modStirling(q,n,k) - modified Stirling number sigma_k^{(n)}(q)
/*
   Walter, 14/10/2000: moved from detools::modStirling to combinat::modStirling
   Thiry, 26/02/2001: file renamed
*/

combinat::modStirling :=
    proc(q:DOM_INT,n:DOM_INT,k:DOM_INT):DOM_INT
    option remember;
    begin
	if testargs() and ((k>n) or (k<0) or (n<0)) then
	    error("illegal arguments");
	end_if;
	case k
	of 0 do return(1);
	of 1 do return((n^2+(2*q+1)*n)/2);
	of n do return(_mult( i $ i=(q+1)..(q+n)));
	otherwise
	    return(combinat::modStirling(q,n-1,k)+
		   (q+n)*combinat::modStirling(q,n-1,k-1));
	end_case;
    end_proc:
