// $Id: cvhp_hash.mu,v 1.1 2002/06/24 11:52:46 ccr Exp $

// The Chaum-van Heijst-Pfitzmann Hash function.
// Right now, the code is fixed to produce a return value
// from 1 to 2417851639229258349415042.  Change the definitions
// of a, b, and p below to change this, but remember
// that a and b must be primitive mod p and that (p-1)/2 must be prime.

crypto::cvhp_hash :=
proc(message)
  local a, b, p, x1, x2, i;
begin
  if domtype(message) = DOM_STRING
    then message := numlib::toAscii(message);
    message := zip([message[2*i-1]$i=1..ceil(nops(message)/2)],
                   [message[2*i]$i=1..floor(nops(message)/2)],
                   (x,y) -> 256*x+y, 0);
    message := zip([message[2*i-1]$i=1..ceil(nops(message)/2)],
                   [message[2*i]$i=1..floor(nops(message)/2)],
                   (x,y) -> 65536*x+y, 0);    
    message := zip([message[2*i-1]$i=1..ceil(nops(message)/2)],
                   [message[2*i]$i=1..floor(nops(message)/2)],
                   (x,y) -> 4294967296*x+y, 0);    
  end_if;

  p := 2417851639229258349415043;
  a := 786534234;
  b := 98723576521345698;

  x1 := 0:

  for x2 in message do
    x1 := (powermod(a, x1, p) + powermod(b, x2, p)) mod p;
  end_for;

  x1;
end_proc:
