#++
Dom::HomogenisedWeylAlgebra

Author: Marcus Hausdorf, Uni Karlsruhe
        (hausdorf@ira.uka.de)
Created: 	Wed Oct 17 10:31:49 2001
Last update: 	Thu Oct 25 14:13:41 2001
++#

alias(REP(x) = extop(x, 1)):

domain Dom::HomogenisedWeylAlgebra(W, hv:DOM_IDENT)
local HVar_l:DOM_LIST, HR:DOM_DOMAIN, HOrder;
inherits Dom::WeylAlgebra(HVar_l, HR, HOrder, hv);
category Cat::SolvableAlgebra(HR);
axiom (if HR::hasProp(Ax::normalRep) then Ax::normalRep end_if),
      (if HR::hasProp(Ax::canonicalRep) then Ax::canonicalRep end_if);
 
//================
// body of domain 
//================

homogenise := (x -> new(dom, poly(map(W::poly2list(x), l -> ([l[1], 
    [W::degree(x) - _plus(op(l[2]))] . l[2]])), dom::dummyList, HR)));
    
dehomogenise := proc(x)
    local DOM;
    begin
	DOM := dom;
	new(W, poly(map(dom::poly2list(x), l -> ([l[1],
	    [op(l[2], 2..DOM::numVars)]])), W::dummyList, HR));
    end_proc;

begin
    if args(0) < 1 or args(0) > 2 then
	error("wrong number of arguments");
    end_if;
    if (domtype(W) <> DOM_DOMAIN
	or not W::constructor = Dom::WeylAlgebra)
    then
	error("wrong type of arguments");
    end_if;
    if not iszero(contains(W::variables, hv)) then
	error("incorrect homogenisation variable");
    end_if;
    HVar_l := W::variables;
    HR := W::coeffRing;
    HOrder := Dom::MonomOrdering(Matrix(linalg::stackMatrix(matrix([[1 $ (W::numVars + 1)]]),
	linalg::concatMatrix(matrix([[0] $ W::numVars]), W::orderMatrix))));
end_domain
    


















