#++
Dom::JanetDivision 

Author: Marcus Hausdorf, Uni Mannheim
        (hausdorf@math.uni-mannheim.de)
Created: 	Tue Dec 11 13:25:05 2001
Last update: 	Thu Feb 14 14:51:38 2002
++#

domain Dom::JanetDivision(nV:Type::PosInt)
local perm_f:DOM_BOOL, perm, invperm;
inherits Dom::BaseDomain;
category Cat::InvolutiveDivision(nV);

separationTableMult := proc(mi_l:Type::ListOf(Type::ListOf(Type::NonNegInt)))
    local res_t:DOM_TABLE, k:DOM_INT, p1:DOM_INT, p2:DOM_INT, current_mv:DOM_SET,
	rvless:DOM_PROC, classr:DOM_PROC, current_mu:DOM_LIST;
    begin
	if nops(mi_l) = 1 then
	    return(table(mi_l[1] = {i $ i = 1..nV}));
	else
	    rvless := proc(mu1, mu2)
	    local tmp, k;
	    begin
		for k from nV downto 1 do
		    tmp := mu2[k] - mu1[k];
		    if tmp > 0 then
			return(FALSE);
		    elif tmp < 0 then 
			return(TRUE);
		    end_if;
		end_for;
		TRUE;
	    end_proc;

	    classr := (l -> (if not iszero(traperror(
		(tmp := max(op(map(select([[l[i], i] $ i = 1..nops(l)],
		    l2 -> not iszero(l2[1])), op, 2)))))) then 1 else tmp end_if));    

	    if perm_f then
		mi_l := map(mi_l, l -> [l[i] $ i in invperm]);
	    end_if;
	    
	    mi_l := sort(mi_l, (l1, l2) -> (rvless(l1, l2)));
	    current_mu := mi_l[1];
	    current_mv := {i $ i = 1..nV};
	    p1 := nV;
	    if perm_f then
		res_t := table([current_mu[i] $ i in perm] = current_mv);
	    else
		res_t := table(current_mu = current_mv);
	    end_if;
	    for k from 2 to nops(mi_l) do
		p2 := classr(zip(current_mu, mi_l[k], _subtract));
		if p2 <= p1 then
		    current_mv := current_mv minus {p2};
		elif p2 > p1 then
		    current_mv := (current_mv minus {p2}) union 
			{i $ i = p1..(p2 - 1)};
		end_if;
		if perm_f then
		    res_t[[mi_l[k][i] $ i in perm]] := map(current_mv, l -> perm[l])
		else
		    res_t[mi_l[k]] := current_mv;
		end_if;
		current_mu := mi_l[k];
		p1 := p2;
	    end_for;
	end_if;
	res_t;
    end_proc;

begin
    perm_f := FALSE;
    if args(0) = 2 then
	if (testtype(args(2), Type::ListOf(Type::NonNegInt)) and
	    nops(args(2)) = nV) 
	then
	    perm_f := TRUE;
	    perm := args(2);
	    invperm := [contains(perm, i) $ i = 1..nV];
	end_if;
    end_if;

end_domain;






















