#++
Dom::LiftedDivision

Author: Marcus Hausdorf, Uni MAnnheim
        (hausdorf@math.uni-mannheim.de)
Created: 	Thu Jan 31 12:49:29 2002
Last update: 	Thu Jan 31 12:49:29 2002
++#

domain Dom::LiftedDivision(L:DOM_DOMAIN)
inherits Dom::BaseDomain;
category Cat::InvolutiveDivision(nV);

separationTableMult := proc(mi_l:Type::ListOf(Type::ListOf(Type::NonNegInt)))
    local m:DOM_INT, tmp, res_t:DOM_TABLE, mu;
    begin
	m := max(mi_l[i][1] $ i = 1..nops(mi_l));
	tmp := map(L::separationTableMult(map([op({op(mi_l)})], l -> [op(l, 2..nV)])),
	    l -> map(l, _plus, 1));
	res_t := table();
	for mu in mi_l do
	    if mu[1] = m then
		res_t[mu] := {1} union tmp[[op(mu, 2..nV)]];
	    else
		res_t[mu] := tmp[[op(mu, 2..nV)]];
	    end_if;
	end_for;
	res_t;
    end_proc;

begin
    if (domtype(L) <> DOM_DOMAIN
	or L::hasProp = FAIL
	or not L::hasProp(Cat::InvolutiveDivision))
    then
	error("wrong type of arguments");
    end_if;
    nV := L::numVars + 1;
end_domain;
