#++
Dom::PommaretDivision

Author: Marcus Hausdorf, Uni Mannheim
        (hausdorf@math.uni-mannheim.de)
Created: 	Mon Dec 17 15:33:31 2001
Last update: 	Thu Feb 14 14:51:48 2002
++#

domain Dom::PommaretDivision(nV:Type::PosInt)
local perm_f:DOM_BOOL, perm, invperm;
inherits Dom::BaseDomain;
category Cat::InvolutiveDivision(nV);

separationTableMult := proc(mi_l:Type::ListOf(Type::ListOf(Type::NonNegInt)))
    local DOM:DOM_DOMAIN, tmp;
    begin
	DOM := dom;
	if perm_f then
	    table(op(zip(mi_l, map(map(map(mi_l, l -> [l[i] $ i in invperm]), 
		l2 -> {i $ i = 1..DOM::class(l2)}),
		    l3 -> map(l3, l4 -> perm[l4])), (l5, l6) -> l5 = l6)));
	else
	    table(op(zip(mi_l, map(mi_l, l -> {i $ i = 1..DOM::class(l)}), 
		(l1, l2) -> l1 = l2)));
	end_if;
    end_proc;

class := proc(mu)
    option remember;
    begin
	if not iszero(traperror((tmp := min(op(map(select([[mu[i], i] $ i = 1..nV],
	    l -> not iszero(l[1])), op, 2))))))
	then
	    return(nV);
	else
	    return(tmp);
	end_if;
    end_proc;
    
begin
    perm_f := FALSE;
    if args(0) = 2 then
	if (testtype(args(2), Type::ListOf(Type::NonNegInt)) and
	    nops(args(2)) = nV) 
	then
	    perm_f := TRUE;
	    perm := args(2);
	    invperm := [contains(perm, i) $ i = 1..nV];
	end_if;
    end_if;
    
end_domain;













