
// intlib::intOverset(f, x, S)
//

// return int_{-\infty}^{\infty} f(x) chi_S(x) dx
// where chi_S is the charcateristic function of S



intlib::intOverSet:=
proc(integrand, variable: DOM_IDENT, set)
  local a, b;
begin

  if set::dom::intOverSet <> FAIL then
    return(set::dom::intOverSet(args()))
  end_if;
  
  case type(set)
    of Dom::Interval do
      a:= set::dom::left(set);
      b:= set::dom::right(set);
      return(piecewise
             ([a < b, int(integrand, variable=a..b)],
              [a >= b, 0]))
    of DOM_SET do
      // integral over a finite set is zero
      // (ignoring the case dirac(..) at the moment
      return(0)
  end_case;

  procname(args())
end_proc:


intlib::intOverSet:=funcenv(intlib::intOverSet):

intlib::intOverSet::type:="intOverSet":