// $Date: 2002/02/27 12:43:52 $ $Author: bij $ $Revision: 1.66 $

// property - Functionallity to compute Properties
//
// September 1997 - Juergen Billing



property:= newDomain("property"):
property::create_dom:=hold(property):
property::info:= "Library 'property': properties of identifiers":
property::Name:= "property":
property::type:= "property":
        
property::interface:=
        {
         //hold(is),
         //hold(unassume),
         //hold(getprop),
         //hold(assume),
         hold(implies),
         hold(hasprop),
         hold(simpex),
         hold(Null)
         //hold(delrule),
         //hold(getrule),
         //hold(setrule)
         //hold(loadrule),
         //hold(saverule)
         }:

property::exported:=
        {hold(assume),
         hold(getprop),
         hold(is),
         hold(unassume)}:
            
// Konvertierungs-Hierarchie
property::incl:= table(//"NRange" = {},
                       //"Rel"    = {"NRange"},
                       //"Residue" = {"NRange"},
                       //"NRange"  = {"Residue"},
                       "IV"      = {"NRange", "Rel"},
                       "Complex" = {"NRange"/*, "IV", "Rel"*/}):

// Konvertierung immer moeglich?
property::ord:=
        proc(NACH, VON)
          option remember;
        begin
          if contains(property::incl, NACH) then
            contains(property::incl[NACH], VON)
          else
            FALSE
          end_if
        end_proc:

// gemeinsame Obermenge
property::Sset:=
        proc(PX, PY)
          option remember;
          local Ss;
        begin
          if (Ss:= contains(map([map(op(property::incl), op, 2)],
                                (S, X, Y)->contains(S, X) and contains(S, Y),
                                PX, PY), TRUE)) > 0 then
            return(op(property::incl, [Ss, 1]))
          end_if;
          FAIL
        end_proc:

//property::aliases:= table():

property::ITABLE:= table(): // table for properties of indexed identifiers

property::RTABLE:= table(): // table for relations between identifiers


// 0 = low
// 1 = normal
// 2 = high
property::EVALLEVEL:= 2:

// maximale Laenge eines eingegebenen Ausdrucks (is)
property::MAXLENGTH:= 777:

alias(path = pathname("PROP")):
// Domain
property::NRange := loadproc(property::NRange , path, "NRange" ):
// noch nicht im CVS!
//property::Real   := loadproc(property::Real   , path, "Real"   ):
property::Rel    := loadproc(property::Rel    , path, "Rel"    ):
property::IV     := loadproc(property::IV     , path, "IV"     ):
property::IVnat  := loadproc(property::IVnat  , path, "IVnat"  ):
property::Complex:= loadproc(property::Complex, path, "PComp"  ):
property::Prule  := loadproc(property::Prule  , path, "Prule"  ):
property::Residue:= loadproc(property::Residue, path, "Residue"):
// Funktion
property::assume    := loadproc(property::assume    , path, "Propset" ):
property::sysprop   := loadproc(property::sysprop   , path, "Propsys" ):
property::getprop   := loadproc(property::getprop   , path, "Propget" ):
property::sysgetprop:= loadproc(property::sysgetprop, path, "Propsys" ):
property::_getprop  := loadproc(property::_getprop  , path, "Propget" ):
property::hasprop   := loadproc(property::hasprop   , path, "hasprop" ):
property::unassume  := loadproc(property::unassume  , path, "Propdel" ):
// noch nicht im CVS!
//property::_delrel   := loadproc(property::_delrel   , path, "Propdel" ):
property::is        := loadproc(property::is        , path, "Propis"  ):
property::_is       := loadproc(property::_is       , path, "Propis"  ):
property::isrel     := loadproc(property::isrel     , path, "Proprel" ):
property::isxRel    := loadproc(property::isxRel    , path, "Proprel" ):
// noch nicht im CVS!
//property::searchrel := loadproc(property::searchrel , path, "Propsrel"):
property::Factor    := loadproc(property::Factor    , path, "Proprel" ):
property::implies   := loadproc(property::implies   , path, "Propis"  ):
property::propend   := loadproc(property::propend   , path, "Propis"  ):
property::sysimplies:= loadproc(property::sysimplies, path, "Propsys" ):
property::sysis     := loadproc(property::sysis     , path, "Propsys" ):
property::Ex2Px     := loadproc(property::Ex2Px     , path, "Psimp"   ):
property::simpex    := loadproc(property::simpex    , path, "Propisr" ):
property::complexity:= loadproc(property::complexity, path, "Propisr" ):
property::normalize := loadproc(property::normalize , path, "Propisr" ):
property::setrule   := loadproc(property::setrule   , path, "Proprule"):
property::_setrule  := loadproc(property::_setrule  , path, "Proprule"):
property::getrule   := loadproc(property::getrule   , path, "Proprule"):
property::_getrule  := loadproc(property::_getrule  , path, "Proprule"):
property::_getfunc  := loadproc(property::_getfunc  , path, "Proprule"):
property::delrule   := loadproc(property::delrule   , path, "Proprule"):
property::saverule  := loadproc(property::saverule  , path, "Proprule"):
property::loadrule  := loadproc(property::loadrule  , path, "Proprule"):
property::autoload  := loadproc(property::autoload  , path, "Proprule"):
property::_Op       := loadproc(property::_Op       , path, "Propeval"):
property::convert_to:= loadproc(property::convert_to, path, "Propconv"):
property::carefloat := loadproc(property::carefloat , path, "Propconv"):
property::_convert  := loadproc(property::_convert  , path, "Propconv"):
// for simpex
property::prop2set  := loadproc(property::prop2set  , path, "Propconv"):
property::convertSets:= loadproc(property::convertSets, path, "Propconv"):
property::checkOp   := loadproc(property::checkOp   , path, "Propconv"):
//property::expr      := loadproc(property::expr      , path, "Propeval"):
property::lzeval    := loadproc(property::lzeval    , path, "Propeval"):
//property::mapr      := loadproc(property::mapr      , path, "Propeval"):
//property::mapp      := loadproc(property::mapp      , path, "Propeval"):
property::path      := loadproc(property::path      , path, "Propetc" ):
property::divis     := loadproc(property::divis     , path, "Propetc" ):
property::constant  := loadproc(property::constant  , path, "Propetc" ):
property::isconstant:= loadproc(property::isconstant, path, "Propetc" ):

DOM_INT::NRange     := loadproc(DOM_INT::NRange     , path, "DOM_INT" ):
DOM_IDENT::NRange   := loadproc(DOM_IDENT::NRange   , path, "DOM_ID"  ):
DOM_RAT::NRange     := loadproc(DOM_RAT::NRange     , path, "DOM_RAT" ):
DOM_FLOAT::NRange   := loadproc(DOM_FLOAT::NRange   , path, "DOM_FLO" ):
DOM_COMPLEX::NRange := loadproc(DOM_COMPLEX::NRange , path, "DOM_COM" ):
infinity:
stdlib::Infinity::NRange := loadproc(stdlib::Infinity::NRange , path, "infi"):
DOM_INTERVAL::NRange:= loadproc(DOM_INTERVAL::NRange, path, "DOM_IV"  ):
DOM_EXPR::NRange    := loadproc(DOM_EXPR::NRange    , path, "DOM_EXPR"):

DOM_INT::Rel        := loadproc(DOM_INT::Rel        , path, "DOM_INT" ):
DOM_IDENT::Rel      := loadproc(DOM_IDENT::Rel      , path, "DOM_ID"  ):
DOM_RAT::Rel        := loadproc(DOM_RAT::Rel        , path, "DOM_RAT" ):
DOM_FLOAT::Rel      := loadproc(DOM_FLOAT::Rel      , path, "DOM_FLO" ):
DOM_COMPLEX::Rel    := loadproc(DOM_COMPLEX::Rel    , path, "DOM_COM" ):
stdlib::Infinity::Rel := loadproc(stdlib::Infinity::Rel , path, "infi"):
DOM_INTERVAL::Rel   := loadproc(DOM_INTERVAL::Rel   , path, "DOM_IV"  ):
DOM_EXPR::Rel       := loadproc(DOM_EXPR::Rel       , path, "DOM_EXPR"):

DOM_INT::IV         := loadproc(DOM_INT::IV         , path, "DOM_INT" ):
DOM_IDENT::IV       := loadproc(DOM_IDENT::IV       , path, "DOM_ID"  ):
DOM_RAT::IV         := loadproc(DOM_RAT::IV         , path, "DOM_RAT" ):
DOM_FLOAT::IV       := loadproc(DOM_FLOAT::IV       , path, "DOM_FLO" ):
stdlib::Infinity::IV:= loadproc(stdlib::Infinity::IV, path, "infi"    ):
DOM_INTERVAL::IV    := loadproc(DOM_INTERVAL::IV    , path, "DOM_IV"  ):
DOM_EXPR::IV        := loadproc(DOM_EXPR::IV        , path, "DOM_EXPR"):

DOM_INT::Residue    := loadproc(DOM_INT::Residue    , path, "DOM_INT" ):
DOM_IDENT::Residue  := loadproc(DOM_IDENT::Residue  , path, "DOM_ID"  ):
DOM_RAT::Residue    := loadproc(DOM_RAT::Residue    , path, "DOM_RAT" ):
DOM_COMPLEX::Residue:= loadproc(DOM_COMPLEX::Residue, path, "DOM_COM" ):

DOM_INT::Complex    := loadproc(DOM_INT::Complex    , path, "DOM_INT" ):
DOM_IDENT::Complex  := loadproc(DOM_IDENT::Complex  , path, "DOM_ID"  ):
DOM_RAT::Complex    := loadproc(DOM_RAT::Complex    , path, "DOM_RAT" ):
DOM_FLOAT::Complex  := loadproc(DOM_FLOAT::Complex  , path, "DOM_FLO" ):
DOM_COMPLEX::Complex:= loadproc(DOM_COMPLEX::Complex, path, "DOM_COM" ):
stdlib::Infinity::Complex := loadproc(stdlib::Infinity::Complex , path, "infi"):
DOM_INTERVAL::Complex:= loadproc(DOM_INTERVAL::Complex, path, "DOM_IV"):
DOM_EXPR::Complex   := loadproc(DOM_EXPR::Complex   , path, "DOM_EXPR"):

unalias(path):

// leere Eigenschaft
property::Null:= 
        new(property, "Null"):
// erzeugt die leere Eigenschaft analog 'null'
property::null:= () -> property::Null:

// Operationen, die nicht definiert sind - /0
property::Undefined:= 
        new(property, "Undefined"):

// Symbol fur bestimmte Ausgaben
property::Z:= "is ":

property::_and:=
        proc()
        begin
          if has([args()], property::Null) then
            property::Null
          else
            hold(_and)(args())
          end_if
        end_proc:

property::_or:=
        proc()
          local ARGS;
        begin
          if has((ARGS:= {args()}), property::Null) then
            if nops(ARGS) > 1 then
              _or(select(args(), X -> bool(X <> property::Null)))
            else
              op(ARGS)
            end_if
          else
            hold(_or)(op(args()))
          end_if
        end_proc:

property::_not:=
        proc(PROP)
        begin
          if PROP = property::Null then
            Type::Complex
          else
            hold(_not)(PROP)
          end_if
        end_proc:

// fur Undefined, Unknown etc.
property::print:=
        proc()
        begin
          hold(slot)(property, op(args()))
        end_proc:

// Eigenschaft unbekannt
property::Unknown:=
        new(property, "Unknown"):

property::Fail:=
        proc()
        begin
          _lazy_or(contains([property::Undefined, property::Unknown,
                               property::Null, FAIL, undefined],
                              args(i)) <> 0 $ i = 1..args(0))
        end_proc:

// Beschrankung der Evaluierungstiefe
//property::RECLEVEL:= 0:
//property::MAXREC:= 50:
property::RESET:= 0:
// Fehler in 'assume' und 'is' NICHT abfangen!
property::NoErrors:= FALSE:

// Berucksichtigung eigener Regeln
property::OWNRULES:= FALSE:
property::RULECNT:= 0:

property::error:=
        proc(R)
        begin
          if args(0) = 0 then
            property::error(not property::NoErrors);
            property::NoErrors
          elif contains({TRUE, FALSE}, R) then
            sysassign(property::NoErrors, R);
            if R then
              warning("Don't forget to call 'property::reset()' after any error!")
            end_if
          else
            error("'TRUE' or 'FALSE' expected")
          end_if
        end_proc:

// numeric constants as properties
property::Numeric:=
  proc(prop)
  begin
    if contains(prop::dom, "Numeric") and prop::dom <> property then
      prop::dom::Numeric(prop)
    else
      FALSE
    end_if
  end_proc:

// alle properties gultig?
property::depends:=
  proc(EXPR = 0)
    local IND;
  begin
    IND:=
      proc(ind, nr = {})
        local nind;
      begin
        if (nind:= indets(map(ind, X -> op(properties(X), 2))) minus nr) <> {} then
          ind union IND(nind, ind union nr)
        else
          ind
        end_if
      end_proc;
    table(op(map(IND(indets(EXPR)), X -> X = op(properties(X), 2))),
          op(property::ITABLE), // indexed identifiers
          hold(Global) = op(properties(hold(Global)), 2),
          hold(Rule) = property::RULECNT)
  end_proc:

// remember
// property::_Op         kein reset
// property::_convert    kein reset
// property::_getprop
// property::_is
// property::implies
// property::isrel

property::reset:=
        proc(R = hold(Clear)) // default: clear all remember tables
        begin
          if args(0) = 0 then
            sysassign(property::RESET, 0);
          end_if;
          if domtype(R) = DOM_INT then
            sysassign(property::RESET, property::RESET + R)
          else
            if contains([hold(Clear), hold(ClearPrevent)], R) = 0 then
              error("option 'Clear' or 'ClearPrevent' expected")
            end_if;
            //!! property::_Op(hold(Remember), OPT);
            //!! property::_convert(hold(Remember), OPT);
            property::_getprop(hold(Remember), R);
            property::_is(hold(Remember), R);
            property::implies(hold(Remember), R);
            property::isrel(hold(Remember), R);
            sysassign(property::RESET, 0)
          end_if;
          null()
        end_proc:

stdlib::LoadlibState["property"]:= TRUE:

