// $Date: 2001/11/12 15:57:23 $ $Author: bij $ $Revision: 1.3 $

// < FUNCS, < ATOMS, < VALUES >>>
// FUNCS  - list of functions VALUES -> VALUES or expressions in ATOMS
// ATOMS  - list of MuPAD objects
// VALUES - list of VALUES or equations 'SYMBOL = VALUE'

logic::truthTable:=
  proc(FUNCS, ATOMS = FAIL, VALUES = [0 = FALSE, 1 = TRUE])
    local i, k, shuffle, Table, ARGS, NOPS, OVALUES;
  begin
    shuffle:=
      proc(LIST)
        name truthTable::shuffle;
        local i, UE;
      begin
fprint(">>shuffle", LIST);
        UE:= 1;
        for i from nops(LIST) downto 1 do
          LIST:= subsop(LIST, i = op(LIST, i) + UE);
          if op(LIST, i) >= nops(VALUES) then
            LIST:= subsop(LIST, i = 0);
            UE:= 1
          elif op(LIST, i) <> 0 then
            UE:= 0
          end_if
        end_for;
fprint("<<shuffle", LIST);
        LIST
      end_proc:

    // Argument-Aufbereitung
    if type(FUNCS) <> DOM_LIST and type(FUNCS) <> DOM_SET then
      if contains([DOM_EXPR, DOM_PROC, DOM_FUNC_ENV], domtype(FUNCS)) <> 0 then
        FUNCS:= [FUNCS]
      else
        error("the first argument must be an expression or a procedure")
      end_if
    end_if;

    if type(ATOMS) <> DOM_LIST and type(ATOMS) <> DOM_SET then
      if type(ATOMS) = DOM_IDENT then
        ATOMS:= [ATOMS]
      elif ATOMS = FAIL
           and indets(FUNCS) <> {} then
        ATOMS:= sort([op(indets(FUNCS))])
      else
        error("the second argument must be a list of identifiers")
      end_if
    elif {op(map(ATOMS, testtype, Type::Constant))} = {TRUE} and args(0) < 3 then // 3rd argument
      if indets(FUNCS) <> {} then
        VALUES:= ATOMS;
        ATOMS:= sort([op(indets(FUNCS))])
      else
        error("the second argument must be a list of identifiers")
      end_if
    end_if;
    // Ende Argument-Aufbereitung
    
    NOPS:= nops(ATOMS); //

    ARGS:= [0 $ NOPS];
    
    // VALUES should be a table VALUES[print_version] == call_version
    if type(op(VALUES, 1)) = "_equal" then
      OVALUES:= table(op(map(VALUES, X -> op(X, 2) = op(X, 1))));
      VALUES:= map(VALUES, op, 2)
    else
      OVALUES:= table(k = k $ k in VALUES)
    end_if;

    if testargs() then
      for k from 1 to nops(FUNCS) do
        Table:= {};
        for i from 1 to nops(VALUES)^NOPS do
          if domtype(op(FUNCS, k)) = DOM_EXPR then
            Table:= Table union {eval(subs(op(FUNCS, k),
                                           op(ATOMS, X) = op(VALUES, op(ARGS, X) + 1)
                                           $ X = 1..NOPS))}
          else
            Table:= Table union {op(FUNCS, k)(op(map(ARGS, X->op(VALUES, X + 1))))}
          end_if
        end_for;
        if Table union {op(VALUES)} <> {op(VALUES)} then
          error("value set of '".expr2text(op(FUNCS, k))."' dosn't in ".expr2text({op(VALUES)}))
        end_if
      end_for;
      ARGS:= [0 $ NOPS]
    end_if;

    Table:= array(1..(nops(VALUES)^NOPS + 1), 1..(nops(ATOMS) + nops(FUNCS)),
                  (1, i) = op([op(ATOMS), op(map(FUNCS, prog::getname))], i)
                  $ i = 1..(NOPS + nops(FUNCS)));

    for i from 1 to nops(VALUES)^NOPS do
      for k from 1 to NOPS do
        Table[i + 1, k]:= OVALUES[op(VALUES, 1 + op(ARGS, k))]
      end_for;
      for k from 1 to nops(FUNCS) do
        if domtype(op(FUNCS, k)) = DOM_EXPR then
          Table[i + 1, NOPS + k]:= OVALUES[eval(subs(op(FUNCS, k),
                                                     op(ATOMS, X) = op(VALUES, op(ARGS, X) + 1)
                                                     $ X = 1..NOPS))]
        else
          Table[i + 1, NOPS + k]:= OVALUES[op(FUNCS, k)(op(map(ARGS, X->op(VALUES, X + 1))))]
        end_if
      end_for;
      ARGS:= shuffle(ARGS)
    end_for;
    Table
  end_proc:

