
alias(ERROR_DURING_EVAL =
      "Error during evaluation of f(x) [numeric::evalf]"):
      
      
numeric::evalf := proc(f, x)
    local eps, epsabsx, t, y;
 begin
    t := traperror((y:=float(f(x))));
    if t <> 0 then
       return(ERROR_DURING_EVAL)
    end_if;
    if domtype(y) <> DOM_COMPLEX then
       return(y)
    end_if;
    // Note: If you change this function then
    //       you have to change the kernel
    //        procedure MGR_is_real also!
    eps := 10.0^(-DIGITS);
    // Do not round like numeric::complexRound
    // Just use eps.
    // epsabsx := eps * specfunc::abs(y);
    epsabsx := eps;
    if specfunc::abs(op(y,2)) < epsabsx then
       return(op(y,1))
    end_if;
    return(y)
end_proc:

