    //------------------------------------------------------------
    //                                   b                        
    //                         a^b  ->  a                         
    //------------------------------------------------------------
_power::Content := 
proc(Out, data) 
  local root, Exponent, exponent, base, factors, Sign, res;
begin
  /* first we split the power into base^(Sign*(exponent/root)) */
  base := op(data, 1);
  root := 1;
  Exponent := op(data, 2);
  Sign := 1;

  if domtype(Exponent) = DOM_RAT then
    root := op(Exponent, 2);   
    exponent := op(Exponent, 1); 
  elif type(Exponent) = "_mult" then
    factors := Out::splitProduct(Exponent);
    if op(factors, 1) = -1 then
      Sign := -1
    end_if;
    if nops(op(factors, 2)) = 1 then
      exponent := op(op(factors, 2));
    else
      exponent := hold(_mult)(op(op(factors, 2)));
    end_if;
    if nops(op(factors, 3)) = 0 then
      root := 1;
    elif nops(op(factors, 3)) = 1 then
      root := op(op(factors, 3));
    else
      root := hold(_mult)(op(op(factors, 3)));
    end_if;
  elif type(Exponent) = "_power" then
    if op(Exponent, 2) = -1 then
      root := op(Exponent, 1);
      exponent := 1;
    else
      root := 1;
      exponent := Exponent;
    end_if;
  elif type(Exponent) = "_divide" then
    exponent := op(Exponent, 1);
    if generate::isNeg(exponent) then
      Sign := -1;
      exponent := -exponent;
    end:
    root := op(Exponent, 2);
  elif type(Exponent) = "_invert" then
    root := op(Exponent);
    exponent := 1;
  elif type(Exponent) = "_negate" then
    root := 1;
    exponent := op(Exponent);
    Sign := -1;
  elif type(Exponent) = DOM_INT and Exponent < 0 and
    not testtype(base, Type::Real) and not type(base)="matrix"
    and not domtype(base) = matrix then
    root := 1;
    exponent := -Exponent;
    Sign := -1;
  else
    root := 1;   
    exponent := Exponent; 
  end_if;

  if exponent = 1 and
    (testtype(root, Type::NonNegInt) or domtype(root) = DOM_IDENT) then
    if root = 1 then
      res := Out(base);
    elif root = 2 then
      res := Out::Csqrt(Out(base));
    else
      res := Out::Croot(Out(base), Out::Cdegree(Out(root)));
    end_if;
  else
    if root <> 1 then
    // output with frational exponent
      exponent := hold(_divide)(exponent, root);
    end_if;
    if exponent <> 1 then
      res := Out::Capply(Out::Cpower, Out(base), Out(exponent)):
    else
      res := Out(base):
    end_if;
  end_if;

  if Sign = -1 then
    Out::Cdivide(Out(1),res)
  else
    res
  end_if;
end_proc:

_power::Presentation :=
proc(Out, data)
begin
  if generate::isNeg(op(data, 2)) then
    if op(data, 2) = -1 then

/* ist Quatsch, sollte aber entsprechend laufen */
        Out::Cdivide(1,Out(op(data,1)))
    else
        Out(hold(_mult)(1, data));
    end_if;
  else
    Out::msup(
              Out::parenthesisOut(
                                  output::Priority::Power,
                                  [op(data,1)]),
              Out(op(data,2)))
  end_if;
end_proc:
    
