// $Date: 2002/02/20 12:38:32 $ $Author: bij $ $Revision: 1.6 $

//
// This file contains informations about changes
// between MuPAD 1.4.2 - 2.0, 2.0 - 2.5
//
// new objects
// 

///////////////////////////////////////////////////////////////////////////////////////////////////
//// Changes 2.0 -> 2.5 ///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////

slot(prog::Changes, "newKeywords2.5"):=
  ["==>", "<=>", "frame", "save", "xor"]:

slot(prog::Changes, "newLibs2.5"):=
  []:

slot(prog::Changes, "newFunctions2.5"):=
  table(
        hold(System)   = [hold(_save), hold(assert), hold(card), hold(copyClosure),
                          hold(DOM_INTERVAL), hold(FILEPATH), hold(fname),
                          hold(frandom), hold(hull), hold(hypergeom),
                          hold(interval), hold(PACKAGEPATH)],
        hold(Ax)       = [hold(indetElements)],
        hold(Dom)      = [hold(SparseMatrix), hold(DomFloatIV)],
        hold(Type)     = [hold(Indeterminante), hold(Set)],
        hold(groebner) = [hold(stronglyIndependentSet)],
        hold(linalg)   = [hold(laplacian)],
        hold(numeric)  = [hold(cubicSpline2d), hold(leastSquares),
                          hold(odesolveGeometric), hold(ode2vectorfield)],
        hold(plot)     = [hold(bars), hold(piechart2d), hold(piechart3d),
                          hold(surface)],
        hold(prog)     = [hold(tcov)],
        hold(stats)    = [hold(betaCDF), hold(betaPDF), hold(betaQuantile),
                          hold(betaRandom), hold(binomialCDF), hold(binomialPF),
                          hold(binomialQuantile), hold(binomialRandom),
                          hold(cauchyCDF), hold(cauchyPDF), hold(cauchyQuantile),
                          hold(cauchyRandom), hold(chisquareCDF), hold(chisquarePDF),
                          hold(chisquareQuantile), hold(chisquareRandom),
                          hold(covariance), hold(csGOFT), hold(empiricalCDF),
                          hold(equiprobableCells), hold(erlangCDF), hold(erlangPDF),
                          hold(erlangQuantile), hold(erlangRandom),
                          hold(exponentialCDF), hold(exponentialPDF),
                          hold(exponentialQuantile), hold(exponentialRandom),
                          hold(fCDF), hold(fPDF), hold(fQuantile), hold(fRandom),
                          hold(gammaCDF), hold(gammaPDF), hold(gammaQuantile),
                          hold(gammaRandom), hold(geometricCDF), hold(geometricPF),
                          hold(geometricQuantile), hold(geometricRandom),
                          hold(hypergeometricCDF), hold(hypergeometricPF),
                          hold(hypergeometricRandom), hold(ksGOFT), hold(logisticCDF),
                          hold(logisticPDF), hold(logisticQuantile),
                          hold(logisticRandom), hold(meandev), hold(moment),
                          hold(normalPDF), hold(normalQuantile), hold(normalRandom),
                          hold(poissonCDF), hold(poissonPF), hold(poissonQuantile),
                          hold(poissonRandom), hold(swGOFT), hold(tPDF),
                          hold(tQuantile), hold(tRandom), hold(uniformCDF),
                          hold(uniformPDF), hold(uniformQuantile), hold(uniformRandom),
                          hold(weibullCDF), hold(weibullPDF), hold(weibullQuantile),
                          hold(weibullRandom)]
        ):

///////////////////////////////////////////////////////////////////////////////////////////////////
//// Changes 1.4.2 -> 2.0  ////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////

slot(prog::Changes, "newKeywords2.0"):=
  ["domain", "save", "delete"]:

slot(prog::Changes, "newLibs2.0"):=
  [hold(matchlib), hold(adt), hold(polylib), hold(prog), hold(output),
   hold(solvelib), hold(detools), hold(intlib), hold(listlib)]:

slot(prog::Changes, "newFunctions2.0"):=
  table(
        hold(System)   = [hold(lhs), hold(rhs), hold(package), hold(piecewise),
                          hold(newDomain), hold(matrix), hold(coerce),
                          hold(operator), hold(ground), hold(lasterror),
                          hold(unexport), hold(int2text), hold(unfreeze),
                          hold(external), hold(Factored), hold(universe),
                          hold(share), hold(slot), hold(clientCall), 
                          hold(clientObject), hold(ClientObject),
                          hold(outputFormat), hold(outputType),
                          hold(rdabs), hold(rddivide), hold(rdfloat2text),
                          hold(rdgetsign), hold(rdint2float), hold(rdisfinite),
//                        hold(interpolate),  // fuer 2.0 -> 2.1
                          hold(rdmult), hold(rdnegate), hold(rdplus),
                          hold(rdround), hold(rdsubtract), hold(rdtext2float)],
        hold(adt)      = [hold(Tree), hold(Stack), hold(Queue)],
        hold(Cat)      = [hold(Set)],
        hold(Dom)      = [hold(ImageSet), hold(MonomOrdering), hold(SparseMatrixF2), hold(SubSet)],
        hold(domains)  = [hold(grouporder)],
        hold(linalg)   = [hold(minpoly), hold(pseudoInverse), hold(inverseLU),
                          hold(factorLU), hold(hessenberg), hold(wiedemann), hold(frobeniusForm),
                          hold(hilbert), hold(invhilbert), hold(vandermondeSolve),
                          hold(companion), hold(permanent), hold(substitute), hold(smithForm)],
        hold(matchlib) = [hold(match), hold(analyze)],
        hold(numeric)  = [
                          hold(complexRound),
                          hold(cubicSpline), 
                          hold(expMatrix),
                          hold(fMatrix),
                          hold(fsolve),
                          hold(indets),
                          hold(int),
                          hold(lagrange), // verschwindet fuer 2.1 wieder -> (stdlib) interpolate
                          hold(linsolve),
                          hold(matlinsolve),
                          hold(odesolve2),
                          hold(odesolveGeometric),
                          hold(polyroots),
                          hold(polysysroots),
                          hold(rationalize),
                          hold(realroot),
                          hold(realroots),
                          hold(solve),
                          hold(sort),
                          hold(spectralradius)
                         ],
        hold(output)   = [hold(tree)],
        hold(plotlib)  = [hold(inequalityplot)],
        hold(plotlib)  = [hold(ode)],
        hold(polylib)  = [hold(realroots)],
        hold(prog)     = [hold(check), hold(getname), hold(remember), hold(calltree),
                          hold(exprtree), hold(init), hold(traced), hold(find)],
        hold(property) = [hold(hasprop)],
        hold(specfunc) = [hold(arg), hold(log), hold(lambertV),
                          hold(lambertW), hold(polylog), hold(BesselI),
                          hold(BesselK), hold(Ci), hold(signIm)],
        hold(stats)    = [hold(BPCorr), hold(FCorr), hold(Tdist), hold(a_quantil), hold(calc),
                          hold(col), hold(concatCol), hold(concatRow), hold(geometric),
                          hold(harmonic), hold(kurtosis), hold(linReg), hold(mean),
                          hold(meanTest), hold(median), hold(modal), hold(normal),
                          hold(obliquity), hold(quadratic), hold(reg), hold(row),
                          hold(sample), hold(sample2list), hold(selectRow), hold(sortSample),
                          hold(stdev), hold(tabulate), hold(unzipCol), hold(variance), hold(zipCol)],
        hold(student)  = [hold(simpson), hold(trapezoid), hold(riemann)]
        ):

