
////////////////////////////////////////////////////////////////////////////////
// Interface: setcheckglobals
////////////////////////////////////////////////////////////////////////////////

// MSG : DOM_STRING - warning "MSG"" is not displayed by 'prog::check'
// MSG = hold(All)  - file "PROG/checkDisableMessages.txt" is red line by line
//                    and each line must contain a message without quotes
//                    message is quoted and this procedure called with each message
// OPT = quiet      - no warning message is printed, if the requested file cannot be opened
prog::checkDisableMessage:=
  proc(MSG = "", OPT = FAIL)
    local file, k, p;
  begin
    if MSG = hold(All) then
      for p in LIBPATH do
        if (file:= fopen(p.pathname("PROG")."checkDisableMessages.txt")) <> FAIL then // open message file
          while (k:= ftextinput(file)) <> null() do
            while k <> "" and (k[0] = " " or k[0] = "\t") do
              k:= substring(k, 1..length(k)-1)
            end_while;
            while k <> "" and (k[length(k)-1] = " " or k[length(k)-1] = "\t") do
              k:= substring(k, 0..length(k)-2)
            end_while;
            if k <> "" and k[0] <> "#" and (length(k) > 1 and substring(k, 0..1) <> "//") then
              prog::checkDisableMessage(k)
            end_if
          end_while;
          fclose(file)
        elif OPT <> hold(Quiet) then
          fprint(Unquoted, 0, "Info: cannot find '".
                              p.pathname("PROG")."checkDisableMessages.txt' [prog::check]")
        end_if
      end_for
    else
      sysassign(prog::NMSG, prog::NMSG union {MSG})
    end_if
  end_proc:

prog::setcheckglobals:=
  proc(FUN = null(), GLOBAL = null())
    //option hold;
  begin
    if FUN = null() then
      prog::getcheckglobals()
    elif GLOBAL = null() then
      prog::getcheckglobals(FUN)
    else
      userinfo(Text, 6..9, "set global for ".prog::getname(FUN).": ".expr2text(GLOBAL));
      userinfo(Text, 14, "set global for ".prog::getname(FUN).": ".expr2text(GLOBAL));
      sysassign(prog::globalIdents,
		table(op(prog::globalIdents), prog::getname(FUN) = context(GLOBAL)));
      null()
    end_if
  end_proc:

prog::getcheckglobals:=
  proc(FUN = null())
    //option hold;
    local i;
  begin
    if FUN = null() then
      if nops(prog::PATH) > 0 then 
	_union(prog::getcheckglobals(op(prog::PATH, i))
	       $ i=1..nops(prog::PATH),
	       prog::getcheckglobals(hold(All)))
      else
	{}
      end_if
    else
      if contains(prog::globalIdents, prog::getname(FUN)) then
	prog::globalIdents[prog::getname(FUN)]
      else
        {}
      end_if
    end_if
  end_proc:
