// $Date: 2002/02/23 22:07:49 $ $Author: bij $ $Revision: 1.54 $

//
// IVnat  - Domain of basic calculus for property 'Intervall'
//

alias(IV = property::IVnat):
//alias(Rel = property::Rel):
alias(Le(x) = op(extop(x, 1), 1)):
alias(FLe(x) = float(op(extop(x, 1), 1))):
alias(LE = [1, 1]):
alias(Ri(x) = op(extop(x, 1), 3)):
alias(FRi(x) = float(op(extop(x, 1), 3))):
alias(RI = [1, 3]):
alias(LeO(x) = op(extop(x, 1), 2)):
alias(LEO = [1, 2]):
alias(RiO(x) = op(extop(x, 1), 4)):
alias(RIO = [1, 4]):
alias(FLOAT(x) = op(extop(x, 1), 5)):
alias(ISFLOAT(x, y) = bool((contains([DOM_INT, DOM_RAT, DOM_FLOAT], domtype(float(x))) > 0 or
                            domtype(x) = stdlib::Infinity)
                           and (contains([DOM_INT, DOM_RAT, DOM_FLOAT], domtype(float(y))) > 0
                                or domtype(y) = stdlib::Infinity))):

IV:= newDomain("property::IVnat"):
IV::create_dom:=hold(property::IVnat):
IV::info:= "Domain of basic calculus for property::IV":
IV::domtype:= ()->Type:
IV::type:= "IVnat":
IV::prop:= TRUE:
//IV::propdom:= slot(property, "IV"):

IV::noTrace:= {hold(print), hold(testtype), hold(domtype)}:

IV::new:=
  proc(l, r)
  begin
    case args(0)
      of 0 do
        return(new(IV, [-infinity, 0, infinity, 0, TRUE]))
      of 1 do
        if domtype(l) <> DOM_LIST then
          error("wrong type of args")
        elif nops(l) <> 2 then
          error("wrong number of args")
        else
          return(IV::_Check(op(l, 1), 1, op(l, 2), 1))
        end_if
      of 2 do
      of 3 do
        return(IV::_Check(_if(domtype(l) = DOM_LIST, (op(l), 1), (l, 0)),
                          _if(domtype(r) = DOM_LIST, (op(r), 1), (r, 0))))
      otherwise
        error("wrong number of args")
    end_case
  end_proc:

IV::_new:=
  proc(l, lo, r, ro, FL)
  begin
    new(IV, [l, lo, r, ro, FL])
  end_proc:

IV::_Check:=
  proc(l, lo, r, ro, FL = UNKNOWN)
  begin
    if FL = UNKNOWN then
      FL:= ISFLOAT(l, r)
    end_if;
    if type(l) = stdlib::Infinity then lo:= 0 end_if;
    if type(r) = stdlib::Infinity then ro:= 0 end_if;
    if FL = TRUE then
      if not op([_less, _leequal], lo*ro + 1)(float(l), float(r)) then
        return(property::Null)
      end_if
    else
      if property::_is(op([_less, _leequal], lo*ro + 1)(l, r)) = FALSE then
        return(property::Null)
      end_if
    end_if;
    if property::Fail(l) then return(l) end_if;
    if property::Fail(r) then return(r) end_if;
    new(IV, [l, lo, r, ro, FL])
  end_proc:

// Zugriff
IV::left:= iv->Le(iv):
IV::leftB:= iv->_if(LeO(iv) = 0, Le(iv), [Le(iv)]):
IV::right:= iv->Ri(iv):
IV::rightB:= //proc(iv) begin _if(RiO(iv) = 0, Ri(iv), [Ri(iv)]) end_proc:
  proc(iv)
  begin
    if op(extop(iv, 1), 4) = 0 then 
      op(extop(iv, 1), 3)
    else 
      [op(extop(iv, 1), 3)]
    end_if
  end_proc:

IV::lopen:= iv->bool(LeO(iv) = 0):
IV::_lopen:= iv->LeO(iv):
IV::ropen:= iv->bool(RiO(iv) = 0):
IV::_ropen:= iv->RiO(iv):
IV::isfloat:= iv->FLOAT(iv):

// TRUE if only one point
IV::isPoint:=
proc(iv)
begin
  if type(Le(iv))= stdlib::Infinity or type(Ri(iv))= stdlib::Infinity then
    FALSE
  else  
    bool(_and(bool(LeO(iv) = 1), bool(RiO(iv) = 1), is(Le(iv) = Ri(iv))))
  end_if
end_proc:

IV::subsleft:=
  proc(iv, b, o = FAIL)
  begin
    subsop(iv, LE = b, _if(o <> FAIL, LEO = o, null()))
  end_proc:

IV::subsright:=
  proc(iv, b, o = FAIL)
  begin
    subsop(iv, RI = b, _if(o <> FAIL, RIO = o, null()))
  end_proc:

IV::swap:=
  proc(iv)
  begin
    IV::_new(Ri(iv), RiO(iv), Le(iv), LeO(iv), FLOAT(iv))
  end_proc:

IV::_eval:=
  proc(iv)
    local l, r;
  begin
    l:= eval(Le(iv));
    r:= eval(Ri(iv));
    IV::_new(l, LeO(iv), r, RiO(iv), ISFLOAT(l, r))
  end_proc:

// b - a
IV::_length:=
  proc(iv)
  begin
    Ri(iv) - Le(iv)
  end_proc:

// IV::constant:=
//   proc(iv)
//   begin
//     testtype(Le(iv), Type::Constant) and testtype(Ri(iv), Type::Complex)
//   end_proc:

//"
// IV::is((a, b), (a', b'))
// TRUE, wenn a' < a und  b < b';   FALSE, wenn b < a' oder b' < a
//            [[ <=                            [[ <               
//            [( <=                            [( <=              
//            (( <=                            (( <=              
//            ([ <                             ([ <=              "
IV::is:=
  proc(iv1, iv2)
    local op1, op2, FL;
  begin
    if type(iv1) <> "IVnat" or type(iv2) <> "IVnat" then
      return(UNKNOWN)
    end_if;
//    if type(iv2) = "Rel" then // Konvertierung
//      iv2:= property::Rel::IVnat(iv2)
//    elif type(iv2) <> "IVnat" then
//      return(UNKNOWN)
//    end_if;

//fprint(0, "is", op1, op2);
    FL:= FLOAT(iv1) and FLOAT(iv2);

    op1:= op([_leequal, _less], 1 + min(LeO(iv1), 1 - LeO(iv2)));
    op2:= op([_leequal, _less], 1 + min(RiO(iv1), 1 - RiO(iv2)));

    // 1 in 2
    if FL then
      if op1(FLe(iv2), FLe(iv1)) and op2(FRi(iv1), FRi(iv2)) then
        return(TRUE)
      end_if
    else
      if property::isrel(op1(Le(iv2), Le(iv1))) = TRUE and
        property::isrel(op2(Ri(iv1), Ri(iv2))) = TRUE then
//fprint(0, "is2", op1(Le(iv2), Le(iv1)), op2(Ri(iv1), Ri(iv2)));
        return(TRUE)
      end_if
    end_if;

    op1:= op([_leequal, _less], 1 + LeO(iv1)*RiO(iv2));
    op2:= op([_leequal, _less], 1 + RiO(iv1)*LeO(iv2));

    // Schnitt leer
    if FL then
      if op1(FRi(iv2), FLe(iv1)) or op2(FRi(iv1), FLe(iv2)) then
        return(FALSE)
      end_if
    else
      if property::isrel(op1(Ri(iv2), Le(iv1))) = TRUE
        or property::isrel(op2(Ri(iv1), Le(iv2))) = TRUE then
//fprint(0, "is1", op1(Ri(iv2), Le(iv1)), op2(Ri(iv1), Le(iv2)));
        return(FALSE)
      end_if
    end_if;

    // only one point -- interval empty??
//     if IV::isPoint(iv1) then
//       return(_lazy_or(Le(iv1) = Le(iv2), Le(iv1) = Ri(iv2)) or UNKNOWN)
//     end_if;
    
    UNKNOWN
  end_proc:

IV::sign:=
  proc(iv)
  begin
    if FLOAT(iv) then
      if op([_leequal, _less], LeO(iv) + 1)(0, FLe(iv)) then
        {1}
      elif op([_leequal, _less], RiO(iv) + 1)(FRi(iv), 0) then
        {-1}
      elif IV::iszero(iv) then
        {0}
      elif LeO(iv) = 1 and _leequal(0, FLe(iv)) then
        {0, 1}
      elif RiO(iv) = 1 and _leequal(FRi(iv), 0) then
        {0, -1}
      elif op([_leequal, _less], 2 - LeO(iv))(FLe(iv), 0)
           and op([_leequal, _less], 2 - RiO(iv))(0, FRi(iv)) then
        {0, 1, -1}
      else
        {0, 1, -1}//hold(sign)(iv)
      end_if
    else
      if property::_is(op([_leequal, _less], LeO(iv) + 1)(0, Le(iv))) = TRUE then
        {1}
      elif property::_is(op([_leequal, _less], RiO(iv) + 1)(Ri(iv), 0)) = TRUE then
        {-1}
      elif IV::iszero(iv) then
        {0}
      elif LeO(iv) = 1 and property::_is(_leequal(0, Le(iv))) = TRUE then
        {0, 1}
      elif RiO(iv) = 1 and property::_is(_leequal(Ri(iv), 0)) = TRUE then
        {0, -1}
      elif property::_is(op([_leequal, _less], 2 - LeO(iv))(Le(iv), 0)) = TRUE
           and property::_is(op([_leequal, _less], 2 - RiO(iv))(0, Ri(iv))) = TRUE then
        {0, 1, -1}
      else
        {0, 1, -1}//hold(sign)(iv)
      end_if
    end_if
  end_proc:

IV::abs:=
  proc(iv)
    local i, l, r;
  begin
    if not contains((i:= IV::sign(iv)), -1) then
      iv
    elif i = {-1} then
      IV::_new(-Ri(iv), RiO(iv), -Le(iv), LeO(iv), FLOAT(iv))
    else //
      l:= -Le(iv);
      r:= Ri(iv);
      IV::_new(0, 1, (if property::_is(r > l) = TRUE then
                        r, RiO(iv)
                      elif property::_is(r = l) = TRUE then
                        r, max(LeO(iv), RiO(iv))
                      else
                        l, LeO(iv)
                      end_if),
               FLOAT(iv))
    end_if
  end_proc:

IV::iszero:=
  proc(iv)
  begin
    if LeO(iv) = 1 and RiO(iv) = 1
      then
       if FLOAT(iv) then
         if iszero(Le(iv)) and iszero(Ri(iv)) then
           TRUE
         end_if
       elif property::_is(Le(iv) = 0) = TRUE and property::_is(Ri(iv) = 0) = TRUE then
         TRUE
       end_if
    end_if;
    FALSE
  end_proc:

IV::_and:=
  proc()
    local i, t;
  begin
    // one argument is a union of intervals
    t:= [args()];
    if (i:= contains(map(t, type), "_or")) > 0 then
      return(IV::_or(IV::_and(op(subsop(t, i = null())), op(t, [i, k])) $ k = 1..nops(t)))
    end_if;
    property::_Op
     (IV, _and,
      proc(iv1, iv2)
        name property::IVnat::_and;
        local i;
      begin
        // Intervall: [a, b] intersect [c, d]
        if FLOAT(iv1) and FLOAT(iv2) then
          // leer: d < a  or  b < c
          if _if(RiO(iv2)*LeO(iv1) = 0, _leequal, _less)(FRi(iv2), FLe(iv1)) or
            _if(LeO(iv2)*RiO(iv1) = 0, _leequal, _less)(FRi(iv1), FLe(iv2)) then
            return(property::Null)
          end_if;
          // in a < c and b > d    or    c < a and d > b
          if (i:= contains([TRUE, FALSE], IV::is(iv1, iv2))) > 0 then
            return(op([iv1, iv2], i))
          elif (i:= contains([TRUE, FALSE], IV::is(iv2, iv1))) > 0 then
            return(op([iv2, iv1], i))
          end_if;
          // Schnitt: a < d   or   c < b
          if (FLe(iv2) < FRi(iv1) or FLe(iv2) <= FRi(iv1) and LeO(iv2) <= RiO(iv1))
             and FLe(iv1) <= FLe(iv2) then
            return(IV::_Check(Le(iv2), LeO(iv2), Ri(iv1), RiO(iv1)))
          elif (FLe(iv1) < FRi(iv2) or FLe(iv1) <= FRi(iv2) and LeO(iv1) >= RiO(iv2))
               and FLe(iv1) >= FLe(iv2) then
            return(IV::_Check(Le(iv1), LeO(iv1), Ri(iv2), RiO(iv2)))
          end_if;
        else // symbolic
          // leer: d < a  or  b < c
// fprint(0, "leer", hold(is)(_if(RiO(iv2)*LeO(iv1) = 0, _leequal, _less)(Ri(iv2), Le(iv1))),
//                   (is)(_if(RiO(iv2)*LeO(iv1) = 0, _leequal, _less)(Ri(iv2), Le(iv1))));
// fprint(0, "leer", hold(is)(_if(LeO(iv2)*RiO(iv1) = 0, _leequal, _less)(Ri(iv1), Le(iv2))),
//                   (is)(_if(LeO(iv2)*RiO(iv1) = 0, _leequal, _less)(Ri(iv1), Le(iv2))));
          if property::_is(_if(RiO(iv2)*LeO(iv1) = 0, _leequal, _less)(Ri(iv2), Le(iv1))) = TRUE or
             property::_is(_if(LeO(iv2)*RiO(iv1) = 0, _leequal, _less)(Ri(iv1), Le(iv2))) = TRUE then
            return(property::Null)
          end_if;
          // in a < c and b > d    or    c < a and d > b
          if (i:= contains([TRUE, FALSE], IV::is(iv1, iv2))) > 0 then
// fprint(0, "in1");
            return(op([iv1, iv2], i))
          elif (i:= contains([TRUE, FALSE], IV::is(iv2, iv1))) > 0 then
// fprint(0, "in2");
            return(op([iv2, iv1], i))
          end_if;
          // Schnitt: a < d   or   c < b
// fprint(0, "sch1", Le(iv2) <= Ri(iv1), LeO(iv2) <= RiO(iv1), Le(iv1) < Le(iv2));
// fprint(0, "sch2", Le(iv1) <= Ri(iv2), LeO(iv1) <= RiO(iv2), Le(iv2) < Le(iv1));
          if (property::_is(Le(iv2) < Ri(iv1)) = TRUE
              or property::_is(Le(iv2) <= Ri(iv1)) = TRUE and LeO(iv2) <= RiO(iv1))
             and property::_is(Le(iv1) < Le(iv2)) = TRUE then
// fprint(0, "sch1");
// fprint(0, Le(iv2) < Ri(iv1), LeO(iv2) <= RiO(iv1), Le(iv1) <= Le(iv2));
            return(IV::_Check(Le(iv2), LeO(iv2), Ri(iv1), RiO(iv1)))
          elif (property::_is(Le(iv1) < Ri(iv2)) = TRUE
                or property::_is(Le(iv1) <= Ri(iv2)) = TRUE and LeO(iv1) <= RiO(iv2))
               and property::_is(Le(iv1) > Le(iv2)) = TRUE then
// fprint(0, "sch2");
            return(IV::_Check(Le(iv1), LeO(iv1), Ri(iv2), RiO(iv2)))
          end_if
        end_if;
        // Spezialfall ein-Punkt-Berhrung (fr Bezeichner ohne Eigenschaft)
        // ??
        
        // special case possibly empty interval
        // 'isrel' with real mode (argument 'TRUE')
        if (i:= property::isrel(Le(iv1) < Le(iv2), TRUE)) <> UNKNOWN then
          if i then // a < c
            if (i:= property::isrel(Ri(iv1) < Ri(iv2), TRUE)) <> UNKNOWN then
              if i then // b < d
                return(IV::_Check(Le(iv2), LeO(iv2), Ri(iv1), RiO(iv1)))
              else // b > d
                return(IV::_Check(Le(iv2), LeO(iv2), Ri(iv2), RiO(iv2)))
              end_if
            end_if
          else // a > c
            if (i:= property::isrel(Ri(iv1) < Ri(iv2), TRUE)) <> UNKNOWN then
              if i then // b < d
                return(IV::_Check(Le(iv1), LeO(iv1), Ri(iv1), RiO(iv1)))
              else // b > d
                return(IV::_Check(Le(iv1), LeO(iv1), Ri(iv2), RiO(iv2)))
              end_if
            end_if
          end_if
        end_if;
        hold(_and)(iv1, iv2)
      end_proc, args())
  end_proc:

IV::_or:=
  proc()
  begin
    property::_Op
     (IV, _or,
      proc(iv1, iv2)
        name property::IVnat::_or;
        local i;
      begin
        if FLOAT(iv1) and FLOAT(iv2) then
          // leer
          if _if(RiO(iv2)*LeO(iv1) = 0, _leequal, _less)(FRi(iv2), FLe(iv1)) or
             _if(LeO(iv2)*RiO(iv1) = 0, _leequal, _less)(FRi(iv1), FLe(iv2)) then
            // Sonderfall keine Beruhrung aber keine Lucke
            if RiO(iv1) + LeO(iv2) > 0 and (Ri(iv1) = Le(iv2)) then
              return(IV::_Check(Le(iv1), LeO(iv1), Ri(iv2), RiO(iv2)))
            elif RiO(iv2) + LeO(iv1) > 0 and (Ri(iv2) = Le(iv1)) then
              return(IV::_Check(Le(iv2), LeO(iv2), Ri(iv1), RiO(iv1)))
            else
              return(hold(_or)(iv1, iv2))
            end_if
          end_if;
          // in
          if (i:= contains([TRUE, FALSE], IV::is(iv1, iv2))) > 0 then
            return(op([iv2, iv1], i))
          elif (i:= contains([TRUE, FALSE], IV::is(iv2, iv1))) > 0 then
            return(op([iv1, iv2], i))
          end_if;
          // Schnitt
          if FLe(iv2) <= FRi(iv1) and FLe(iv1) <= FLe(iv2) then
            return(IV::_Check(Le(iv1), LeO(iv1), Ri(iv2), RiO(iv2)))
          elif FLe(iv1) <= FRi(iv2) and FLe(iv1) >= FLe(iv2) then
            return(IV::_Check(Le(iv2), LeO(iv2), Ri(iv1), RiO(iv1)))
          end_if;
        else
          // leer: [a,b] or [c,d] -> d < a or b < c
//            fprint(0, "leer", iv1, iv2, _if(RiO(iv2)*LeO(iv1) = 0, _leequal, _less)(Ri(iv2), Le(iv1)),
//                   _if(LeO(iv2)*RiO(iv1) = 0, _leequal, _less)(Ri(iv1), Le(iv2)));
          if property::_is(_if(RiO(iv2)*LeO(iv1) = 0, _leequal, _less)(Ri(iv2), Le(iv1))) = TRUE or
             property::_is(_if(LeO(iv2)*RiO(iv1) = 0, _leequal, _less)(Ri(iv1), Le(iv2))) = TRUE then
            // Sonderfall keine Beruhrung aber keine Lucke
            if RiO(iv1) + LeO(iv2) > 0 and property::_is(Ri(iv1) = Le(iv2)) = TRUE then
              return(IV::_Check(Le(iv1), LeO(iv1), Ri(iv2), RiO(iv2)))
            elif RiO(iv2) + LeO(iv1) > 0 and property::_is(Ri(iv2) = Le(iv1)) = TRUE then
              return(IV::_Check(Le(iv2), LeO(iv2), Ri(iv1), RiO(iv1)))
            else
              return(hold(_or)(iv1, iv2))
            end_if
          end_if;
          // in
// fprint(0, "1a in", iv1, iv2);
// fprint(0, "1b in", iv2, iv1);
          if (i:= contains([TRUE, FALSE], IV::is(iv1, iv2))) > 0 then
// fprint(0, "1a ret", op([iv2, iv1], i));
            return(op([iv2, iv1], i))
          elif (i:= contains([TRUE, FALSE], IV::is(iv2, iv1))) > 0 then
// fprint(0, "1b ret", op([iv1, iv2], i));
            return(op([iv1, iv2], i))
          end_if;
          // Schnitt ist nicht leer
// fprint(0, "2a", Le(iv2) <= Ri(iv1), Le(iv1) <= Le(iv2));
// fprint(0, "2b", Le(iv1) <= Ri(iv2), Le(iv1) >= Le(iv2));
          if property::_is(Le(iv2) <= Ri(iv1)) = TRUE
             and property::_is(Le(iv1) <= Le(iv2)) = TRUE then
// fprint(0, "2a ret", Le(iv1), LeO(iv1), Ri(iv2), RiO(iv2));
            return(IV::_Check(Le(iv1), LeO(iv1), Ri(iv2), RiO(iv2)))
          elif property::_is(Le(iv1) <= Ri(iv2)) = TRUE
               and property::_is(Le(iv1) >= Le(iv2)) = TRUE then
// fprint(0, "2b ret", Le(iv2), LeO(iv2), Ri(iv1), RiO(iv1));
            return(IV::_Check(Le(iv2), LeO(iv2), Ri(iv1), RiO(iv1)))
          end_if;
          // Spezialfall ein-Punkt-Berhrung (fr Bezeichner ohne Eigenschaft)
// fprint(0, "3a", Le(iv2) = Ri(iv1));
// fprint(0, "3b", Le(iv1) = Ri(iv2));
          if property::_is(Le(iv2) = Ri(iv1)) = TRUE then
            if property::_is(Le(iv1) = Ri(iv2)) = TRUE
              and testtype(Le(iv2), Type::Constant) then
              return(IV::_Check(Le(iv2), LeO(iv2), Ri(iv1), RiO(iv1)))
            else
              // die einfachere Grenze
// fprint(0, "3a ret", Le(iv1), LeO(iv1), Ri(iv2), RiO(iv2));
              return(IV::_Check(Le(iv1), LeO(iv1), Ri(iv2), RiO(iv2)))
            end_if
          elif property::_is(Le(iv1) = Ri(iv2)) = TRUE then
// fprint(0, "3b ret", Le(iv2), LeO(iv2), Ri(iv1), RiO(iv1));
            return(IV::_Check(Le(iv2), LeO(iv2), Ri(iv1), RiO(iv1)))
          end_if
        end_if;
// fprint(0, "4 hold");
        hold(_or)(iv1, iv2)
        end_proc, args())
  end_proc:

// [borders, ...], [mating open info, ...]
IV::hull_ind:=
  proc(BORD, OPEN)
    local mi, ma, MIN, PMIN, MAX, PMAX, k, k1, N, NNUM, ni;
  begin
    BORD:= map(BORD, property::carefloat);
    // 1. numerisch
    k:= contains(map(BORD, X -> bool(contains([DOM_INT, DOM_RAT, DOM_FLOAT], domtype(X)) > 0)), TRUE);
    if k > 0 then
      MAX:= op(BORD, k); ma:= k;
      MIN:= op(BORD, k); mi:= k;
      for k from k + 1 to nops(BORD) do
        N:= op(BORD, k);
        if contains([DOM_INT, DOM_RAT, DOM_FLOAT], domtype(N)) > 0 then
          if N < MIN then // echtes Minimum
            MIN:= N;
            mi:= k
          elif N > MAX then // echtes Maximum
            MAX:= N;
            ma:= k
          elif N = MAX and N = MIN then
            if op(OPEN, k) > op(OPEN, mi) then
              mi:= k
            end_if;
            if op(OPEN, k) > op(OPEN, ma) then
              ma:= k
            end_if
          elif N = MIN and op(OPEN, k) > op(OPEN, mi) then
            mi:= k
          elif N = MAX and op(OPEN, k) > op(OPEN, ma) then
            ma:= k
          end_if
        end_if
      end_for
    else
      MAX:= op(BORD, 1); ma:= 1;
      MIN:= op(BORD, 1); mi:= 1
    end_if;
    if contains(map(BORD, X -> bool(contains([DOM_INT, DOM_RAT, DOM_FLOAT], domtype(X)) = 0)), TRUE) = 0 then
      return(mi, ma)
    end_if;
    // 2. symbolisch
    NNUM:= [];
    k:= contains(map(BORD, X -> bool(contains([DOM_INT, DOM_RAT, DOM_FLOAT], domtype(X)) = 0)), TRUE);
    for k from k to nops(BORD) do
      N:= op(BORD, k);
      if contains([DOM_INT, DOM_RAT, DOM_FLOAT], domtype(N)) = 0 then
        if (ni:= property::_is(N < MIN)) = TRUE then // echtes Minimum
          MIN:= N;
          mi:= k
        elif property::_is(N > MAX) = TRUE then // echtes Maximum
          MAX:= N;
          ma:= k
        else
          k1:= TRUE;
          if property::_is(N <= MIN) = TRUE then
            //k1:= FALSE;
            if op(OPEN, k) >= op(OPEN, mi) then
              mi:= k
            end_if
          end_if;
          if property::_is(N >= MAX) = TRUE then
            //k1:= FALSE;
            if op(OPEN, k) >= op(OPEN, ma) then
              ma:= k
            end_if
          end_if;
          if k1 then
            NNUM:= append(NNUM, k)
          end_if
        end_if
      end_if
    end_for;
    if NNUM = [] then
      return(mi, ma)
    elif nops(NNUM) = 1 then
      return(append(NNUM, mi), append(NNUM, ma))
    end_if;
    
    // 3. unmogliche min/max aussortieren
    PMIN:= NNUM; PMAX:= NNUM;
    for k from 1 to nops(NNUM) - 1 do
      for k1 from 2 to nops(NNUM) do
        if op(BORD, op(NNUM, k)) = op(BORD, op(NNUM, k1)) and
           op(OPEN, op(NNUM, k)) = op(OPEN, op(NNUM, k1)) then
          PMIN:= subsop(PMIN, k = 0.0);
          PMAX:= subsop(PMAX, k1 = 0.0)
        elif property::_is(op(BORD, op(NNUM, k)) < op(BORD, op(NNUM, k1))) = TRUE then
          PMIN:= subsop(PMIN, k1 = 0.0);
          PMAX:= subsop(PMAX, k = 0.0)
        elif property::_is(op(BORD, op(NNUM, k)) > op(BORD, op(NNUM, k1))) = TRUE then
          PMIN:= subsop(PMIN, k = 0.0);
          PMAX:= subsop(PMAX, k1 = 0.0)
        elif property::_is(op(BORD, op(NNUM, k)) <= op(BORD, op(NNUM, k1))) = TRUE then
          if op(OPEN, op(NNUM, k)) >= op(OPEN, op(NNUM, k1)) then
            PMIN:= subsop(PMIN, k1 = 0.0);
            PMAX:= subsop(PMAX, k1 = 0.0)
          elif op(OPEN, op(NNUM, k)) < op(OPEN, op(NNUM, k1)) then
            PMIN:= subsop(PMIN, k = 0.0);
            PMAX:= subsop(PMAX, k = 0.0)
          end_if            
        elif property::_is(op(BORD, op(NNUM, k)) >= op(BORD, op(NNUM, k1))) = TRUE then
          if op(OPEN, op(NNUM, k)) >= op(OPEN, op(NNUM, k1)) then
            PMIN:= subsop(PMIN, k = 0.0);
            PMAX:= subsop(PMAX, k = 0.0)
          elif op(OPEN, op(NNUM, k)) < op(OPEN, op(NNUM, k1)) then
            PMIN:= subsop(PMIN, k1 = 0.0);
            PMAX:= subsop(PMAX, k1 = 0.0)
          end_if            
        end_if
      end_for
    end_for;
    if contains(PMIN, mi) = 0 then PMIN:= append(PMIN, mi) end_if;
    if contains(PMAX, ma) = 0 then PMAX:= append(PMAX, ma) end_if;
    return(subs(PMIN, 0.0 = null()), subs(PMAX, 0.0 = null()))
  end_proc:

// undefined aussortieren
IV::noundef:=
  proc(BORD, OPEN)
    local k, IND;
  begin
    IND:= [];
    for k from 1 to nops(BORD) do
      if op(BORD, k) = undefined then
        IND:= append(IND, k)
      end_if
    end_for;
    subsop(BORD, k = null() $ k in IND), subsop(OPEN, k = null() $ k in IND)
  end_proc:

IV::_plus:=
  proc()
  begin
    property::_Op
     (IV, _plus,
      proc(iv1, iv2)
        name property::IVnat::_plus;
      begin
        IV::_Check(Le(iv1) + Le(iv2), LeO(iv1)*LeO(iv2), Ri(iv1) + Ri(iv2), RiO(iv1)*RiO(iv2))
      end_proc, args())
  end_proc:

IV::_subtract:=
  proc(iv1, iv2)
  begin
    IV::_Check(Le(iv1) - Ri(iv2), LeO(iv1)*RiO(iv2), Ri(iv1) - Le(iv2), RiO(iv1)*LeO(iv2))
  end_proc:

IV::_negate:=
  proc(iv)
  begin
    IV::_Check(-Ri(iv), RiO(iv), -Le(iv), LeO(iv))
  end_proc:

IV::_mult:=
  proc()
  begin
    property::_Op
     (IV, _mult,
      proc(iv1, iv2)
        name property::IVnat::_mult;
        local X, Y;
      begin
        X:= [Le(iv1)*Le(iv2), Le(iv1)*Ri(iv2), Ri(iv1)*Le(iv2), Ri(iv1)*Ri(iv2)],
            [LeO(iv1)*LeO(iv2), LeO(iv1)*RiO(iv2), RiO(iv1)*LeO(iv2), RiO(iv1)*RiO(iv2)];
        // undefined aussortieren
        X:= IV::noundef(X);
        if X = ([], []) then // 0 * infinity
          return(IV::_Check(0, 1, 0, 1, TRUE))
        end_if;
        Y:= IV::hull_ind(X);
        if domtype(op(Y, 1)) = DOM_INT then
          return(IV::_Check(op(X, [1, op(Y, 1)]), op(X, [2, op(Y, 1)]),
                            op(X, [1, op(Y, 2)]), op(X, [2, op(Y, 2)])))
        end_if;
        X:= select(IV::_Check(op(X, [1, i]), op(X, [2, i]),
                              op(X, [1, j]), op(X, [2, j]))
                   $ i in op(Y, 1) $ j in op(Y, 2), bool@_unequal, property::Null);
        if type(X) = "_exprseq" then IV::_or(X) else X end_if
      end_proc, args())
  end_proc:

IV::_divide:=
  proc(iv1, iv2)
    local sl, slo, sr, sro, X, Y;
  begin
    //if contains(IV::sign(iv2), 0) then
    //  error("division by zero (property)")
    //end_if;
    if FLOAT(iv1) and FLOAT(iv2) then
      if iszero(Le(iv2)) then
        sl:= sign(Le(iv1))*infinity, sign(Ri(iv1))*infinity; slo:= 0, 0
      else
        sl:= Le(iv1)/Le(iv2), Ri(iv1)/Le(iv2); slo:= LeO(iv1)*LeO(iv2), RiO(iv1)*LeO(iv2)
      end_if;
      if iszero(Ri(iv2)) then
        sr:= sign(Le(iv1))*infinity, sign(Ri(iv1))*infinity; sro:= 0, 0
      else
        sr:= Le(iv1)/Ri(iv2), Ri(iv1)/Ri(iv2); sro:= LeO(iv1)*RiO(iv2), RiO(iv1)*RiO(iv2)
      end_if
    else
      if property::_is(Le(iv2) = 0) = TRUE then
        sl:= sign(Le(iv1))*infinity, sign(Ri(iv1))*infinity; slo:= 0, 0
      else
        sl:= Le(iv1)/Le(iv2), Ri(iv1)/Le(iv2); slo:= LeO(iv1)*LeO(iv2), RiO(iv1)*LeO(iv2)
      end_if;
      if property::_is(Ri(iv2) = 0) = TRUE then
        sr:= sign(Le(iv1))*infinity, sign(Ri(iv1))*infinity; sro:= 0, 0
      else
        sr:= Le(iv1)/Ri(iv2), Ri(iv1)/Ri(iv2); sro:= LeO(iv1)*RiO(iv2), RiO(iv1)*RiO(iv2)
      end_if
    end_if;
    X:= /*IV::noundef*/([sl, sr], [slo, sro]);
    Y:= IV::hull_ind(X);
    if domtype(op(Y, 1)) = DOM_INT then
      return(IV::_Check(op(X, [1, op(Y, 1)]), op(X, [2, op(Y, 1)]),
                        op(X, [1, op(Y, 2)]), op(X, [2, op(Y, 2)])))
    end_if;
    X:= select(IV::_Check(op(X, [1, i]), op(X, [2, i]),
                          op(X, [1, j]), op(X, [2, j]))
               $ i in op(Y, 1) $ j in op(Y, 2), bool@_unequal, property::Null);
    if type(X) = "_exprseq" then IV::_or(X) else X end_if
  end_proc:

IV::_invert:=
  proc(iv)
    local sl, slo, sr, sro, X, Y;
  begin
    if contains((X:= IV::sign(iv)), 0) then
      return(_if(iszero(Le(iv)), null(), 1/subsop(iv, RI = 0, RIO = 0))
             or _if(iszero(Ri(iv)), null(), 1/subsop(iv, LE = 0, LEO = 0)))
    end_if;
    if FLOAT(iv) then
      if iszero(Le(iv)) then
        sl:= infinity; slo:= 0;
        sr:= _invert(Ri(iv)); sro:= RiO(iv)
      else
        sl:= _invert(Le(iv)); slo:= LeO(iv);
        if iszero(Ri(iv)) then
          sr:= -infinity; sro:= 0
        else
          sr:= _invert(Ri(iv)); sro:= RiO(iv)
        end_if
      end_if
    else
      if property::_is(Le(iv) = 0) = TRUE then
        sl:= infinity; slo:= 0;
        sr:= _invert(Ri(iv)); sro:= RiO(iv)
      else
        sl:= _invert(Le(iv)); slo:= LeO(iv);
        if property::_is(Ri(iv) = 0) = TRUE then
          sr:= -infinity; sro:= 0
        else
          sr:= _invert(Ri(iv)); sro:= RiO(iv)
        end_if
      end_if
    end_if;
    X:= /*IV::noundef*/([sl, sr], [slo, sro]);
    Y:= IV::hull_ind(X);
    if domtype(op(Y, 1)) = DOM_INT then
      return(IV::_Check(op(X, [1, op(Y, 1)]), op(X, [2, op(Y, 1)]),
                        op(X, [1, op(Y, 2)]), op(X, [2, op(Y, 2)])))
    end_if;
    X:= select(IV::_Check(op(X, [1, i]), op(X, [2, i]),
                          op(X, [1, j]), op(X, [2, j]))
               $ i in op(Y, 1) $j in op(Y, 2), bool@_unequal, property::Null);
    if type(X) = "_exprseq" then IV::_or(X) else X end_if;
  end_proc:

IV::_power:=
  proc(iv, pow)
    local X, Y, SIGN;
  begin
    if contains(["_and", "_or", "_not"], type(iv)) > 0 then
      return(map(iv, _power, pow))
      //return(hold(_power)(iv, pow))
    end_if;
    SIGN:= IV::sign(subsop(iv, LEO = 1, RIO = 1));
    if property::_is(pow, Type::Zero) = TRUE then
      if contains(SIGN, 0) then
        return(IV::_new(-infinity, 0, infinity, 0, TRUE))
      else
        return(IV::_new(1, 1, 1, 1, TRUE))
      end_if
    end_if;
    if contains(SIGN, -1) and property::_is(pow, Type::Integer) <> TRUE then
      // !! Verwirrung bei anderen Funktionen??
      if property::implies(pow, property::IVnat([-1/2, 1/2])) = TRUE then
//      if domtype(pow) = DOM_RAT and op(pow, 2) = 2 then
//        return(Rel::sqrt(rel, op(pow, 1)))
      //if abs(pow) < 1/2 then // power less than 1/2, but positive!
        return(property::Complex(property::Rel(-_less, 0)))
      else
        return(Type::Complex)
      end_if
    end_if;
    if contains([DOM_INT, DOM_RAT, DOM_FLOAT, DOM_IDENT], domtype(pow)) > 0 then
      if specfunc::frac(pow) <> 0 and contains(IV::sign(iv), -1) then
        Y:= IV::_and(iv, IV([0], infinity));
        if Y = property::Null then
          return(property::Null)
        elif type(Y) = "_and" then
          // split interval
          return(map(Y, _power, pow))
        else
          iv:= Y
        end_if
      end_if;
      
      // Quadrat
      if property::_is(pow < 0) = TRUE then
        return(property::IVnat::_invert(property::IVnat::_power(iv, -pow)))
      end_if;
      X:= /*IV::noundef*/([Le(iv)^pow, Ri(iv)^pow], [LeO(iv), RiO(iv)]);
      if property::_is(pow, Type::Even) = TRUE then
        if IV::sign(iv) = {-1, 0, 1} then
          X:= append(op(X, 1), 0), append(op(X, 2), 1)
        end_if
      end_if;
      Y:= IV::hull_ind(X);
      if domtype(op(Y, 1)) = DOM_INT then
        return(IV::_Check(op(X, [1, op(Y, 1)]), op(X, [2, op(Y, 1)]),
                          op(X, [1, op(Y, 2)]), op(X, [2, op(Y, 2)])))
      end_if;
      X:= select(IV::_Check(op(X, [1, i]), op(X, [2, i]),
                            op(X, [1, j]), op(X, [2, j]))
                 $ i in op(Y, 1) $j in op(Y, 2), bool@_unequal, property::Null);
      if type(X) = "_exprseq" then return(IV::_or(X)) else return(X) end_if;
    elif type(iv) <> "IVnat" or type(pow) <> "IVnat" then
      return(hold(_power)(iv, pow))
    elif type(pow) <> "IVnat" then
      Y:= property::convert_to(pow, property::IVnat);
      if type(Y) <> "IVnat" then
        return(hold(_power)(iv, pow))
      else
        pow:= Y
      end_if
    end_if;
    // prevent illegal operations
    X:= IV::noundef(map([[Le(iv), Le(pow), 1], [Le(iv), Ri(pow), 1],
                          [Ri(iv), Le(pow), -1], [Ri(iv), Ri(pow), -1]],
                        X -> if op(X, 1) = 0 and op(X, 2) < 0 then // 1/0
                               op(X, 3)*infinity
                             else
                               _power(op(X, 1..2))
                             end_if),
                    // open if pow is infinity
                    [_if(domtype(Le(pow)) <> stdlib::Infinity, LeO(iv), 0),
                     _if(domtype(Ri(pow)) <> stdlib::Infinity, LeO(iv), 0),
                     _if(domtype(Le(pow)) <> stdlib::Infinity, RiO(iv), 0),
                     _if(domtype(Ri(pow)) <> stdlib::Infinity, RiO(iv), 0)]);
    Y:= IV::hull_ind(X);
    if domtype(op(Y, 1)) = DOM_INT then
      return(IV::_Check(op(X, [1, op(Y, 1)]), op(X, [2, op(Y, 1)]),
                        op(X, [1, op(Y, 2)]), op(X, [2, op(Y, 2)])))
    end_if;
    X:= select(IV::_Check(op(X, [1, i]), op(X, [2, i]),
                             op(X, [1, j]), op(X, [2, j]))
               $ i in op(Y, 1) $ j in op(Y, 2), bool@_unequal, property::Null);
    if type(X) = "_exprseq" then IV::_or(X) else X end_if
  end_proc:

// IV intersect Type::Integer
IV::Integer:=
  proc(iv)
    local l, lo, r, ro;
  begin
    l:= _if(domtype(Le(iv)) = DOM_INT, Le(iv) + 1 - LeO(iv),
            _if(domtype(ceil(Le(iv))) = DOM_INT, ceil(Le(iv)), Le(iv)));
    if l <> Le(iv) then lo:= 1 else lo:= LeO(iv) end_if;
    r:= _if(domtype(Ri(iv)) = DOM_INT, Ri(iv) - 1 + RiO(iv),
            _if(domtype(floor(Ri(iv))) = DOM_INT, floor(Ri(iv)), Ri(iv)));
    if r <> Ri(iv) then ro:= 1 else ro:= RiO(iv) end_if;
    if domtype(r - l) = DOM_INT then
      if property::_is((op([_less, _leequal], lo*ro + 1))(r - l, 0)) = TRUE then
	property::Null
      end_if
    end_if;
    IV::_Check(l, lo, r, ro)
  end_proc:

IV::hull:=
  proc(iv)
    local sgn;
  begin
    if FLOAT(iv) then
      Le(iv)...Ri(iv)
    else
      sgn:= IV::sign(iv);
      if sgn = {0} then
        0...0
      else
        _union(_if(has(sgn, -1), RD_NINF...0, null()),
               _if(has(sgn, 1), 0...RD_INF, null()))
      end_if
    end_if
  end_proc:

// 
IV::print:=
  proc(iv)
  begin
    _if(LeO(iv) = 0, "]", "[")
    .expr2text(Le(iv))
    .", "
    .expr2text(Ri(iv))
    ._if(RiO(iv) = 0, "[", "]")
    //._if(FLOAT(iv), ".", "")
  end_proc:

IV::Content:=
  proc(Out, iv)
  begin
    Out::Cinterval({hold(closure) = op(["open", "closed-open", 
                                        "open-closed", "closed"], 1 + LeO(iv) + 2*RiO(iv))},
                   Out(Le(iv)), 
                   Out(Ri(iv))) 
  end_proc:
