// $Date: 2002/02/27 12:32:58 $ $Author: bij $ $Revision: 1.99 $

//
// NRange - Domain of numerical property 'Range of a number'
//

alias(NRange = property::NRange):
// Arg gibt das Argument -String- zuruck
alias(Arg(x) = op(extop(x, 5), 1)):
alias(ARG = [5, 1]):
alias(Excl(x) = op(extop(x, 5), 2)):
alias(EXCL = [5, 2]):

/*( 1)*/   alias(NONZERO = 1):
/*( 2)*/   alias(ZERO = 2):
/*( 3)*/   alias(PRIME = 3):
/*( 4)*/   alias(POSINT = 4):
/*( 5)*/   alias(NONNEGINT = 5):
/*( 6)*/   alias(NEGINT = 6):
/*( 7)*/   alias(INTEGER = 7):
/*( 8)*/   alias(POSRAT = 8):
/*( 9)*/   alias(NONNEGRAT = 9):
/*(10)*/   alias(NEGRAT = 10):
/*(11)*/   alias(RATIONAL = 11):
/*(12)*/   alias(FRACTION = 12):
/*(13)*/   alias(POSITIVE = 13):
/*(14)*/   alias(NONNEGATIVE = 14):
/*(15)*/   alias(NEGATIVE = 15):
/*(16)*/   alias(IRRATIONAL = 16):
/*(17)*/   alias(REAL = 17):
/*(18)*/   alias(INTIMAGINARY = 18):
/*(19)*/   alias(IMAGINARY = 19):
/*(20)*/   alias(COMPLEX = 20):
/*(21)*/   alias(NFAIL = 21):



NRange:= newDomain("property::NRange"):
NRange::create_dom:=hold(property::NRange):
NRange::info:= "Domain of numerical property 'Range of a number'":
NRange::domtype:= ()->Type:
NRange::type:= "NRange":
NRange::prop:= TRUE:
NRange::propdom:= slot(property, "NRange"):
NRange::autoload:= TRUE:
NRange::testtype:= Type::testtype:

NRange::noTrace:= {hold(print), hold(testtype), hold(domtype)}:

NRange::ax:= []:

NRange::new:= 
        proc(prop = "Complex", cl = property::Null) // cl = non included subset
        begin
          if testargs() then
            if domtype(prop) <> DOM_STRING and prop <> property::Null then
              error("illegal first argument '".prop."'")
            elif contains(NRange::order, prop) = 0 and prop <> property::Null then
              error("unknown range of a number '".prop."'")
            elif domtype(cl) <> DOM_STRING and cl <> property::Null then
              error("illegal second argument '".cl."'")
            end_if
          end_if;
          // simplify
          NRange::combine(prop, cl)
        end_proc:

// set and excl-set
NRange::combine:=
        proc(arg, excl = property::Null)
        begin
          if arg = property::Null then
            return(subsop(slot(Type, "Complex"), /*ARG = property::Null,*/ EXCL = excl))
          elif excl = property::Null or excl = "Complex" then
            return(slot(Type, arg))
          else // simplify
            if property::path(NRange::child, excl, arg) then
              return(property::Null)
            elif NRange::_and(slot(Type, arg), slot(Type, excl)) = property::Null then
              return(slot(Type, arg))
            elif excl = "Zero" then
              if not contains(op(NRange::_info, [contains(NRange::order, arg), 1]), 0) then
                return(slot(Type, arg))
              elif op(NRange::_info, [contains(NRange::order, arg), 1]) <> {-1, 0, 1} then
                //
                if op(NRange::_info, [contains(NRange::order, arg), 1]) = {0, 1} then
                  return(slot(Type, op(NRange::order, 
                                       op([POSITIVE, POSRAT, POSINT],
                                          contains([NONNEGATIVE, NONNEGRAT, NONNEGINT],
                                                   contains(NRange::order, arg))))))
                //elif op(NRange::_info, [contains(NRange::order, rg), 1]) = {-1, 0} then
                //  
                end_if
              end_if
            //elif contains(NRange::child[arg], excl) and nops(NRange::child[arg]) = 2 then
            //  slot(Type, op(NRange::child[arg] minus {excl}))
            end_if
          end_if;
          subsop(slot(Type, arg), EXCL = excl)
        end_proc:

NRange::child:=
        table(
          "Complex"     = {"Imaginary", "Real", "Imaginary", "NonZero"},
          "NonZero"     = {/*"Imaginary",*/ "Positive", "Negative"/*, "IntImaginary"*/},
          "Imaginary"   = {"IntImaginary"},
          "IntImaginary"= {"HELP1"},
          "HELP1"       = {"Zero"},
          "Real"        = {"Rational", "Irrational", "NonNegative", "Negative" /*, "NonZero"*/},
          //"NonZero"     = {"Positive", "Negative"},
          "Irrational"  = {"Irrational"},
          "Negative"    = {"NegRat"},
          "NonNegative" = {"Positive", "NonNegRat"},
          //"NonPositive" = {"Negative", "NonPosRat"},
          "Positive"    = {"PosRat"},
          "Rational"    = {"Integer", "Fraction", "NonNegRat", "NegRat"},
          "Fraction"    = {"Fraction"},
          "NegRat"      = {"NegInt"},
          "NonNegRat"   = {"PosRat", "NonNegInt"},
          //"NonPosRat"   = {"NegRat", "NonPosInt"},
          "PosRat"      = {"PosInt"},
          "Integer"     = {"NegInt", "NonNegInt"},
          "NegInt"      = {"NegInt"},
          "NonNegInt"   = {"PosInt", "Zero"},
          //"NonPosInt"   = {"NegInt", "Zero"},
          "PosInt"      = {"Prime"},
          "Prime"       = {"Prime"},
          "Zero"        = {"Zero"/*, "FAIL"*/}
          //"FAIL"        = {"FAIL"}
        ):

NRange::parent:=
    table(
          "Zero"        = {"NonNegInt", "HELP3"},
          "Prime"       = {"PosInt"},
          "PosInt"      = {"NonNegInt", "HELP1"},
          "HELP1"       = {"PosRat"},
          "NonNegInt"   = {"Integer", "NonNegRat"},
          //"NonPosInt"   = {"Integer", "NonPosRat"},
          "NegInt"      = {"Integer", "NegRat"},
          "Integer"     = {"Rational"},
          "PosRat"      = {"NonNegRat", "HELP2"},
          "HELP2"       = {"Positive"},
          "NonNegRat"   = {"Rational", "NonNegative"},
          //"NonPosRat"   = {"Rational", "NonPositive"},
          "NegRat"      = {"Rational", "Negative"},
          "Fraction"    = {"Rational"},
          "Rational"    = {"Real"},
          "Positive"    = {"NonNegative", "HELP4"},
          "HELP4"       = {"NonZero"},
          "NonNegative" = {"Real"},
          //"NonPositive" = {"Real"},
          "Negative"    = {"Real", "HELP5"},
          "HELP5"       = {"NonZero"},
          //"NonZero"     = {"Real"},
          "Real"        = {"Complex"},
          "Irrational"  = {"Real"},
          "HELP3"       = {"IntImaginary"},
          "IntImaginary"= {"Imaginary"},
          "Imaginary"   = {/*"NonZero",*/ "Complex"},
          "NonZero"     = {"Complex"},
          "Complex"     = {"Complex"/*, "FAIL"*/}
          //"FAIL"        = {"FAIL"}
        ):

// gibt die Ordnung zuruck 
/* NRange::_o:= proc(rg, X = 1) begin op([contains(NRange::order, Arg(rg)),
                                       contains(NRange::order, Excl(rg))], X) end_proc:
*/


// gibt die Ordnung zuruck 
NRange::_o:= proc(rg, X = 1)
             begin
               contains(NRange::order, op([Arg(rg), Excl(rg)], X))
             end_proc:

// interne Ordnung 
NRange::order:=
/*( 1 )*/ ["NonZero",
/*( 2 )*/  "Zero",
/*( 3 )*/  "Prime",
/*( 4 )*/  "PosInt",
/*( 5 )*/  "NonNegInt",
/*( 6 )*/  "NegInt",
/*( 7 )*/  "Integer",
/*( 8 )*/  "PosRat",
/*( 9 )*/  "NonNegRat",
/*(10 )*/  "NegRat",
/*(11 )*/  "Rational",
/*(12 )*/  "Fraction",
/*(13 )*/  "Positive",
/*(14 )*/  "NonNegative",
/*(15 )*/  "Negative",
/*(16 )*/  "Irrational",
/*(17 )*/  "Real",
/*(18 )*/  "IntImaginary",
/*(19 )*/  "Imaginary",
/*(20 )*/  "Complex",
/*(21 )*/  property::Null]:
//#(22 )#  "FAIL"]:

// info   mult,     -rg,          neg,          inv,         pow
// Tabelle fr Spezialflle
// Spalte 1: sign
// Spalte 2:
// Spalte 3: -x | x \in NRange
// Spalte 4: 1/x | x \in NRange
// Spalte 5: x^k | x \in NRange und k \in POSINT

// mult: negativ/beides/positiv
//  -rg: (mult) - mal -        
//  neg: negatives             
//  inv: inverses              
//  pow: ^ bei Exponent PosInt
alias(PINT = 0...RD_INF):
alias(RINT = RD_NINF...RD_INF):

NRange::_info:=
/*( 1 )*/ [[{-1,1}  , NONZERO,      NONZERO,      NONZERO,     NONZERO    , RINT + I*RINT],
/*( 2 )*/  [{0}     , ZERO,         ZERO,         NFAIL,       ZERO       , 0...0],
/*( 3 )*/  [{1}     , POSINT,       NEGINT,       POSRAT,      POSINT     , 2...RD_INF],
/*( 4 )*/  [{1}     , POSINT,       NEGINT,       POSRAT,      POSINT     , 1...RD_INF],
/*( 5 )*/  [{0,1}   , NONNEGINT,    INTEGER/*ne!*/, NONNEGRAT,   POSINT     , PINT],
/*( 6 )*/  [{-1}    , POSINT,       POSINT,       NEGRAT,      INTEGER    , -PINT],
/*( 7 )*/  [{-1,0,1}, INTEGER,      INTEGER,      RATIONAL,    INTEGER    , RINT],
/*( 8 )*/  [{1}     , POSRAT,       NEGRAT,       POSRAT,      POSRAT     , PINT],
/*( 9 )*/  [{0,1}   , NONNEGRAT,    RATIONAL/*ne!*/, NONNEGRAT,   NONNEGRAT  , PINT],
/*(10 )*/  [{-1}    , POSRAT,       POSRAT,       NEGRAT,      RATIONAL   , -PINT],
/*(11 )*/  [{-1,0,1}, RATIONAL,     RATIONAL,     RATIONAL,    RATIONAL   , RINT],
/*(12 )*/  [{-1,0,1}, FRACTION,     FRACTION,     FRACTION,    FRACTION   , RINT],
/*(13 )*/  [{1}     , POSITIVE,     NEGATIVE,     POSITIVE,    POSITIVE   , PINT],
/*(14 )*/  [{0,1}   , NONNEGATIVE,  REAL/*ne!*/,NONNEGATIVE, NONNEGATIVE, PINT],
/*(15 )*/  [{-1}    , POSITIVE,     POSITIVE,     NEGATIVE,    REAL       , -PINT],
/*(16 )*/  [{-1,0,1}, IRRATIONAL,   IRRATIONAL,   IRRATIONAL,  REAL       , RINT],
/*(17 )*/  [{-1,0,1}, REAL,         REAL,         REAL,        REAL       , RINT], // NEGINT?
/*(18 )*/  [{-I,0,I}, INTIMAGINARY, INTIMAGINARY, IMAGINARY,   COMPLEX    , I*RINT],
/*(19 )*/  [{-I,0,I}, IMAGINARY,    IMAGINARY,    IMAGINARY,   COMPLEX    , I*RINT],
/*(20 )*/  [{-I,0,I}, COMPLEX,      COMPLEX,      COMPLEX,     COMPLEX    , RINT + I*RINT],
/*(21 )*/  [{-I,0,I}, COMPLEX,      COMPLEX,      COMPLEX,     COMPLEX    , {}],
/*(22 )*/  [FAIL    , NFAIL,        NFAIL,        NFAIL,       NFAIL      , FAIL]]:

unalias(RINT):
unalias(PINT):

NRange::elem:=
        proc(rg)
        begin
          op([[1.2, -1.2], // "NonZero",
              [0],         // "Zero",
              [3],         // "Prime",
              [1],         // "PosInt",
              [0, 1],      // "NonNegInt",
              [-1],        // "NegInt",
              [1, -1],     // "Integer",
              [1/2],       // "PosRat",
              [0, 1/2],    // "NonNegRat",
              [-1/2],      // "NegRat",
              [1/2, -1/2], // "Rational",
              [1/2, -1/2], // "Fraction",
              [1.2],       // "Positive",
              [0, 1.2],    // "NonNegative",
              [-1.2],      // "Negative",
              [2.7, -2.7], // "Irrational",
              [2.3, -2.3], // "Real",
              [2.3*I],         // "Imaginary",
              [2*I],       // "IntImaginary",
              [1.2 + 2.3*I]],// "Complex",
             NRange::_o(rg))
        end_proc:

NRange::is:=
        proc(rg1, rg2)
        begin
          if rg2 = Type::Complex then
            return(TRUE)
          elif type(rg2) <> "NRange" then
            return(UNKNOWN)
          elif type(rg1) = "IV" then
            // Verallgemeinerung der Intervallgrenzen
            return(NRange::is(rg1::dom::NRange(rg1), rg2))
            //elif type(rg1) = "Complex" then
            //  // Verallgemeinerung der Intervallgrenzen
            //  return()
          elif type(rg1) = "Residue" then
            return(NRange::is(property::Residue::range(rg1), rg2))
          elif property::Numeric(rg1) then
            // rg1 - number, rg2 - Type
            return(testtype(rg1::dom::Numeric(rg1, hold(Exact)), rg2))
          elif domtype(property::carefloat(rg1)) = DOM_COMPLEX
               and property::implies(Type::Real, rg2) = TRUE then
            return(FALSE)
          elif type(rg1) <> "NRange" then
            if rg2 = Type::NonZero then
              return(property::implies(rg1, property::Rel(hold(_unequal), 0)))
            elif rg2 = Type::Zero then
              return(property::implies(rg1, property::Rel(hold(_equal), 0)))
            else
              return(UNKNOWN)
            end_if
          else // NRange, NRange
            if property::path(NRange::child, Arg(rg2), Arg(rg1))
               and property::path(NRange::parent, Excl(rg2), Excl(rg1)) then
              return(TRUE)
            elif NRange::_and(rg1, rg2) = property::Null then
              return(FALSE)
            elif property::path(NRange::parent, Arg(rg2), Excl(rg1)) then
              return(FALSE)
            end_if
          end_if;
          return(UNKNOWN)
        end_proc:

// Uberladung
NRange::contains:=
        proc(rg, nm)
        begin
          if type(rg) <> "NRange" then
            FALSE
          else
            bool(property::_is(nm, rg) = TRUE)
          end_if
        end_proc:

// Type::Constant 
NRange::constant:=
        proc(rg)
        begin
          if Arg(rg) = "Zero" then
            TRUE
          else
            UNKNOWN
          end_if;
        end_proc:

// _rg1 and _rg2 --> Schnitt 
NRange::_and:=
        proc()
          local k, n;
        begin
          // Spezialfall 'not relation' and 'Type::Real'
          if (n:= op((k:= split([args()], X -> type(X) = "_not")), 1)) <> []
             and contains(map(n, X -> bool(type(op(X)) = "Rel")), TRUE) > 0 then
            if contains(map(op(k, 2),
                            X -> _lazy_and(type(X) = "NRange",
                                           NRange::is(X, Type::Real) = TRUE)),
                        TRUE) > 0 then
              return(NRange::_and(op(op(k, 2)),
                                  op(map(n, X -> if type(op(X)) = "Rel" then
                                                   property::Rel::_not(op(X), TRUE)
                                                 else
                                                   X
                                                 end_if))))
            end_if
          // Spezialfall Relationen - exakt rechnen!
          elif contains(map([args()], type), "Rel") <> 0 then
            return(property::Rel::_and(args()))
          end_if;
          property::_Op
           (NRange, _and,
            proc(rg1, rg2)
              local _rg1, _rg2, _ret, _s1, _las, _alt, _neu, _excl;
            begin
              _rg2:= Arg(rg1);
              _rg1:= Arg(rg2);

              if Excl(rg1) <> Excl(rg2) then
                if Excl(rg1) = property::Null then
                  _excl:= Excl(rg2)
                elif Excl(rg2) = property::Null then
                  _excl:= Excl(rg1)
                else
                  _excl:= Arg(NRange::_or(NRange::combine(Excl(rg1)), NRange::combine(Excl(rg2))))
                end_if
              else
                _excl:= Excl(rg1)
              end_if;

              // Sonderbehandlung
              //if _rg2 = "NonZero" and contains({"Integer", "Rational"}, _rg1) then
              //  return(NRange::combine(_rg1, _excl))
              //end_if;

              if (_rg1 = _rg2 and _rg1 <> property::Null)
                 or property::path(NRange::parent, _rg2, _rg1) then
                return(NRange::combine(_rg2, _excl));
              end_if;
              if property::path(NRange::child, _rg2, _rg1) then
                return(NRange::combine(_rg1, _excl));
              end_if;

              if _rg1 = property::Null then
                return(NRange::combine(_rg2, _excl))
              elif _rg2 = property::Null then
                return(NRange::combine(_rg1, _excl))
              end_if;

              _s1:= {_rg1};
              _neu:= _s1;
              _alt:= _neu;
              _las:= 0;
              while (_las <> nops(_s1)) do
                _las:= nops(_s1);
                _ret:= select(_neu, X -> property::path(NRange::child, _rg2, X));
                if _ret <> {} then
                  if nops(_ret) > 1 then
                    return(NRange::_or(op(map(_ret, NRange::combine))))
                  else
                    return(NRange::combine(op(_ret, 1), _excl))
                  end_if
                end_if;
                _s1:= _union(_s1, NRange::child[extop(_neu, i)] $ i=1..extnops(_neu));
                _neu:= _s1 minus _alt;
                _alt:= _alt union _s1;
              end_while;
              return(property::Null)
            end_proc, args())
        end_proc:

// _rg1 or _rg2 --> Vereinigung 
NRange::_or:=
        proc()
        begin
          property::_Op
           (NRange, _or,
            proc(rg1, rg2)
              local _rg1, _rg2, _s1, _las, _alt, _neu, __i, _excl;
            begin
              _rg1:= Arg(rg1);
              _rg2:= Arg(rg2);
              //if Excl(rg1) <> property::Null and _rg1 = "Complex" then _rg1:= property::Null end_if;
              //if Excl(rg2) <> property::Null and _rg2 = "Complex" then _rg2:= property::Null end_if;

              if Excl(rg1) <> Excl(rg2) then
                if Excl(rg1) = property::Null then
                  _excl:= Excl(rg2)
                elif Excl(rg2) = property::Null then
                  _excl:= Excl(rg1)
                else
                  _excl:= Arg(NRange::_and(NRange::combine(Excl(rg1)), NRange::combine(Excl(rg2))))
                end_if
              else
                _excl:= Excl(rg1)
              end_if;

              // beide <> 0
              if property::path(NRange::child, "NonZero", _rg1)
                 and property::path(NRange::child, "NonZero", _rg2) then
                if _excl <> property::Null then
                  _excl:= Arg(NRange::_and(NRange::combine(_excl), Type::Zero))
                else
                  _excl:= "Zero"
                end_if                
              end_if;

              //
              if _rg1 = property::Null then
                return(NRange::combine(_rg2, _excl))
              elif _rg2 = property::Null then
                return(NRange::combine(_rg1, _excl))
              end_if;

              // Sonderbehandlung
              if _rg1 = "Zero"         // sign
                 and NRange::sign(NRange::combine(_rg2)) = {-1} then
                return(property::IV(-infinity, [0],
                                    NRange::_or(NRange::combine(_rg1), Type::Integer)))
              elif _rg2 = "Zero"       // sign
                 and NRange::sign(NRange::combine(_rg1)) = {-1} then
                return(property::IV(-infinity, [0],
                                    NRange::_or(NRange::combine(_rg1), Type::Integer)))
              end_if;

              // direkter Vorfahre
              if (_rg1 = _rg2 and _rg1 <> property::Null)
                 or property::path(NRange::child, _rg2, _rg1) then
                return(NRange::combine(_rg2/*, _excl*/));
              end_if;
              if property::path(NRange::parent, _rg2, _rg1) then
                return(NRange::combine(_rg1/*, _excl*/));
              end_if;

              _s1:= {_rg1};
              _neu:= _s1;
              _alt:= _neu;
              _las:= 0;
              while (_las <> nops(_s1)) do
                _las:= nops(_s1);
                for __i from 1 to nops(_neu) do
                  if property::path(NRange::parent, _rg2, extop(_neu, __i)) then
                    return(NRange::combine(extop(_neu, __i), _excl))
                  end_if;
                  _s1:= _s1 union NRange::parent[extop(_neu, __i)];
                end_for;
                _neu:= _s1 minus _alt;
                _alt:= _alt union _s1;
              end_while;
              return(property::Null)
            end_proc, args())
        end_proc:

NRange::_not:=
        proc(rg)
        begin
          if Excl(rg) = property::Null then
            return(NRange::combine(Excl(rg), Arg(rg)))
          elif Arg(rg) = "Complex" then
            return(NRange::combine(Excl(rg), Arg(rg)))
          else
            NRange::_or(NRange(Excl(rg)), NRange::_not(NRange(Arg(rg))))
          end_if
        end_proc:

NRange::_plus:= 
        proc()
          local k, r;
        begin
          // Sonderfall 'x - 1'
          if contains({args()}, Type::PosInt) then
            if (k:= select({args()}, X->domtype(X) = DOM_INT)) <> {} and op(k) = -1 then
              if args(0) > 2 then
                return(NRange::_plus(Type::NonNegInt,
                                     op(select({args()}, X -> domtype(X) <> DOM_INT
                                                              and X <> Type::PosInt))))
              else
                return(Type::NonNegInt)
              end_if
            end_if
          end_if;
//           // Sonderfall Primzahl
//           if contains((k:= [args()]), Type::Prime) > 0 then
//             k:= split(k, _equal, Type::Prime);
//             if nops((r:= op(op(k, 2)))) > 1 then
//               r:= NRange::_plus(r)
//             end_if;
//             if testtype(r, Type::NonNegative) then // positive or nonnegative
//               return(property::IV::simplify
//                      (property::IV::_plus
//                       (property::IV([2*nops(op(k, 1))], infinity, Type::PosInt),
//                        r)))
//             else
//               return(r + nops(op(k, 1))*Type::Prime)
//             end_if
//           end_if;
          // Sonderfall: numerischer Wert -> Intervall
          if (r:= _plus(op(op((k:= split([args()], testtype, Type::Complex)), 1)))) <> 0 then
            k:= op(k, 2):
            if nops(k) > 1 then
              k:= NRange::_plus(op(k))
            elif nops(k) = 1 then
              k:= op(k)
            elif k = null() then
              // only constants
              return(r)
            end_if;
            if testtype(r, Type::Real) and op((r:= (NRange::IV(k), r)), 1) <> FAIL then
              return(property::IV::simplify(property::IV::_plus(r)))
            else // complex
              return(property::Complex::_plus(k, r))
            end_if
          end_if;

          property::_Op
          (NRange, _plus,
           proc(rg1, rg2)
             local __i1, __i2;
           begin
             __i1:= NRange::_o(rg1);
             __i2:= NRange::_o(rg2);
             // Sonderfall 'Null'
             if contains([__i1, __i2], ZERO) > 0 then
               return(op([rg2, rg1], contains([__i1, __i2], ZERO)))
             end_if;

             // forget Excl ??
             rg1:= subsop(rg1, EXCL = property::Null);
             rg2:= subsop(rg2, EXCL = property::Null);

             // NonNegative
             if contains({NONNEGINT, NONNEGRAT, NONNEGATIVE}, __i1) then
               if not(contains({NONNEGINT, NONNEGRAT, NONNEGATIVE}, __i2)) then
                 if op(NRange::_info, [__i2, 1]) = {1} then
                   return(NRange::_or(NRange(op(NRange::order, __i1 - 1)),
                                      rg2))
                 end_if
               end_if
             elif contains({NONNEGINT, NONNEGRAT, NONNEGATIVE}, __i2) then
               if op(NRange::_info, [__i1, 1]) = {1} then
                 return(NRange::_or(rg1,
                                    NRange(op(NRange::order, __i2 - 1))))
               end_if
             end_if;
             // Sonderfall 'imaginr'
//              if {__i1, __i2} intersect {INTIMAGINARY, IMAGINARY} <> {} then
//                return(NRange::_or(rg1, rg2) and not NRange("Real"))
//              end_if;
             if NRange::_and(NRange::_negate(rg1), rg2) <> property::Null then
               return(NRange::_or(rg1, rg2, Type::Zero))
             else
               return(NRange::_or(rg1, rg2))
             end_if
           end_proc, args())
        end_proc:

NRange::_subtract:= 
        proc(le, ri)
        begin
          // Sonderfall
          if property::implies(le, Type::Zero) = TRUE then
            // 0 - x = -x
            return(-ri)
          elif testtype(ri, Type::Complex) then // numerischer Wert
            // x - const
            if testtype(ri, Type::Real) then
              if not contains(NRange::sign(le), sign(ri))
                and not contains(sign(le), I) then
                return(property::IV::simplify(property::IV::_subtract(NRange::IV(le), ri)))
              else
                return(NRange::_plus(le, -ri))
              end_if
            else
              return(property::Complex::_subtract(le, ri))
            end_if
          elif testtype(le, Type::Complex) then // numerischer Wert
            return(NRange::_plus(le, -ri))
          end_if;
          property::_Op
          (NRange, _subtract,
           proc(rg1, rg2)
           begin
             return(NRange::_or(rg1, NRange::_negate(rg2)))
           end_proc, args())
        end_proc:

NRange::_negate:= 
        proc(rg)
        begin
          return(NRange(op(NRange::order,
                           op(NRange::_info, [NRange::_o(rg), 3]))))
        end_proc:

NRange::sign:=
        proc(rg)
        begin
          if Excl(rg) <> "Complex" and Excl(rg) <> property::Null then
            op(NRange::_info, [NRange::_o(rg), 1])
            minus _if(Excl(rg) = "Zero", {0}, {})
          else
            op(NRange::_info, [NRange::_o(rg), 1])
          end_if
        end_proc:

NRange::_mult:=
        proc()
          local ret, ret1;
        begin
          if contains({args()}, NRange("Zero")) then
            return(NRange("Zero"))
//        problem: I*infinity
//           elif has(map([args()], type), stdlib::Infinity) then
//             // return 'infinity'
//             return(property::Rel(hold(_equal),
//                                  _plus(select(args(), X -> domtype(X) = stdlib::Infinity))))
          elif contains(map({args()}, domtype), DOM_COMPLEX) then
            ret:= property::Complex::_mult(args());
            if (ret1:= property::_convert(hold(Exact), ret, property::NRange)) <> FAIL then
              return(ret1)
            else
              return(ret)
            end_if
          end_if;
          if contains(map({args()}, type), "Residue") then
            return(property::Residue::_mult(args()))
          end_if;

          property::_Op
           (NRange, _mult,
            proc(rg1, rg2)
              local __o;
            begin
              if rg1 = NRange("Zero") or rg2 = NRange("Zero") then
                return(NRange("Zero"))
              end_if;
// fprint(0, "_mult", rg1, NRange::sign(rg1), rg2, NRange::sign(rg2));
              __o:= _union(NRange::sign(rg1), NRange::sign(rg2));
              ret:= _if(contains(__o, 0), property::Null, "Zero");
              // sonderfall
              if contains({INTIMAGINARY, IMAGINARY} , NRange::_o(rg1)) then
                // Imaginary
                if NRange::is(rg2, Type::Integer) = TRUE then
                  return(NRange::combine(Arg(rg1), ret))
                elif NRange::is(rg2, Type::Real) = TRUE then
                  return(NRange::combine("Imaginary", ret))
                end_if
              elif contains({INTIMAGINARY, IMAGINARY} , NRange::_o(rg2)) then
                // Imaginary
                if NRange::is(rg1, Type::Integer) = TRUE then
                  return(NRange::combine(Arg(rg2), ret))
                elif NRange::is(rg1, Type::Real) = TRUE then
                  return(NRange::combine("Imaginary", ret))
                end_if
              end_if;

              // Sonderfall Type::XX * not Type::XX
              if rg1 = not rg2 then
                if Arg(rg1) = "Complex" or Arg(rg1) = property::Null then
                  return(rg1)
                else
                  return(rg2)
                end_if
              end_if;

              // Sonderfall: beide Excl gleich: behalte Excl!
              if Excl(rg1) = Excl(rg2) then
                ret1:= Excl(rg1)
              else
                ret1:= property::Null
              end_if;
              if contains(__o, 0) then
                // mit Excl
                // _or vergisst Excl!
                return(NRange::combine(Arg(NRange::_or(NRange::combine(Arg(rg1)),
                                                       NRange::combine(Arg(rg2)))), ret1))
              else
                // mit Excl
                ret:= NRange::_or(NRange(op(NRange::order,
                                                     op(NRange::_info,
                                                        [NRange::_o(rg1), 2]))),
                                  NRange(op(NRange::order,
                                                     op(NRange::_info,
                                                        [NRange::_o(rg2), 2]))));
                if __o = {-1} or __o = {1} then
                  return(NRange::combine(Arg(ret), ret1))
                else
                  return(NRange::combine(Arg(NRange::_negate(ret)), ret1))
                end_if
              end_if
            end_proc, args())
        end_proc:

NRange::_divide:=
        proc(x, y)
        begin
          if type(x) = "NRange" and type(y) = "NRange" then
            return(NRange::_mult(x, NRange::_invert(y)))
//             property::_Op
//              (NRange, _divide,
//               proc(rg1, rg2)
//                 local _ret;
//               begin
//                 //if NRange::is(rg1, Type::NonZero) = TRUE then
//                 //  return(rg1)
//                 //else
//                 return(NRange::_mult(rg1, NRange::_invert(rg2)));
//                 //end_if;
//                 _ret:= NRange::_or(NRange(op(NRange::order,
//                                              op(NRange::_info,
//                                                 [NRange::_o(rg1), 3]))),
//                                    NRange(op(NRange::order,
//                                              op(NRange::_info,
//                                                 [NRange::_o(rg2), 3]))));
//                 return(NRange::_or(_ret, NRange::_mult(rg1, rg2)))
//               end_proc, args())
          else
            return(NRange::_mult(x, NRange::_invert(y)))
          end_if
        end_proc:

NRange::_invert:= 
        proc(rg)
        begin
          if type(rg) <> "NRange" then
            _invert(rg)
          else
            // special case: not Real (for simpex)
            if rg = not Type::Real then
              return(rg)
            else
              return(NRange(op(NRange::order,
                               op(NRange::_info, [NRange::_o(rg), 4]))))
            end_if
          end_if
        end_proc:

NRange::_power:=
        proc(NR, pow)
          local k;
        begin
//           nonzero:= case property::_is(NR, Type::Zero)
//                       of TRUE do
//                         return(NR)
//                       of FALSE do
//                         TRUE; break
//                       of UNKNOWN do
//                         FALSE
//                     end_case;
          if type(pow) <> "NRange" and type(NR) = "NRange" and
             property::_is(pow, Type::Real) = TRUE then
            if (k:= property::_is(pow, Type::NonNegative)) = TRUE then
              if (k:= property::_is(pow, Type::Even)) = TRUE then
                return(NRange::combine(op(NRange::order,
                                          op([POSITIVE, ZERO, POSINT, POSINT, NONNEGINT,
                                              POSINT, NONNEGINT, POSRAT, NONNEGRAT,
                                              POSRAT, NONNEGRAT, FRACTION, POSITIVE,
                                              NONNEGATIVE, POSITIVE, IRRATIONAL,
                                              NONNEGATIVE, INTEGER, REAL, COMPLEX,
                                              NFAIL], NRange::_o(NR))),
                                       op(NRange::order,
                                          op([POSITIVE, ZERO, POSINT, POSINT, NONNEGINT,
                                              POSINT, NONNEGINT, POSRAT, NONNEGRAT,
                                              POSRAT, NONNEGRAT, FRACTION, POSITIVE,
                                              NONNEGATIVE, POSITIVE, IRRATIONAL,
                                              NONNEGATIVE, INTEGER, REAL, COMPLEX,
                                              NFAIL], NRange::_o(NR, 2)))))
              elif k = FALSE then
                // odd power
                //return(NR)
              end_if
            elif k = FALSE then // pow Type::Negative
              return(NRange::_and(NRange::_invert(NRange::_power(NR, -pow)),
                                  Type::NonZero))
            else // pow real
              return(NRange::_and(NRange::_or(NRange::_power(NR, abs(pow)),
                                              NRange::_invert(NRange::_power(NR, abs(pow)))),
                                  Type::NonZero))
            end_if
          end_if;
          if type(pow) = "Residue" then
            if property::Residue::modulus(pow) = 0 then
              return(NRange::_power(NR, property::Residue::remainder(pow)))
            else
              // Verallgemeinerung
              return(NRange::_power(NR, property::Residue::range(pow)))
            end_if
          end_if;
          if testtype(pow, Type::Integer) then
            // -> Residue
            if pow >= 0 then
              return(NRange::_and(NRange(op(NRange::order,
                                            op(NRange::_info, [NRange::_o(NR), 5]))),
                                  Type::NonZero))
              //return(NRange::_mult(NR, pow))
            else
              return(NRange::_and(NRange::_invert(NRange::_mult(NR, -pow)),
                                  Type::NonZero))
            end_if
          elif testtype(pow, Type::Rational) then
            // Wurzel(neg)
            if contains(NRange::sign(NR), -1) then
              return(Type::NonZero)
            end_if
          elif property::isrel(NR = -1) = TRUE
               and property::implies(pow, Type::Integer) = TRUE then
            // Sonderfall (-1)^Integer => Integer
            return(Type::Integer)
          end_if;

          property::_Op
           (NRange, _power,
            proc(NR, pow)
              local real;
            begin
              if NR = Type::Zero then
                return(Type::Zero)
//               elif NRange::is(NR, Type::Positive) = TRUE then
//                 return(NRange::_or(NR, NRange(op(NRange::order,
//                                                  op(NRange::_info,
//                                                     [NRange::_o(pow), 5])))))
              elif NRange::is(pow, Type::Integer) = TRUE then
                if contains(sign(NR), -1) then
                  NR:= NRange::_or(NR, NRange::_negate(NR))
                end_if;
                case NRange::is(pow, Type::NonNegative)
                  of TRUE do
                      return(NRange::_mult(NR, pow))
                  of FALSE do
                    return(NRange::_invert(NR))
                  otherwise
                    return(NRange::_or(NR, NRange::_invert(NR)))
                end_case
              elif NRange::is(NR, Type::Integer) = TRUE then
                real:= bool(NRange::is(pow, Type::Real) = TRUE);
                case op(NRange::_info, [NRange::_o(NR), 1]) // sign(NR)
                  of {1} do // > 0
                  of {0, 1} do // >= 0
                    if real then
                      if ((real:= NRange::sign(pow))) intersect {-1, 1} = {-1, 1} then
                        // pow alles
                        return(NRange::_divide(NR, NRange::_and(pow, Type::Positive)))
                      elif not contains(real, -1) then
                        // pow pos
                        if NRange::is(pow, Type::Integer) = TRUE then
                          return(NRange::_mult(NR, pow))
                        elif op(NRange::_info, [NRange::_o(NR), 1]) = {1} then
                          return(Type::Positive)
                        else
                          return(Type::NonNegative)
                        end_if
                      else
                        // pow neg
                        return(NRange::_invert(NRange::_mult(NR, pow)))
                      end_if                      
                    else
                      return(NRange::_or(NR, pow))
                    end_if
                  of {-1, 0, 1} do //
                    return(Type::Complex);
                  of {-1, 1} do // <> 0
                    return(Type::NonZero);
                    //return(NRange::_or(NR, pow, NRange::_invert(NRange::_or(NR, pow))));
                    break
                  of {-1, 0} do // <= 0
                  of {-1} do // < 0
                    return(NRange::_invert(NRange::_or(NR, -pow)));
                    break
                end_case
              else
                case op(NRange::_info, [NRange::_o(pow), 1]) // sign
                  of {0} do // 0
                    return(property::Rel(_equal, 1));
                    break
                  of {1} do // > 0
                  of {0, 1} do // >= 0
                    if NRange::is(pow, Type::Integer) = TRUE then
                      return(NRange::_mult(NR, pow))
                    elif op(NRange::_info, [NRange::_o(NR), 1]) = {1} then
                      return(Type::Positive)
                    else
                      return(NRange::_or(NR, NRange::_and(pow, not Type::Zero)));
                      //return(Type::NonNegative)
                    end_if;
                    break
                  of {-1, 0, 1} do //
                    // NR^abs(pow) or NR^-abs(pow)
                    return(NRange::_or(NRange::_power(NR, NRange::abs(pow)),
                                       NRange::_power(NR, NRange::_and(-NRange::abs(pow),
                                                                       Type::Negative))))
                  of {-1, 1} do // <> 0
                    return(Type::NonZero);
                    //return(NRange::_or(NR, pow, NRange::_invert(NRange::_or(NR, pow))));
                    break
                  of {-1, 0} do // <= 0
                  of {-1} do // < 0
                    return(NRange::_invert(NRange::_or(NR, -pow)));
                    break
                end_case
              end_if;
              Type::Complex
            end_proc, args())
        end_proc:

// Attribute
NRange::abs:=
        proc(NR)
        begin
          NRange(op(NRange::order,
                    //  NZ Ze Pr PI NN NI In PR NN NR Ra Fr Po NN Ne Ir Re In Im Co
                    op([POSITIVE, ZERO, PRIME, POSINT, NONNEGINT, POSINT, NONNEGINT,
                        POSRAT, NONNEGRAT, POSRAT, POSRAT,
                        POSITIVE, POSITIVE, NONNEGATIVE, POSITIVE,
                        POSITIVE, NONNEGATIVE, POSINT, POSITIVE, POSITIVE],
                       NRange::_o(NR))))
        end_proc:

NRange::sin:=
        proc(NR)
        begin
          if NRange::_o(NR) <= REAL then
            property::IV([-1, 1], NRange("Real"))
          else
            Type::Complex
          end_if
        end_proc:

NRange::cos:= NRange::sin:

NRange::ln:=
        proc(NR)
        begin
          NRange(op(NRange::order,
                    //  NZ Ze Pr PI NN NI In PR NN NR Ra Fr Po NN Ne Ir Re In Im Co
                    op([COMPLEX, NFAIL, POSITIVE, REAL, REAL, COMPLEX, COMPLEX,
                        REAL, REAL, COMPLEX, COMPLEX, COMPLEX, REAL, REAL,
                        COMPLEX, COMPLEX, COMPLEX, COMPLEX, COMPLEX, COMPLEX],
                       NRange::_o(NR))))
        end_proc:

NRange::log:=
        proc(base, NR)
        begin
          FAIL
        end_proc:

NRange::exp:=
        proc(NR)
        begin
          if NRange::_o(NR) = ZERO then return(1) end_if;
          if NRange::_o(NR) > REAL then
            NRange("Complex")
          elif NRange::sign(NR) = {1} then
            property::IV([1], infinity, NRange("Positive"))
          else
            NRange("Positive")
          end_if
        end_proc:

NRange::Re:=
        proc(NR)
        begin
          property::Complex::Re(NRange::Complex(NR))
        end_proc:

NRange::Im:=
        proc(NR)
        begin
          property::Complex::Im(NRange::Complex(NR))
        end_proc:

// Konvertierungen
NRange::Rel:=
        proc(XX, Opt = hold(Exact))
          local EX;
        begin
          EX:= Excl(XX);
          case Arg(XX)
            of "NonZero" do
              return(property::Rel(hold(_unequal), 0))
            of "Zero" do
              return(property::Rel(hold(_equal), 0))
            of "NonNegative" do
              return(property::Rel((-1)*hold(_leequal), 0))
            of "Positive" do
              return(property::Rel((-1)*hold(_less), 0))
            of "Negative" do
              return(property::Rel(hold(_less), 0))
            of "Real" do
              if EX <> property::Null then
                return(not NRange::Rel(NRange(EX), Opt))
              else
                if Opt = hold(Exact) then
                  return(property::Rel(hold(_less), infinity))
                end_if
              end_if
            of "IntImaginary" do
            of "Imaginary" do
            of "Complex" do
              if EX <> property::Null then
                return(not NRange::Rel(NRange(EX)))
              else
                return(FAIL)
              end_if
          end_case;
          if Opt <> hold(Exact) or NRange::_o(XX) >= POSITIVE then
            case Arg(XX)
              of "NonNegInt" do
              of "NonNegRat" do
                return(property::Rel((-1)*hold(_leequal), 0))
              of "Prime" do
                return(property::Rel((-1)*hold(_leequal), 2))
              of "PosInt" do
                return(property::Rel((-1)*hold(_leequal), 1))
              of "PosRat" do
                return(property::Rel((-1)*hold(_less), 0))
              of "NegInt" do
              of "NegRat" do
                return(property::Rel(hold(_less), 0))
            end_case
          end_if;
          return(NRange::IV(args()))
        end_proc:

NRange::IV:=
        proc(XX)
        begin
          case Arg(XX)
          of "NonZero" do
            return(hold(_and)(property::IV(-infinity, 0, XX and Type::Negative),
                              property::IV(0, infinity, XX and Type::Positive)))
          of "Zero" do
            return(property::IV([0], [0], Type::Zero))
          of "PosInt" do
            return(property::IV(0, infinity, XX))
          of "Prime" do
            return(property::IV([2], infinity, XX))
          of "NonNegInt" do
            return(property::IV([0], infinity, XX))
          of "NegInt" do
            return(property::IV(-infinity, 0, XX))
          of "PosRat" do
            return(property::IV(0, infinity, XX))
          of "NonNegRat" do
            return(property::IV([0], infinity, XX))
          of "NegRat" do
            return(property::IV(-infinity, 0, XX))
          of "Positive" do
            return(property::IV(0, infinity, XX))
          of "NonNegative" do
            return(property::IV([0], infinity, XX))
          of "Negative" do
            return(property::IV(-infinity, 0, XX))
          of "IntImaginary" do
          of "Imaginary" do
          of "Complex" do
            return(FAIL)
          end_case;
          return(property::IV(-infinity, infinity, XX))
        end_proc:

NRange::Complex:=
        proc(XX)
        begin
          case Arg(XX)
          of "Zero" do
            return(property::Complex(Type::Zero, Type::Zero))
          of "IntImaginary" do
            return(property::Complex(Type::Zero, Type::Integer))
          of "Imaginary" do
            return(property::Complex(Type::Zero, Type::Real))
          of "Complex" do
            return(property::Complex(Type::Real, Type::Real))
          end_case;
          return(property::Complex(XX, Type::Zero))
        end_proc:

NRange::Residue:=
        proc(XX, OPT = hold(Exact))
        begin
          if NRange::is(XX, NRange("Integer")) = TRUE then
            property::Residue::new(0, 1, XX)
          else
            FAIL
          end_if
        end_proc:

//NRange::NAdj:=
//      proc(XX)
//      begin
//        return(property::NAdj(XX, op(NRange::elem(XX), 1)))
//      end_proc:

NRange::Type:=
        proc(XX)
        begin
          if contains(Type, Arg(XX)) then
            return(slot(Type, Arg(XX)))
          end_if;
          return(FAIL)
        end_proc:

NRange::expr:=
        proc(rg, ident = FAIL)
        begin
          if ident = FAIL then
            ident:= genident("ID")
          end_if;
          if Excl(rg) = "Complex" or Excl(rg) = property::Null then // no "Not set"
            ident in NRange::combine(Arg(rg))
          elif Arg(rg) = "Complex" or Arg(rg) = property::Null then // only "Not set"
            not ident in NRange::combine(Excl(rg))
          else // both
            ident in NRange::combine(Arg(rg)) and not ident in NRange::combine(Excl(rg))
          end_if
        end_proc:

NRange::hull:=
        proc(rg)
        begin
          op(NRange::_info, [NRange::_o(rg), 6])
        end_proc:


// #( 1 )# ["NonZero",
// #( 2 )#  "Zero",
// #( 3 )#  "Prime",
// #( 4 )#  "PosInt",
// #( 5 )#  "NonNegInt",
// #( 6 )#  "NegInt",
// #( 7 )#  "Integer",
// #( 8 )#  "PosRat",
// #( 9 )#  "NonNegRat",
// #(10 )#  "NegRat",
// #(11 )#  "Rational",
// #(12 )#  "Fraction",
// #(13 )#  "Positive",
// #(14 )#  "NonNegative",
// #(15 )#  "Negative",
// #(16 )#  "Irrational",
// #(17 )#  "Real",
// #(18 )#  "IntImaginary",
// #(19 )#  "Imaginary",
// #(20 )#  "Complex",
// #(21 )#  "FAIL"]:

alias(SB = solvelib::BasicSet):
alias(DI = Dom::ImageSet):
NRange::prop2set:=
        proc(rg)
          local PR;
        begin
          PR:=
            proc(XX)
              local ID;
            begin
              case XX
                of "NonZero" do
                  return(hold(_minus)(SB(Dom::Complex), {0}))
                of "Zero" do
                  return({0})
                of "PosInt" do
                  return(hold(_intersect)(SB(Dom::Integer), Dom::Interval(0, infinity)))
                of "Prime" do
                  warning("The property 'Type::Prime' doesn't have an equivalent set now.");
                  return(FAIL)
                of "NonNegInt" do
                  return(hold(_intersect)(SB(Dom::Integer), Dom::Interval([0], infinity)))
                //of "NonPosInt" do
                //  return(hold(_intersect)(SB(Dom::Integer), Dom::Interval(-infinity, [0])))
                of "NegInt" do
                  return(hold(_intersect)(SB(Dom::Integer), Dom::Interval(-infinity, 0)))
                of "PosRat" do
                  return(hold(_intersect)(SB(Dom::Rational), Dom::Interval(0, infinity)))
                of "NonNegRat" do
                  return(hold(_intersect)(SB(Dom::Rational), Dom::Interval([0], infinity)))
                //of "NonPosRat" do
                //  return(hold(_intersect)(SB(Dom::Rational), Dom::Interval(-infinity, [0])))
                of "NegRat" do
                  return(hold(_intersect)(SB(Dom::Rational), Dom::Interval(-infinity, 0)))
                of "Fraction" do
                  return(hold(_minus)(SB(Dom::Rational), SB(Dom::Integer)))
                of "Irrational" do
                  return(hold(_minus)(SB(Dom::Real), SB(Dom::Rational)))
                of "Positive" do
                  return(hold(_intersect)(SB(Dom::Real), Dom::Interval(0, infinity)))
                of "NonNegative" do
                  return(hold(_intersect)(SB(Dom::Real), Dom::Interval([0], infinity)))
                //of "NonPositive" do
                //  return(hold(_intersect)(SB(Dom::Real), Dom::Interval(-infinity, [0])))
                of "Negative" do
                  return(hold(_intersect)(SB(Dom::Real), Dom::Interval(-infinity, 0)))
                of "Real" do
                  return(SB(Dom::Real))
                of "IntImaginary" do
                  ID:= genident("Y");
                  return(DI(I*ID, [ID], [SB(Dom::Integer)]))
                of "Imaginary" do
                  ID:= genident("Y");
                  return(DI(I*ID, [ID], [SB(Dom::Real)]))
                of "Integer" do
                of "Rational" do
                of "Real" do
                of "Complex" do
                  return(SB(slot(Dom, XX)))
              end_case
            end_proc;
          if Excl(rg) = property::Null then
            PR(Arg(rg))
          elif Arg(rg) = property::Null or Arg(rg) = "Complex" then
            hold(_not)(PR(Excl(rg)))
            //hold(_and)(PR("Complex"), hold(_not)(PR(Excl(rg))))
          else
            hold(_and)(PR(Arg(rg)), hold(_not)(PR(Excl(rg))))
          end_if
        end_proc:
unalias(SB):
unalias(DI):

NRange::Z:= "of ":

NRange::print:=
        proc(XX)
        begin
          if Excl(XX) = property::Null then
            hold(slot)(Type, op(XX, 1))
          elif Arg(XX) = "Complex" or Arg(XX) = property::Null then
            hold(_not)(hold(slot)(Type, Excl(XX)))
          else
            if op(XX, 1) <> Arg(XX) then
              hold(slot)(Type, op(XX, 1))
            else
              hold(_and)(hold(slot)(Type, op(XX, 1)), hold(_not)(hold(slot)(Type, Excl(XX))))
            end_if
          end_if
        end_proc:

// NRange::Content:=
//         proc()
//         begin
//          
//         end_proc:
                 
unalias(Arg):
unalias(NRange):
