// $Date: 2002/02/22 11:38:53 $ $Author: bij $ $Revision: 1.27 $

// converts a property expression 
property::prop2set:=
        proc(EX, SUBSFAIL = FALSE)
        begin
          if domtype(EX) = DOM_EXPR then
            case type(EX)
              of "_or" do
                EX:= map([op(EX)], property::prop2set, SUBSFAIL);
                if contains(map(EX, testtype, Type::Set), TRUE) > 0 then
                  _union(op(EX))
                else // relations
                  _or(op(EX))
                end_if;
                break
              of "_and" do
                EX:= map([op(EX)], property::prop2set, SUBSFAIL);
                if contains(map(EX, testtype, Type::Set), TRUE) > 0 then
                  _intersect(op(EX))
                else // relations
                  _and(op(EX))
                end_if;
                break
              of "_not" do
                EX:= property::prop2set(op(EX), SUBSFAIL);
                if testtype(EX, Type::Set) and domtype(EX) <> DOM_IDENT then
                  C_ minus EX
                else
                  not EX
                end_if;
                break
              of "_in" do
                if testtype(property::prop2set(op(EX, 2), op(EX, 1)), Type::Relation) then
                  property::prop2set(op(EX, 2), op(EX, 1))
                else
                  _in(op(EX, 1), property::prop2set(op(EX, 2), SUBSFAIL))
                end_if;
                break
              otherwise
                EX //error("Unknown type '".type(EX)."' of property")
            end_case
          elif SUBSFAIL <> FALSE
               and testtype(property::convertSets(EX, Type::Relation), Type::Relation) then
            subs(property::convertSets(EX, Type::Relation), FAIL = SUBSFAIL)
          elif contains([FAIL, EX], property::convertSets(EX, Type::Set)) = 0 then
            property::convertSets(EX, Type::Set)
          elif EX::dom = property then
            return(op([EX, {}], contains([property::Null], EX) + 1))
          elif contains(EX::dom, "prop2set") then
            EX::dom::prop2set(EX)
          else
            EX
          end_if
        end_proc:

// 
property::convertSets:=
  proc(EX, TO = Type::Property)
  begin
    if testtype(EX, TO) then
      EX
    elif testtype(EX, Type::Relation) then
      if TO = Type::Set then
        return(property::convertSets(EX::dom::set2prop(EX), Type::Property))
      elif TO = Type::Property then
        return(property::convert_to(EX, property::NRange, hold(Sloppy)))
      end_if
    elif testtype(EX, Type::Set) then
      if TO = Type::Relation then
        if EX = {} then
          return(FALSE)
        elif EX = C_ then
          return(TRUE)
        else
//           TO:= expr(property::convert_to(property::convertSets(EX, Type::Property),
//                                          property::Rel));
//           if TO <> FAIL then
            return(EX)
//           else
//             return(TRUE)
//           end_if
        end_if
      elif TO = Type::Property then
        return(property::convert_to(EX, solvelib::set2prop(EX)))
      end_if
    elif testtype(EX, Type::Property) then
      if TO = Type::Set then
        return(slot(slot(property, type(EX)), "prop2set")(EX))
      elif TO = Type::Relation then
        // !! returns "Rel"
        if contains({"_and", "_or"}, type(EX)) then
          return(map(EX, X -> property::Rel::expr(property::convert_to(X, property::Rel), FAIL)))
        else
          return(property::Rel::expr(property::convert_to(EX, property::Rel), FAIL))
        end_if
      end_if
    elif domtype(EX) = DOM_BOOL then
      if TO = Type::Set then
        //return(op([C_, {}, {}], contains([TRUE, UNKNOWN, FALSE], EX)))
        return(EX)
      elif TO = Type::Relation then
        return(EX)
      elif TO = Type::Property then
        return(op([Type::Complex, property::Null, property::Null],
                  contains([TRUE, UNKNOWN, FALSE], EX)))
      end_if
    elif type(EX) = "_and" or type(EX) = "_or" then
      return(map(EX, property::convertSets, TO))
    end_if;
    EX
  end_proc:

//
property::checkOp:=
  proc(EX, TO = Type::Property)
  begin
    if TO = Type::Property or TO = Type::Relation then
      if type(EX) = "_intersect"
         and contains(map([op(EX)], testtype, Type::Set), TRUE) <> 0 then
        subsop(EX, 0 = _and)
      elif type(EX) = "_union"
         and contains(map([op(EX)], testtype, Type::Set), TRUE) <> 0 then
        subsop(EX, 0 = _or)
      elif type(EX) = "_minus"
         and contains(map([op(EX)], testtype, Type::Set), TRUE) <> 0 then
        subsop(EX, 0 = _and, 2 = _not(op(EX, 2)))
      else
        EX
      end_if
    elif TO = Type::Set then
      if type(EX) = "_and"
         and contains(map([op(EX)], testtype, Type::Set), TRUE) = 0 then
        subsop(EX, 0 = _intersect)
      elif type(EX) = "_or"
         and contains(map([op(EX)], testtype, Type::Set), TRUE) = 0 then
        subsop(EX, 0 = _union)
      elif type(EX) = "_not"
         and contains(map([op(EX)], testtype, Type::Set), TRUE) = 0 then
        _minus(C_, op(EX))
      else
        EX
      end_if
    else
      EX
    end_if;
  end_proc:

// Konvertierung - Schnittstelle 
property::convert_to:=
        proc(prop, _to = FAIL, Opt = FAIL, _dir = FAIL)
          local ret, k;
          //option remember;
        begin
          // kein Ziel
          if _to = FAIL then
            // numerisch
            if Opt = hold(Exact) then
              if contains(Type::ConstantIdents, prop) then
                return(property::Rel(_equal, prop))
              elif not(contains({DOM_INT, DOM_RAT, DOM_FLOAT}, domtype(prop))) and
                contains({DOM_FLOAT, DOM_COMPLEX}, domtype((ret:= property::carefloat(prop)))) then
                //return(ret)
                return(property::Rel(_equal, prop))
              end_if
            end_if;
            return(prop)
          end_if;
          // expressions
          if domtype(prop) = DOM_EXPR then
            if contains({DOM_FLOAT, DOM_COMPLEX}, domtype((ret:= property::carefloat(prop)))) then
              return(property::_convert(Opt, ret, _to, _dir))
            elif contains(["RootOf", "log", "int", "diff"], type(prop)) > 0 then
              return(prop)
            elif type(prop) = "_index" and domtype(op(prop, 1)) = DOM_IDENT then
              // kein 'map'!
              if (ret:= property::_getprop(prop)) <> prop then
                return(property::_convert(Opt, ret, _to, _dir))
              else
                return(prop)
              end_if
            elif domtype((k:= eval(op(prop, 0)))) = DOM_FUNC_ENV then // DOM_FUNC_ENV
              ret:= map([op(prop)], property::convert_to, _to, Opt, _dir);
              if property::isOverloaded(type(prop), ret) then
                return(property::_convert(Opt, k(op(ret)), _to, _dir))
              else
                return(prop)
              end_if
            else
              return(prop)
            end_if
          end_if;
          
          property::_convert(Opt, prop, _to, _dir)
        end_proc:

property::_convert:=
        proc(Opt = hold(Exact), prop = property::Unknown, _to = FAIL, _dir = FAIL)
          local ret;
        begin
          if property::Fail(prop) then
            return(prop)
          end_if;
          if domtype(_to) <> DOM_DOMAIN then
            _to:= _to::dom
          end_if;
          // nichts zu konvertieren
          if prop::dom = _to then
            return(prop)
          end_if;

//           if Opt = hold(Subset) then
            
//           end_if;

          // Generierung von Eigenschaften, Konvertierung
          _to:= _if(_to::type <> FAIL, _to::type, expr2text(_to));
          //userinfo(3, "convert_to: ".expr2text(prop)." --> ".expr2text(_to));
          ret:= slot(prop::dom, _to)(prop, Opt, _dir);
          if ret <> FAIL then
            return(ret)
          end_if;

          //if testtype(prop, Type::Constant) then
          //  return(property::_convert(Opt, property::Rel(_equal, prop), _to, _dir))
          //end_if;

          // System-Konstanten und auswertbare Funktionen
          if Opt = hold(Exact) and contains({DOM_IDENT, DOM_EXPR}, domtype(prop)) then
            if contains(Type::ConstantIdents, prop) then
              return(property::Rel(_equal, prop))
            elif testtype(prop, Type::Constant) and testtype(prop, Type::Arithmetical) then
              return(property::_convert(Opt, property::Rel(_equal, prop), _to, _dir))
              //elif domtype((ret:= float(prop))) <> domtype(prop) then
              //  //userinfo(9, "convert_to: float ".expr2text(ret));
              //  return(property::convert_to(ret, _to))
            end_if
          end_if;
          if domtype(prop) = DOM_EXPR then
            return(FAIL)
          end_if;
          // solver
          if contains(prop::dom, "set2prop") then
            return(prop::dom::set2prop(prop))
          end_if;

          // nicht konvertieren?
          return(prop)
        end_proc:

// DOM_EXPR - keine Kern-Typen
// check whether the given argument is really complex
property::carefloat:=
  proc(x)
    local xf, xff, x12, x22;
  begin
    // float test
    xf:= float(x);
    if domtype(xf) <> DOM_COMPLEX then
      // "real" mode
      return(xf) // ??? xf
    end_if;
    if iszero(xf) then
      // ??? UNKNOWN
      DIGITS:= DIGITS + 10;
      xff:= float(x);
      DIGITS:= DIGITS - 10;
      if iszero(xff) then
        return(0.0)
      else
        return(x)
      end_if
    end_if;
    // Heuristics: increase DIGITS to verify that t is not complete round-off trash
    // We need at least DIGITS + 10 to make sure, that PARI adds a further block
    //x11:= specfunc::abs(op(xf, 1));
    x12:= specfunc::abs(op(xf, 2));
    DIGITS:= DIGITS + 10;
    xff:= float(x);
    DIGITS:= DIGITS - 10;
    if domtype(xff) <> DOM_COMPLEX then
      // ??? UNKNOWN
      return(op(xf, 1))
    else
      //x21:= specfunc::abs(op(xff, 1));
      x22:= specfunc::abs(op(xff, 2))
    end_if;
    // the leading digit of x1 is reliable, if 1/2 < x1/x2 < 2;
    if x12 < 2*x22 and x22 < 2*x12 then
      return(xf)
    else
      // ??? UNKNOWN
      return(op(xf, 1))
    end_if
  end_proc:

// check whether a func env is overloaded
// 
property::isOverloaded:=
  proc(TYP, OPR)
  begin
    if contains(["_plus", "_subtract", "_negate", "_mult",
                 "_divide", "_invert", "_power"], TYP) = 0 then
         // not only single properties?
      if contains(map(OPR, X -> contains(X::dom, "prop")), FALSE) <> 0
         // no overloading method?
         or contains(map(OPR, X -> contains(X::dom, TYP)), TRUE) = 0 then
        FALSE
      else
        TRUE
      end_if
    else
      TRUE
    end_if
  end_proc:

property::_convert:= prog::remember(property::_convert, property::depends):
