// $Date: 2002/03/04 10:02:14 $ $Author: stefanw $ $Revision: 1.79 $

// Mengen statt Eigenschaften
property::SET:= FALSE:

// Werte von property::isxRel
alias(t_t = 0):alias(i_t = 1):alias(e_t = 2):alias(p_t = 3):alias(t_i = 4):alias(i_i = 5):
alias(e_i = 6):alias(p_i = 7):alias(t_e = 8):alias(i_e = 9):alias(e_e = 10):
alias(p_e = 11):alias(t_p = 12):alias(i_p = 13):alias(e_p = 14):alias(p_p = 15):

// Vereinfachungen fur property::simpex
property::simpex:=
  proc(BL = TRUE, OPT = FAIL)
    local SPLIT, RET, LIT, R, i, TYP;
  begin
    //
    if contains([TRUE, UNKNOWN, FALSE, undefined], BL) <> 0 then
      if BL = undefined then
        return(FALSE)
      else
        return(BL)
      end_if
    end_if;

    // do not expand single '_in' expressions
    if type(BL) <> "_in" and OPT = FAIL then
      BL:= expand(BL)
    end_if;
    
    sysassign(property::SET, not testtype(BL, Type::Property));

    // Typ merken
    TYP:= property::_simpexType(BL);

    if domtype(BL) <> DOM_EXPR then
      return(property::_simpex(BL, OPT))
    end_if;

    // schnelle Ueberladung eingefuegt. Stefan
    if type(BL) = "_in" and (R:=(op(BL, 2))::dom::simpexIn) <> FAIL then
      return(R(op(BL, 1), op(BL, 2)))
    end_if;
      
    SPLIT:= split([op(BL)], X->bool(contains(["_and", "_or"/*, "_not"*/], type(X)) <> 0));
    // Literale einzeln vereinfachen
    if nops(op(SPLIT, 2)) > 0 then
      R:= property::_simpex(op(BL, 0)(op(op(SPLIT, 2))), OPT)
    else
      R:= null()
    end_if;
    if R = TRUE then
      if contains(["_or", "_not"], type(BL)) <> 0 then
        return(TRUE)
      end_if
    elif R = FALSE then
      if contains(["_not", "_and"], type(BL)) <> 0 then
        return(FALSE)
      end_if
    end_if;

    LIT:= R;
    if nops(op(SPLIT, 1)) = 0 then //keine Teilbaume
      BL:= R
    else
      RET:= op(SPLIT, 1);
      for i from 1 to nops(RET) do
        R:= property::simpex(op(RET, i));
        if R = TRUE then
          if contains(["_or", "_not"], type(BL)) <> 0 then
            return(TRUE)
          end_if
        elif R = FALSE then
          if contains(["_not", "_and"], type(BL)) <> 0 then
            return(FALSE)
          end_if
        end_if;
        RET:= subsop(RET, i = R, Unsimplified);
      end_for;

      // special case: 'intersect' or 'union' of boolean formulas (from 'solve')
      BL:= property::checkOp(BL, Type::Property);
      BL:= property::_simpex(op(BL, 0)(LIT, op(RET)), OPT);
    end_if;

    // prevent loops with 'prog::remember'
    R:= BL; RET:= BL; i:= [BL]; // init
    while (R:= property::simp(RET)) <> RET
          and contains(i, R) = 0 do // change
      // keep simplification
      i:= append(i, R);
      R:= property::simpex(R, hold);
      if property::complexity(R) < property::complexity(BL) then // measure complexity
        BL:= R;
      end_if;
      RET:= R
    end_while;

    // re-simplify after simpex
//     if contains(["_and", "_or"], type(BL)) <> 0 then
//       R:= BL; RET:= BL; i:= [BL]; // init
//       while (R:= property::reSimp(RET)) <> RET
//             and contains(i, R) = 0 do // change
//         // keep simplification
//         i:= append(i, R);
//         if property::complexity(R) < property::complexity(BL) then // measure complexity
//           BL:= R;
//         end_if;
//         RET:= R
//       end_while
//     end_if;

    if domtype(BL) <> DOM_BOOL and not testtype(BL, Type::Property) then
      // re-transformation
      property::checkOp(property::convertSets(BL, TYP), TYP)
    else
      BL
    end_if
  end_proc:

// prevent recursion because of 'while' and loop simplifications,
// regard properties (property::depends)
property::simpex:= prog::remember(property::simpex, property::depends, hold(PreventRecursion), id):

property::simp:=
  proc(BL)
    local m;
  begin
    if (m:= expand(BL)) <> BL then
      m
    // using match
    elif (m:= match(BL, `#A` and `#C` or `#B` and `#C`,
                    hold(Cond) = {`#A` <> TRUE and `#B` <> TRUE and `#C` <> TRUE})) <> FAIL then
      subs((`#A` or `#B`) and `#C`, m)
    elif (m:= match(BL, `#A` and `#B` or `#A` and `#C`,
                    hold(Cond) = {`#A` <> TRUE and `#B` <> TRUE and `#C` <> TRUE})) <> FAIL then
      subs(`#A` and (`#B` or `#C`), m)
//     elif (m:= match(BL, `#A` and `#B` or `#C`)) <> FAIL then
//       subs((`#A` and `#B`) or (`#A` and `#C`), m)
//     elif (m:= match(BL, `#A` and `#C` or `#B` and `#C`)) <> FAIL then
//       subs((`#A` or `#B`) and `#C`, m)
//     wird wieder zurck-vereinfacht wegen hherer Bewertung
//     elif type(BL) = "_or" and (m:= match(BL, `#ID` < `#CONST` or `#ID` > `#CONST`)) <> FAIL then
//       subs(_and(`#ID` <> `#CONST`, `#ID` in R_), m)
    elif contains(["_and", "_or"], type(BL)) <> 0 then
//       if op((m:= split([op(BL)], X -> type(X) = "_equal"
//                                    and domtype(op(X, 1)) = DOM_IDENT
//                                    and testtype(op(X, 2), Type::Constant))), 1) <> [] then
//         // substitute constant values to equalities        
//       else
        map(BL, property::simp)
//       end_if
    elif type(BL) = "_equal"
         and (type(op(BL, 1)) = "_mult" and iszero(op(BL, 2))
              or type(op(BL, 2)) = "_mult" and iszero(op(BL, 1))) then
      _or(map(op(op(BL, _if(iszero(op(BL, 2)), 1, 2))), _equal, 0))
    elif type(BL) = "_unequal"
         and (type(op(BL, 1)) = "_mult" and iszero(op(BL, 2))
              or type(op(BL, 2)) = "_mult" and iszero(op(BL, 1))) then
      _and(map(op(op(BL, _if(iszero(op(BL, 2)), 1, 2))), _unequal, 0))
    // 1/m = 0
    elif type(BL) = "_equal"
         and (type(op(BL, 1)) = "_power" and op(BL, [1, 2]) = -1 and iszero(op(BL, 2))
              or type(op(BL, 2)) = "_power" and op(BL, [2, 2]) = -1 and iszero(op(BL, 1))) then
      FALSE
    else
      BL
    end_if
  end_proc:

property::reSimp:=
  proc(BL)
    local m;
  begin
    // using match
    if (m:= match(BL, `#A` and `#C` or `#B` and `#C`,
                    hold(Cond) = {`#A` <> TRUE and `#B` <> TRUE and `#C` <> TRUE})) <> FAIL then
      subs((`#A` or `#B`) and `#C`, m)
    elif (m:= match(BL, `#A` and `#B` or `#A` and `#C`,
                    hold(Cond) = {`#A` <> TRUE and `#B` <> TRUE and `#C` <> TRUE})) <> FAIL then
      subs(`#A` and (`#B` or `#C`), m)
//     elif type(BL) = "_and" and
//          op((m:= split(BL, X -> type(X) = "_unequal"
//                                 and (domtype(op(X, 1)) = DOM_IDENT
//                                      or domtype(op(X, 2)) = DOM_IDENT))), 1) <> TRUE then
//       // collect ident <> constant ==> not ident in {constant, ...}
//       for k in indets(op(m, 1)) do
//         c:= select()
//       end_for;
      

//     elif (m:= match(BL, `#A` and `#B` or `#C`)) <> FAIL then
//       subs((`#A` and `#B`) or (`#A` and `#C`), m)
//     elif (m:= match(BL, `#A` and `#C` or `#B` and `#C`)) <> FAIL then
//       subs((`#A` or `#B`) and `#C`, m)
//     // wird wieder zurck-vereinfacht wegen hherer Bewertung
//     elif type(BL) = "_or" and (m:= match(BL, `#ID` < `#CONST` or `#ID` > `#CONST`)) <> FAIL then
//       subs(_and(`#ID` <> `#CONST`, `#ID` in R_), m)
//     elif contains(["_and", "_or"], type(BL)) <> 0 then
//       map(BL, property::reSimp)
//     elif type(BL) = "_equal"
//          and (type(op(BL, 1)) = "_mult" and iszero(op(BL, 2))
//               or type(op(BL, 2)) = "_mult" and iszero(op(BL, 1))) then
//       _or(map(op(op(BL, _if(iszero(op(BL, 2)), 1, 2))), _equal, 0))
//     elif type(BL) = "_unequal"
//          and (type(op(BL, 1)) = "_mult" and iszero(op(BL, 2))
//               or type(op(BL, 2)) = "_mult" and iszero(op(BL, 1))) then
//       _and(map(op(op(BL, _if(iszero(op(BL, 2)), 1, 2))), _unequal, 0))
    else
      BL
    end_if
  end_proc:

// property::simp:= prog::remember(property::simp, property::depends, hold(PreventRecursion), id):

property::_simpexType:=
  proc(EX)
  begin
    case type(EX)
      of "_intersect" do
      of "_union" do
        Type::Set; break
      of "_and" do
      of "_or" do
      of "_not" do
        Type::Relation; break
      otherwise
        Type::AnyType
    end_case
  end_proc:

// 
property::_simpex:=
        proc(EX, OPT = hold(None))
          local TEST, k, i, REAL, NOTREAL, M, IN, RET, R, OPR, Rnorm;
        begin
          if contains([TRUE, FALSE, UNKNOWN], EX) <> 0 then
            return(EX)
          end_if;

          // check single expression
          TEST:=
            proc(X)
              local k;
            begin
              if contains(["_and", "_or"], type(X)) <> 0
                 or testtype(X, Type::Property) then
                UNKNOWN
              elif (k:= contains([C_, {}], X)) <> 0 then
                op([TRUE, FALSE], k)
              elif type(X) = "_not" then
                not TEST(op(X))
              elif type(X) = "_in" then
                // discont:
                if type(op(X, 2)) <> "function" then
                  property::_is(X)
                else
                  UNKNOWN
                end_if
              elif property::Fail(X) then
                UNKNOWN
              elif property::isxRel(X) = t_t and traperror((k:= bool(X))) = 0 then
                k
              elif nops(indets(X) minus Type::ConstantIdents) = 0
                   and (k:= is(X)) <> UNKNOWN then
                k
              elif domtype(X) = DOM_IDENT and property::_getprop(X) = X then
                UNKNOWN
              elif nops((k:= indets(X))) = 1                 // PI, EULER, CATALAN
                   and (property::_getprop(op(k)) = op(k) or testtype(X, Type::Constant))
                   and (k:= property::_is(X)) <> UNKNOWN then
                k
              elif (k:= property::isrel(X)) <> UNKNOWN then
                k
              else
                UNKNOWN
              end_if
            end_proc;

          // check any single condition
          if type(EX) = "_not" then
            return(_not(property::_simpex(op(EX), OPT)))
          elif type(EX) = "_and" or type(EX) = "_intersect" then
            RET:= map(EX, X->op([hold(null)(), FALSE, X],
                                contains([TRUE, FALSE, UNKNOWN], TEST(X))));
            if has(RET, FALSE) then return(FALSE) end_if
          elif type(EX) = "_or" or type(EX) = "_union" then
            RET:= map(EX, X->op([TRUE, hold(null)(), X],
                                contains([TRUE, FALSE, UNKNOWN], TEST(X))));
            if has(RET, TRUE) then return(TRUE) end_if
          else
            k:= TEST(EX);
            if k <> UNKNOWN then
              return(k)
            else
              RET:= EX
            end_if
          end_if;

          RET:= eval(RET);

          if RET = null() then
            return(op([TRUE, FALSE], contains([hold(_and), hold(_or)], op(EX, 0))))
          end_if;

          // try to normalize literals
          Rnorm:= RET;
          if OPT <> hold(Unsimplified) then
            Rnorm:= property::normalize(RET)
          end_if;
//           if contains(["_and", "_or"], type(RET)) <> 0 then
//             if type((R:= property::normalize(RET))) <> type(RET)
//               or nops(R) < nops(RET) then
//               RET:= R;
//               Rnorm:= R
//             end_if
//           end_if;

          //////////////////////////////////////////////////////////////////////
          //////////////////////////////////////////////////////////////////////
	  IN:= indets(Rnorm) minus Type::ConstantIdents; //{PI, EULER, CATALAN};
          // more than one identifier
          // -> Ex2Rx: convert to properties and use property mechanism
          //           to simplify properties
          if nops(IN) <> 0 then
            // collect real/not real information about identifiers
            NOTREAL:= {};
            map([op(Rnorm)],
                X -> (if type(X) = "_not" then
                        //if contains({"_less", "_leequal"}, type(op(X))) then
                        //  NOTREAL:= NOTREAL union indets(op(X))
                        if type(op(X)) = "_in"
                           and domtype(op(X, [1, 1])) = DOM_IDENT
                           and property::implies(Type::Real,
                                                 property::convertSets(op(X, [1, 2]))) = TRUE then
                          NOTREAL:= NOTREAL union indets(X)
                        end_if;
                      end_if));
            REAL:= {};
            //rel:= FALSE; // real?
            map([op(Rnorm)],
                X -> (if contains({"_less", "_leequal"}, type(X)) then
                        REAL:= REAL union indets(X)
                      elif type(X) = "_in"
                           and domtype(op(X, 1)) = DOM_IDENT
                           and property::implies(op(X, 2), Type::Real) = TRUE then
                        REAL:= REAL union indets(X);
                      end_if;
                      ));
            if (REAL intersect NOTREAL) <> {} and type(Rnorm) = "_and" then
              return(FALSE)
            end_if;
          end_if;
	  if nops(IN) > 1 and contains(["_and", "_or", "_not"], type(Rnorm)) <> 0 then
             //and map({op(EX)}, type) intersect {"_and", "_or", "_not"} = {} then
            if type(Rnorm) = "_not" then
              TEST:= [UNKNOWN, Rnorm, UNKNOWN]
            else
              TEST:= split(Rnorm,
                           X -> contains(["_and", "_or"], type(X)) = 0); // also "_not"??
            end_if;
            // perform the following only with simple conditions
            M:= [];
            // operator
            OPR:= _if(domtype(op(TEST, 2)) <> DOM_BOOL, op(Rnorm, 0), op(TEST, [1, 0]));
            
            for k in IN do
              if type((R:= op(TEST, 1))) = "_and" or type(R) = "_or" then
                i:= select(R, has, k);
                if i <> op([TRUE, FALSE], contains(["_and", "_or"], type(R))) then
                  R:= property::Ex2Rx(i, k, REAL, NOTREAL);
                else
                  next//R:= property::Ex2Rx(R, k, REAL, NOTREAL)
                end_if
              elif has(R, k) then
                R:= property::Ex2Rx(R, k, REAL, NOTREAL);
              else
                R:= k
              end_if;
              if type(Rnorm) = "_and" and contains({FALSE, property::Null}, R) then
                return(FALSE)
              elif type(Rnorm) = "_or" and contains({TRUE, Type::Real}, R) then
                return(TRUE)
              //else
              end_if;
              if R <> k then // skip single idents
                M:= append(M, [R, k])
              elif domtype(op(TEST, 2)) <> DOM_EXPR or op(TEST, [2, 0]) = OPR then
                // don't forget single idents
                TEST:= subsop(TEST, 2 = eval(OPR(op(op(TEST, 2)), k)))
              end_if
            end_for;
            if M <> [] then
              R:= map(M, op, 1);
              i:= bool(k = _and);
              if contains(R, not i) <> 0 then // return TRUE/FALSE
                return(FALSE)
              elif contains(R, i) <> 0 then   // remove TRUE/FALSE
                M:= zip(M, R, (X, Y) -> if Y = i then
                                          null()
                                        else
                                          X
                                        end_if)
              end_if;
              R:= OPR(op(map(M, X -> property::simpexpr(op(X, 1), op(X, 2)))),
                      // skip zero elements of '_and'/'_or'
                      _if(domtype(op(TEST, 2)) = DOM_BOOL, null(), op(TEST, 2)));
            else
              R:= Rnorm
            end_if;

// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// !!!!!!!!!!!!!!! auch letzten Zweig ausprobieren !!!!!!!!!!!!!!!!
          // constant expression
          // -> Ex2Rx
          elif nops(IN) = 0 then
            //if testtype(RET, Type::Property) then
            //  return(RET)
            if traperror((IN:= bool(Rnorm))) = 0 then
              return(IN)
            elif traperror((IN:= bool(float(Rnorm)))) = 0 then
              return(IN)
            else
              return(Rnorm)
            end_if
          // one identifier, use all expressions
          // -> Ex2Rx
          elif nops(IN) = 1 then
            R:= property::Ex2Rx(Rnorm, op(IN), REAL, NOTREAL);
            // subs identifier with the found properties
//             if hastype(R, DOM_IDENT) = TRUE then // identifier (relation, function)
//               case type(R)
//                 of "_in" do
//                   if testtype(op(R, 2), Type::Property) then
//                     TEST:= subs(R, op(IN) = op(R, 2))
//                   end_if; break
//                 of "_and" do
//                 of "_or" do
//                   R:= subs(R, op(IN) = select(R, testtype, Type::Property));
//                   break
//               end_case
//             end_if;
            R:= property::simpexpr(R, op(IN))
          else // do nothing
            R:= Rnorm
          end_if;
          // simplification - because of weekness of 'NRange' with 'not'
          if REAL union NOTREAL <> {} then
            if type(Rnorm) = "_and"
               and (i:= property::_simpreal(eval(R), REAL, NOTREAL)) = FALSE then
              return(FALSE)
            end_if
          end_if;

          // re-transformation
          // property::Ex2RxMulti(RET, op(IN))
	  if (i:= contains([Type::Real, property::Null], R)) > 0 then
            return(op([TRUE, FALSE], i))
          elif R = UNKNOWN then
            R:= Rnorm
          else
            R:= eval(R)
          end_if;

          if domtype(R) <> DOM_BOOL and property::SET then
            R:= property::prop2set(R)
          end_if;

          // result more complex than input after normalize
          if property::complexity(Rnorm) <= property::complexity(R) then
            Rnorm
          else
            R
          end_if

	end_proc:

// prevent recursion because of 'while' and loop simplifications,
// regard properties (property::depends)
property::_simpex:= prog::remember(property::_simpex, property::depends, hold(None), id):

// prop -> expr
property::simpexpr:=
	proc(PR, ident)
          local iv, rg;
        begin
          if PR = Type::Complex or PR = C_ then
            return(TRUE)
          end_if;
          if type(PR) = "IV" then
            if (iv:= property::IV::simplify(PR)) <> PR then
              return(property::simpexpr(iv, ident))
            end_if;
            if PR = property::IV(-infinity, infinity) then
              ident in Type::Real
            else
              if property::implies(property::IV::NRange(PR), Type::Integer) = TRUE then
                if op(op(PR, 2)) - op(op(PR, 1)) < 10 then
                  return(ident in {k $ k = op(op(PR, 1))..op(op(PR, 2))})
                else
                  return(property::IV([op(op(PR, 1)), op(op(PR, 2))]) intersect Type::Integer)
                end_if
              end_if;
              iv:= property::IV::Rel(PR, hold(Approx));
              rg:= property::IV::NRange(PR);
              if property::NRange::is(rg, Type::Rational) = TRUE then
                rg:= ident in rg
              else
                rg:= TRUE
              end_if;
              if contains(["_and", "_or", "_not"], type(iv)) <> 0 then
                map(iv, property::simpexpr, ident) and rg
              elif rg <> TRUE and property::IV::NRange(PR, hold(Exact)) <> FAIL then
                property::simpexpr(iv, ident) // rg?
              // forget the range for equalities
              elif op(iv, 0) = _equal then
                property::simpexpr(iv, ident) // rg?
              else
                property::simpexpr(iv, ident) and rg
              end_if
            end_if
          elif type(PR) = "Rel" then
            if PR = property::Rel(_less, infinity)
               or PR = property::Rel(-_less, -infinity) then
              return(ident in R_)
            end_if;
            rg:= property::Rel::expr(PR, ident);
            // check relation
            if (iv:= is(rg)) <> UNKNOWN then
              return(property::simpex(iv, ident))
            end_if;
            if type(rg) = "_equal" then
              _equal(op(sort([op(rg)], sysorder)))
            elif type(rg) = "_unequal" then
              _unequal(op(sort([op(rg)], sysorder)))
            elif op(rg, 2) = infinity then
              ident in Type::Real
            else
              rg
            end_if
          elif contains([solvelib::BasicSet, Dom::ImageSet, "NRange", "Complex", DOM_SET],
                        type(PR)) <> 0 then
            if type(PR) = "NRange" then
              // ? ident
              property::NRange::expr(PR, ident)
            else
              ident in PR
            end_if
          elif type(PR) = "_in" then
            PR
          elif contains(["_and", "_or", "_not"], type(PR)) <> 0 then
            if type(PR) = "_or" and has(map([op(PR)], type), "IV") then
              // special case x < 1 or 1 < x
              if (rg:= property::convert_to(PR, property::Rel)) <> FAIL and rg <> PR then
                return(property::simpexpr(rg, ident))
              end_if;
              // special case: simplify '(x > a) and (x < b) or (x > b)'
              // and set of integers
              PR:= map(map(PR, X -> if type(X) = "IV" then
                                      map(property::IV::Rel(X, hold(Sloppy)),
                                          property::Rel::expr, ident)
                                    else X end_if),
                       property::simpexpr, ident);
              if type(PR) = "_or"
                 and (rg:= contains(map([op(PR)], type), "_and")) > 0 then
                // expand expression
                if {op(op(PR, [rg, 1]))} = {op(op(PR, 3 - rg))} then
                  _and(property::simpexpr(op(PR, [rg, 2]), ident),
                       _unequal(op(sort([op(op(PR, 3 - rg))], (X,Y) -> bool(X = ident)))))
                elif {op(op(PR, [rg, 2]))} = {op(op(PR, 3 - rg))} then
                  _and(property::simpexpr(op(PR, [rg, 1]), ident),
                       _unequal(op(sort([op(op(PR, 3 - rg))], (X,Y) -> bool(X = ident)))))
                else
                  map(PR, property::simpexpr, ident)
                end_if
              else
                map(PR, property::simpexpr, ident)
              end_if
            elif type(PR) = "_and" and has(map([op(PR)], type), "IV") then
              PR:= map(PR, X -> if type(X) = "IV" then
                                  property::IV::simplify(X)
                                else
                                  X
                                end_if);
              map(PR, property::simpexpr, ident)
//             elif type(PR) = "_not" and type(op(PR)) = "IV"
//                  and  then
//               
            else
              map(PR, property::simpexpr, ident)
            end_if
          elif contains(["_intersect", "_union", "_minus"], type(PR)) <> 0 then
            ident in PR
          //elif domtype(PR) = DOM_BOOL then
            //op([ident in C_, PR, {}], contains([TRUE, UNKNOWN, FALSE], PR))
          else
            PR
          end_if
	end_proc:

// normalize (un-) equalities
property::normalize:=
        proc(EX)
          local l, r, c;
        begin
          if contains(["_and", "_or"], type(EX)) <> 0 then
            map(EX, property::normalize)
          elif contains(["_equal", "_unequal", "_less", "_leequal"], type(EX)) <> 0 then
            // remove constant factors and sort sides
//            [l, r]:= [op(normal(EX))];
            [l, r]:= [op(EX)];
  
            // sort
            if contains(["_equal", "_unequal"], type(EX)) <> 0 then
              if sysorder([op(indets(l))], [op(indets(r))]) then
                [l, r]:= [r, l] // swap
              end_if;
              //if domtype(l) = DOM_IDENT or domtype(r) = DOM_IDENT then // identifier
              if testtype(r, Type::Constant) then // constants right
                // right
              else
                [l, r]:= [r, l] // swap
              end_if
            end_if;
            
            // remove constant factors
            if type(l) = "_mult" and nops(indets(l)) >= nops(indets(r)) then
              c:= split(l, testtype, Type::Real);
              l:= op(c, 2);
              r:= r/op(c, 1);
              if contains(["_less", "_leequal"], type(EX)) <> 0
                 and specfunc::sign(op(c, 1)) = -1 then
                [l, r]:= [r, l]
              end_if
            elif type(r) = "_mult" and
                 domtype(l) <> DOM_IDENT and
                 nops(indets(r)) >= nops(indets(l)) then
              c:= split(r, testtype, Type::Real);
              r:= op(c, 2);
              l:= l/op(c, 1);
              if contains(["_less", "_leequal"], type(EX)) <> 0
                 and specfunc::sign(op(c, 1)) = -1 then
                [l, r]:= [r, l]
              end_if
            end_if;

            // simplify two expressions ex1 ~ ex2 ==> ex1 - ex2 ~ 0
            if domtype(l) = DOM_EXPR
               and (domtype(r) = DOM_EXPR or r = 0) then
              [l, r]:= [l - r, 0];
              // extract constant factors too
              if type(l) = "_mult" then
                l:= l/op(split(l, testtype, Type::Real), 1)
              elif type(l) = "_plus" then
                c:= map([op(l)], X -> if type(X) = "_mult" then
                                        select(X, testtype, DOM_INT)
                                      else
                                        1
                                      end_if);
                c:= igcd(op(c))*specfunc::sign(op(c, 1));
                l:= normal(l/c);
                if c<0 and contains(["_less", "_leequal"], type(EX)) <> 0 then
                  // we have to swap sides, since we  have multiplied
                  // by a negative constant
                  [l, r] := [0, l]
                end_if
              end_if
            end_if;

            op(EX, 0)(l, r)
          else
            EX
          end_if
        end_proc:

// simplify  Range and Constants
property::_simpconst:=
        proc(EX, ident)
          local RG, RET, IN;
        begin
	  if contains({"_and", "_or"}, type(EX)) then
            RET:= select(EX, has, ident);
            if contains({"_and", "_or"}, type(RET)) then
              IN:= select(RET, hastype, "_in");
              //REL:= select(RET, X -> contains({"_equal", "_unequal"}, type(X)));
              if IN = TRUE then
                IN:= [Type::Real]
              elif type(IN) <> "_in" then
                IN:= map([op(IN)], op, 2)
              else
                IN:= [op(IN, 2)]
              end_if;

              for RG in IN do
                EX:= map(EX, property::_simprel, ident, RG)
              end_for
            end_if
          end_if;
          EX
        end_proc:

// relation
property::_simprel:=
        proc(REL, ident, RANGE)
        begin
          if not has(REL, ident) then
            REL
          elif contains({"_equal", "_unequal"}, type(REL)) then
            if testtype(op(REL, 1), RANGE) or testtype(op(REL, 2), RANGE) then
              REL
            else
              null()
            end_if
          elif contains({"_leequal", "_less"}, type(REL)) then
            if testtype(op(REL, 1), RANGE) or testtype(op(REL, 2), RANGE) then
              REL
            else
              property::simpexpr(property::_simprange(property::Ex2Rx(REL, ident), RANGE), ident)
            end_if
          else
            REL
          end_if
        end_proc:

//
property::_simprange:=
        proc(REL, RANGE)
        begin
          if property::implies(RANGE, Type::Integer) = TRUE then
            property::Rel::Integer(REL)
          //elif property::implies(RANGE, Type::Rational) = TRUE
            
          else // Type::Real
            if testtype(property::Rel::border(REL), Type::Real) then
              REL
            else
              null()
            end_if
          end_if
        end_proc:

// simplification - because of weekness of 'NRange' with 'not'
// EX is a simplified expression, (NOT)REAL a set of (not) real identifiers
property::_simpreal:=
        proc(EX, REAL, NOTREAL)
          local SPLIT, isReal, k;
        begin
          if type(EX) = "_in" or type(EX) = "_not" then
            EX:= [hold(_in), [EX], [], []]
          else
            EX:= [op(EX, 0)] . split([op(EX)], X -> type(X) = "_in"
                                                    or type(X) = "_not" and type(op(X)) = "_in")
          end_if;

          isReal:=
            proc(term) // term is an expression with identifiers
              local ind, real, M, toggleReal;
            begin
              if (ind:= indets(term)) minus (REAL union NOTREAL) <> {} then
                return(UNKNOWN)
              end_if;
              real:= TRUE;
              toggleReal:=
                proc(L) // set of idents as args
                  local k;
                begin
                  for k in L do
                    if contains(NOTREAL, k) then
                      real:= FALSE
                    end_if;
                    ind:= ind minus L // remove identifier
                  end_for
                end_proc;
              
              while ind <> {} do
                // search for _mult
                if (M:= match(term, `#A`*`#X`, hold(Cond) = {`#A` -> domtype(`#A`) = DOM_IDENT})) <> FAIL then
                  term:= subs(`#X`, M); // simplify `#A` to 1
                  toggleReal(subs({`#A`}, M))
                elif (M:= match(term, 1/`#A`*`#X`, hold(Cond) = {`#A` -> domtype(`#A`) = DOM_IDENT})) <> FAIL then
                  term:= subs(`#X`, M); // simplify A to 1
                  toggleReal(subs({`#A`}, M))
                elif (M:= match(term, `#A` + `#X`, hold(Cond) = {`#A` -> domtype(`#A`) = DOM_IDENT})) <> FAIL then
                  term:= subs(`#X`, M); // simplify A to 1
                  toggleReal(subs({`#A`}, M))
                else // no identifier found or unknown expressions structure
                  // is the expression constant and real/not real?
                  return(numeric::isreal(term))
                end_if
              end_while;
              if real = TRUE and numeric::isreal(term) = FALSE then
                return(FALSE)
              end_if;
              real
            end_proc;
          
          // split 'in' expressions into real/ not real terms
          SPLIT:= split(op(EX, 2),
                        X -> if type(X) = "_not" then
                               //not property::implies(op(X, [1, 2]), Type::Real)
                               _not(contains({R_, Type::Real}, op(X, [1, 2]))) and UNKNOWN
                             else
                               //property::implies(op(X, 2), Type::Real)
                               contains({R_, Type::Real}, op(X, 2)) or UNKNOWN
                             end_if);

          for k in op(SPLIT, 1) do // k is an 'in' expression, real
            if contains({hold(_and), hold(_in)}, op(EX, 1)) and
               ((type(k) = "_in" and isReal(op(k, 1)) = FALSE)
                or (type(k) = "_not" and isReal(op(k, [1, 1])) = FALSE)) then
              return(FALSE)
            end_if
          end_for;
          for k in op(SPLIT, 2) do // k is an 'in' expression, not real
            if contains({hold(_and), hold(_in)}, op(EX, 1)) and
               ((type(k) = "_in" and isReal(op(k, 1)) = TRUE)
                or (type(k) = "_not" and isReal(op(k, [1, 1])) = TRUE)) then
              return(FALSE)
            end_if
          end_for;
          UNKNOWN
        end_proc:

// property::Ex2RxMulti:=
//         proc(EX, idents)
//         begin
//           EX
//           
//           // split into single identifier conditions
//           
//         end_proc:

property::Ex2Rx:=
proc(EX, ident = null(), REAL = {}, NOTREAL = {})
  local i, j, rel, EX1, R;
begin
  EX1:= EX; // keep original

  if contains(["_and", "_or"], type(EX)) > 0 then
    //rel:= FALSE;

    // select real identifiers
    rel:= TRUE; // real
    // expand expression - important for "_in" expressions
    EX:= expand(EX);

    // select contradictory constant relations
    // whole part deleted - provided by 'property::Rel::_and'
    
    EX:= eval(EX);
    if not contains({"_and", "_or"}, type(EX)) then
      return(property::Ex2Rx(EX, ident, REAL, NOTREAL))
    end_if;

    // call 'simpex' with each operand
    for i from 1 to nops(EX) do
      EX:= subsop(EX, i = property::Ex2Rx(op(EX, i), ident, REAL, NOTREAL), Unsimplified);
              // ident is real
//               if type(EX) = "_and" and property::implies(op(EX, i), Type::Real) = TRUE then
//                 rel:= TRUE
//               end_if
    end_for;
            
    // special case - prevent 'TRUE' because of generalization of properties
    if type(EX) = "_or" then
      R:= [op(EX)];
      if nops(R) > 1 then
        for i from 2 to nops(R) do
          for j from 1 to i - 1 do
            // search for complementary property
            if _not(op(R, i)) = op(R, j)
              or _not(op(R, j)) = op(R, i) then
              return(TRUE)
            end_if
          end_for
        end_for
      end_if
    end_if;

    // simplification
    // nein
//             if contains(map([op(EX1)], type), "_not") <> 0 then
//               // not B => not A  <==>  A => B
//               rel:= property::simpex(subsop(map(EX1, _not), 0 = _if(type(EX1) = "_or", _and, _or)));
//               // negate/exclude result expressions
//               if type(rel) = type(EX1) then
//                 rel:= select(EX1, X -> contains(map([op(rel)], _not), X) = 0);
//               elif rel= FALSE then //
//                 // do nothing
//               else
//                 rel:= select(EX1, X -> X <> not rel);
//               end_if;
//               if property::complexity((EX:= eval(EX))) < property::complexity(rel) then
//                 return(EX)
//               else
//                 return(rel)
//               end_if
//             end_if
            // implications
//             EX:= eval(EX); // perform simplifications
//             if type(EX) = "_and" then
//               for i from 2 to nops(EX) do
//                 if (rel:= property::implies(op(EX, i - 1), op(EX, i))) <> UNKNOWN then
//                   if rel then
//                     EX:= subsop(EX, _if(rel, i = null(), i - 1 = null()), Unsimplified)
//                   else
//                     return(FALSE)
//                   end_if
//                 end_if
//               end_for
//             end_if;
            //EX:= eval(EX);
            // de morgan
    if (map({op(EX1)}, type) = {"_not"}) then
      rel:= map(subsop(EX1, 0 = _if(type(EX1) = "_or", _and, _or),
                       Unsimplified), _not);
      rel:= not property::simpex(rel);
      if rel <> EX1 // changing
        and property::complexity(EX) > property::complexity(rel) then
                // simplify again
        return(property::Ex2Rx(rel, ident, REAL, NOTREAL))
      else
        // don't forget not real
        if not contains({"_and", "_or"}, type(rel))
          and type(EX1) = "_and"
          and not contains(NOTREAL, ident) then
          return(property::Ex2Rx(rel or not ident in R_, ident, REAL, NOTREAL))
        else
          return(rel)
        end_if
      end_if
    end_if
  //////////////////////////////////////////////////////////////////////////////// 
  elif type(EX)  = "_not" then
    rel:= property::Ex2Rx(op(EX), ident);
            // real mode for not
    if contains(REAL, ident) and type(rel) = "Rel" then // relation property
      EX:= property::Rel::_not(rel, TRUE)
    elif rel <> null() then
      EX:= not rel
    end_if
    // "_in"
  //////////////////////////////////////////////////////////////////////////////// 
  elif type(EX) = "_in" then
    // pre-process 'n in C_ minus {...}'
    if type(EX) = "_in" and ident = op(EX, 1) then
      if type(op(EX, 2)) = "_minus" then
        if op(EX, [2, 1]) = C_ then
          return(expand(not ident in op(EX, [2, 2])))
        elif (i:= expand(EX)) <> EX then
          return(i)
        else
          return(EX)
        end_if
      end_if
    end_if;  
    if contains((op(EX, 2))::dom, "simpexIn")
      and type(op(EX, 1)) <> piecewise then
              // solvelib::BasicSet
              // provisorisch: nur exakte Konvertierung
      EX:= (op(EX, 2))::dom::simpexIn(op(EX))
    end_if;
    if contains((op(EX, 2))::dom, "set2prop") then
              // solvelib::BasicSet
              // provisorisch: nur exakte Konvertierung
      if (rel:= (op(EX, 2))::dom::set2prop(op(EX, 2)))::dom::prop2set(rel) = op(EX, 2) then
        sysassign(property::SET, TRUE);
        EX:= subsop(EX, 2 = rel)
      else
        return(EX)
      end_if
    elif testtype((rel:= solvelib::set2prop(op(EX, 2))), Type::Property) then
              // nur exakte Konvertierung
      if rel::dom::prop2set(rel) = op(EX, 2) then
        sysassign(property::SET, TRUE);
        EX:= subsop(EX, 2 = rel)
      end_if
    end_if;
    EX:= eval(EX);
    if type(EX) <> "_in" then
      return(EX)
    end_if;
    if op(EX, 1) = ident then
      return(op(EX, 2))
    elif type(op(EX, 2)) = "function" then
      return(EX)
    elif (i:= property::_is(op(EX, 1), op(EX, 2))) <> UNKNOWN then
      return(i)
//             
//             elif domtype(op(EX, 2)) = DOM_SET and testtype(op(EX, 1), Type::Constant) then
//               return(contains(op(EX, 2), op(EX, 1)))
    else
      return(EX) // !!! hold
    end_if;
  elif testtype(EX, Type::Relation) then
            //           ?? Constant
    if property::isconstant(EX) = TRUE then
      if (rel:= is(EX)) <> UNKNOWN then
        return(rel)
      else
        return(EX)
      end_if
    end_if;
    if ident <> null() and not(has(EX, ident)) then
      if testtype(EX, Type::Constant) then
        return(EX) // !!! hold
      else // wrong ident
        return() // !!! null()
      end_if
    end_if;
            //if testtype(property::_getprop(ident), Type::Property) then
    if (i:= property::isrel(EX)) <> UNKNOWN then
      return(i)
    end_if;
            //end_if;

            // property::isxRel
            //  0   1   2   3   4   5   6   7   8   9  10  11  12  13  14  15
            // t-t/i-t/e-t/p-t/t-i/i-i/e-i/p-i/t-e/i-e/e-e/p-e/t-p/i-p/e-p/p-p
    if (i:= property::isxRel(EX)) = i_t then
      return(property::Rel(op(EX, 0), op(EX, 2)))
    elif i = t_i then
      return(property::Rel(-op(EX, 0), op(EX, 1)))
    elif i = t_t then
      return(bool(EX))
            // const < -x => x > -const
    elif (i = e_t and op(EX, 1) = -ident) then
      return(property::Rel(-op(EX, 0), -op(EX, 2)))
    elif (i = t_e and op(EX, 2) = -ident) then
      return(property::Rel(op(EX, 0), -op(EX, 1)))
            // x - y <> 0 => x <> y
//             elif i = e_t
//                  and  then
// 	      return(property::Rel(-op(EX, 0), -op(EX, 2)))
//             elif i = t_e
//                  and then
//               return(return(property::Rel(op(EX, 0), -op(EX, 1))))
            // x + a _rel_ b  =>  x _rel_ b - a
    elif (i = e_t or i = t_e)
      and hastype(EX, {DOM_INT, DOM_RAT, DOM_FLOAT, DOM_IDENT})
      and type(op(EX, _if(i = e_t, 1, 2))) = "_plus"
      and contains({i_t, t_i, e_i, i_e},
                   property::isxRel((rel:= map(EX, _subtract,
                                               select(op(EX, _if(i = e_t, 1, 2)),
                                                      X -> contains({DOM_INT, DOM_RAT, DOM_FLOAT},
                                                                    domtype(X))))))) then
      return(property::Ex2Rx(rel, ident))
            // x - y <> 0 => x <> y
    elif (rel:= contains([op(EX)], _if(ident <> null(), ident, FAIL))) > 0 then
      return(property::Rel(op([1, -1], rel)*op(EX, 0), op(EX, 3 - rel)))
    elif (i = e_t or i = t_e)
      and contains({"_equal", "_unequal"}, type(EX))
      and op(EX, _if(i = e_t, 2, 1)) = 0
      and contains({/*"_mult",*/ "_plus"}, type(op(EX, _if(i = e_t, 1, 2))))
                 // expr has one strange identifier
      and op(map((rel:= split(op(EX, _if(i = e_t, 1, 2)), has, ident)), indets), 2) <> {} then
      return(property::Ex2Rx(map(EX, op(EX, _if(i = e_t, [1, 0], [2, 0])),
                                 _if(type(op(EX, _if(i = e_t, 1, 2))) = "_mult",
                                     _invert, _negate)(op(rel, 2))), ident))
    else
      return(EX)
    end_if
          //elif type(EX) = DOM_IDENT then
          //  return(property::Rel(_equal, EX))
  end_if;
  EX:= eval(EX);
  if EX = Type::Complex then
            // be skeptical
    EX1
  else
    EX
  end_if
end_proc:

unalias(t_t):unalias(i_t):unalias(e_t):unalias(p_t):unalias(t_i):unalias(i_i):
unalias(e_i):unalias(p_i):unalias(t_e):unalias(i_e):unalias(e_e):unalias(p_e):
unalias(t_p):unalias(i_p):unalias(e_p):unalias(p_p):

// provisorisch

// returns the maximal depth of the expression tree
property::depth:=
proc(EXPR)
begin
  if domtype(EXPR) <> DOM_EXPR then
    1
  else  
    1 + max(property::depth(op(EXPR, i)) $i=0..nops(EXPR))
  end_if
end_proc:

// returns an integer value correlated to the complexity of a
// given expression
property::complexity:=  
proc(EXPR, OPT=hold(None))
  local compl, DEPTH, LENGTH, OPR, T;
  option remember;
  begin
    compl:=
      proc(EXPR)
        local c;
        option remember;
      begin
        if domtype(EXPR) = DOM_EXPR then
          c:= map([op(EXPR)], compl);
          T:= table(type(EXPR) = 1);
          // number off all operands
          _plus(op(c, 4*k-3) $ k = 1..nops(c)/4),
          // max number operands of one subexpression
          stdlib::max(nops(EXPR), op(c, 4*k-2) $ k = 1..nops(c)/4),
          // maximal expr tree depth
          DEPTH*(1 + max(op(c, 4*k-1) $ k = 1..nops(c)/4)),
          // table of all operators and types
          (map(map([op(c, 4*k) $ k = 1..nops(c)/4], op),
               X -> (if contains(T, op(X, 1)) then
                       T[op(X, 1)] := T[op(X, 1)] + op(X, 2)
                     else
                       T[op(X, 1)]:= op(X, 2)
                     end_if)); T)
        else
          nops(EXPR)*LENGTH, nops(EXPR)*LENGTH, 0, table(type(EXPR) = 1)
        end_if
      end_proc;
    
    DEPTH:= 1;
    LENGTH:= 1;
    OPR:= table("All" = 1);

//     case OPT
//       of hold(Flat) do
//         DEPTH:= 2;
//         break
//       of hold(Short) do
//         LENGTH:= 2;
//         break
//       of hold(Simple) do
//         // ??
// 
//     end_case;
    
    [compl, LENGTH, DEPTH, OPR]:= [compl(EXPR)];

    //print("sum nops" = compl, "max nops" = LENGTH, "max depth" = DEPTH, OPR);

    // standard arithmetic
    OPR:= split(OPR, X -> contains([DOM_INT, DOM_RAT, DOM_FLOAT, DOM_COMPLEX,
                                    "_plus", solvelib::BasicSet, "_equal", "_unequal"], op(X, 1)) > 0);
    T:= split(op(OPR, 2), X -> contains(["_mult", "_power", "_and", "_or", "_in",
                                         DOM_SET], op(X, 1)) > 0);

    max(compl, LENGTH)
    + DEPTH*_plus(op(map([op(op(OPR, 1))], op, 2)))
    + 2*DEPTH*_plus(op(map([op(op(T, 1))], op, 2)))
    + 3*DEPTH*_plus(op(map([op(op(T, 2))], op, 2)))
  end_proc:

