// $Date: 2002/02/23 22:57:06 $ $Author: bij $ $Revision: 1.66 $

// (ident, prop, Op) verknupft die Eigenschaften von ident Op prop
property::assume:=
  proc(ident, prop, Op)
    option hold;
    local m, OPR, ARGS, IDENT, PropTable, TESTPROC;
  begin
    // save all properties of any identifier in arguments
    protected(hold(Global), hold(None));
    PropTable:= table(op(map(select(indets([args(), context(args())]) minus Type::ConstantIdents,
                                    X -> domtype(context(X)) = DOM_IDENT),
                             proc(X)
                               local prop;
                             begin
                               prop:= properties(X);
                               // !! no: properties(X, FAIL); // don't remove properties
                               X = prop
                             end_proc)), hold(Global) = properties(hold(Global)));
    protected(hold(Global), hold(Error));
    
    if testargs() then
      ARGS:= [context(args())];
      IDENT:= op(ARGS, 1);
      OPR:=
        proc(NR) // 
        begin
          if nops(ARGS) > NR - 1 then
            if contains({_and, _or, hold(_and), hold(_or)}, op(ARGS, NR)) then
              if nops(ARGS) > NR then
                hold(error)("too many arguments")
              end_if
            else
              hold(error)("wrong type of ".output::ordinal(NR)." argument (operator expected)")
            end_if
          end_if
        end_proc;

      TESTPROC:=
        proc(IDENT, ARGS)
          name assume;
        begin
          if nops(ARGS) > 0 then
            if testtype(IDENT, Type::Property) then
              // assume(Type::Real)
              eval(OPR(2)) // check 2nd operand
            elif domtype(IDENT) = DOM_EXPR and
                 misc::maprec(IDENT, {"NRange", "IV", "IVnat", "Prop",
                                      "Rel", "Complex", "Residue"} = TRUE) = TRUE then
              eval(OPR(2)) // check 2nd operand
            elif domtype(IDENT) = DOM_IDENT or type(IDENT) = "_index" then
              if nops(ARGS) > 1 then
                if testtype(op(ARGS, 2), Type::Property) then
                  eval(OPR(3)) // check 3rd operand
                elif domtype(op(ARGS, 2)) = DOM_EXPR and
                     misc::maprec(op(ARGS, 2), {"NRange", "IV", "IVnat", "Prop",
                                                "Rel", "Complex", "Residue"} = TRUE) = TRUE then
                  eval(OPR(3)) // check 3rd operand
                elif op(ARGS, 2) = property::Null then
                  // 
                else
                  error("second argument must be a property")
                end_if
              else
                error("too few arguments")
              end_if
            elif testtype(IDENT, Type::Relation) then
              if (OPR:= contains(map([subs(op(IDENT), map(Type::ConstantIdents, X -> X = 1))],
                                     domtype), DOM_IDENT)) > 0 then
                // assume(x > 0)
                if testtype(op(IDENT, 3 - OPR), Type::Arithmetical)
                   or testtype(op(IDENT, 3 - OPR), Type::Relation) and
                      indets(op(IDENT, 3 - OPR)) minus Type::ConstantIdents <> {} then
                  //
                else
                  error("wrong type of bound to '".expr2text(op(IDENT, OPR))."'")
                end_if
              elif (OPR:= contains(map([op(IDENT)], testtype, Type::Relation), TRUE)) > 0
                   and contains(map({op(op(IDENT, OPR))}, domtype), DOM_IDENT) then
                // 0 < x < 1
                if testtype(op(IDENT, 1), Type::Relation) then
                  // check direction
                  OPR:= [op(op(IDENT, 1)), op(IDENT, 2)];
                end_if;
                if testtype(op(IDENT, 2), Type::Relation) then
                  OPR:= [op(IDENT, 1), op(op(IDENT, 2))];
                end_if;
                if domtype(op(OPR, 2)) = DOM_IDENT or
                   type(op(OPR, 2)) = "_index" and domtype(op(OPR, [2, 1])) = DOM_IDENT then
                else
                  error("wrong direction of combined relations")
                end_if
              elif {type(op(IDENT, 1)), type(op(IDENT, 2))} intersect {"Re", "Im"} <> {} then
                if domtype(op(op(IDENT, 1))) = DOM_IDENT
                   or domtype(op(op(IDENT, 2))) = DOM_IDENT then
                  // Re(x) > 0
                else
                  error("argument of \"Re\" or \"Im\" must be an identifier")
                end_if
              elif {type(op(IDENT, 1)), type(op(IDENT, 2))} intersect {"_index"} <> {} then
                // indexed identifier
              else
                error("at least one side must be an (indexed) identifier")
              end_if
            elif type(IDENT) = "_in" then
              if domtype(op(IDENT, 1)) = DOM_IDENT then
                if testtype(op(IDENT, 2), Type::Property) then
                  eval(OPR(3)) // check 3rd operand
                elif testtype(op(IDENT, 2), Type::Set) then
                  // can be converted to a property
                  eval(OPR(3)) // check 3rd operand
                else
                  error("second operand must be a property or a set")
                end_if
              else
                error("first operands must be an identifier")
              end_if
            elif domtype(IDENT) = DOM_SET or domtype(IDENT) = DOM_LIST then
              if map({op(IDENT)}, domtype) = {DOM_IDENT} then
                //
              else
                error("the "._if(domtype(IDENT) = DOM_SET, "set", "list").
                      " can only contain identifiers")
              end_if
            elif contains({"Re", "Im"}, type(IDENT)) then
              if domtype(op(IDENT)) = DOM_IDENT then
                // Re(x) > 0
              else
                error("argument of \"Re\" or \"Im\" must be an identifier")
              end_if
            else
              error("wrong type of first argument")
            end_if
          else
            error("wrong number of arguments")
          end_if
        end_proc;
      
      // remove properties to prevent simplification
      // because: simplifications as 'Im(> 0) -> 0'!
      if domtype(ident) = DOM_EXPR then
        if context(ident) <> ident then // simplification
          map(select(indets(ident) minus Type::ConstantIdents,
                     X -> domtype(eval(X)) = DOM_IDENT),
              X -> properties(X, FAIL));
        end_if
      end_if;

      if traperror(TESTPROC(IDENT, ARGS)) <> 0 then
        // argument check fails with evaluated arguments
        
        if traperror(TESTPROC(args(1), [args()])) <> 0 then // unevaluated arguments
          // argument check fails ever
          TESTPROC(IDENT, ARGS) // repeat error
        else
          // argument check passed with unevaluated arguments
        end_if
      else
        // argument check passed
      end_if
    end_if;

    m:= _if(args(args(0)) = hold(NoErrors), 1, 0);
    // necessary for relations as 'x >= a + 1' -> erase properties from 'a'!
    if contains([hold(_and), hold(_or)],
                    args(args(0) - (m:= (_if(args(args(0)) = hold(NoErrors), 1, 0))))) = 0
       and (context(ident))::dom::prop = FAIL then
      map(indets(ident), X -> (if domtype(context(X)) = DOM_IDENT then
                                 unassume(context(X));
                                 PropTable[X]:= FAIL
                               end_if));
    end_if;

    property::_assume(bool(m = 0), PropTable, context(args(1..(args(0) - m))))
  end_proc:

// 
property::_Assume:=
  proc(Err)
    local i, ARGS, m;
  begin
    m:= sign(contains([_and, _or, _not], args(args(0)))); // Opr
    ARGS:= [];
    for i from 2 to args(0) - m do
      if domtype(args(i)) = DOM_EXPR then // 1
        ARGS:= append(ARGS, [args(i)])
      elif domtype(args(i)) = DOM_IDENT or domtype(args(i)) then
      end_if;
    end_for;
    
    property::_assume()
    
  end_proc:

// Err: error, if property::Null is the result
// PropTable: table with all former properties: ident = property
property::_assume:=
  proc(Err, PropTable, ident = FAIL, prop = null(), Op = null(), Opt = null())
    local idprops, ORIG;
  begin
    if contains({"_less", "_leequal", "_equal", "_unequal"}, // Relation
                type(ident)) then
      return(property::setrel(args()));
    end_if;
    if type(ident) = "_in" then
      return(property::_assume(Err, PropTable, op(ident),
                               _if(args(0) > 3, args(3..args(0)), null())));
    elif type(ident) = "_index" and domtype(op(ident, 1)) = DOM_IDENT then
      // indexed identifier
      ORIG:= genident("PROP");
      if contains(property::ITABLE, ident) then
        PropTable[ORIG]:= property::ITABLE[ident] // keep property in table
      end_if;
      property::_assume(Err, PropTable, ORIG, prop, Op, Opt);
      sysassign(property::ITABLE[ident], properties(ORIG));
      delete ORIG;
      return(op(property::ITABLE[ident], 2))
    end_if;
    if domtype(ident) = DOM_EXPR then
      Op:= property::setfunc(args());
      if Op = hold(Error) then
        if args(0) = 3
           or args(0) = 4 and contains([_and, _or, hold(_and), hold(_or)], prop) <> 0 then
          // Global
          return(property::_assume(Err, PropTable, hold(Global), ident, prop))
        elif Opt = hold(Quiet) then
          return(FAIL)
        else
          error("only expressions of type 'Re' or 'Im' possible")
        end_if
      else
        return(Op)
      end_if
    elif contains([DOM_LIST, DOM_SET], domtype(ident)) <> 0 then
      map(op(ident), assume, prop, Op, Opt);
      return(prop)
    end_if;

    if ident::dom::prop = TRUE then // globales assume
      return(property::_assume(Err, PropTable, hold(Global), args(3..args(0))))
    // set as a property
    elif not testtype(prop, Type::Property) then
      if prop = property::Null then
        error("assumption impossible (property::Null)")
      elif not testtype((prop:= solvelib::set2prop(prop)), Type::Property) then
        error("given set cannot be converted to a property")
      end_if
    end_if;

    //Global
    protected(hold(Global), hold(None));
    if contains(PropTable, ident) then
      idprops:= op(PropTable[ident], 2) // only property, no sysprop
    else
      properties(ident, [property::sysprop(prop), prop]);
      protected(hold(Global), hold(Error));
      return(prop)
    end_if;

    // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//     userinfo(Text, 1, "pre-assign property: ",
//              ident = (_if(Op = _or, hold(_or), hold(_and)))(idprops, prop));
    properties(ident, [0, (_if(Op = _or, hold(_or), hold(_and)))(idprops, prop)]);
    if Op <> null() and Op <> id and idprops <> FAIL then
      if domtype(idprops) = DOM_EXPR then
        idprops:= map(idprops, Op, prop)
      else
        idprops:= eval(Op(idprops, prop))
      end_if
    else
      idprops:= prop
    end_if;
//     if TRUE then                 // Vereinfachung gewunscht 
//       if domtype(idprops) = DOM_EXPR then
//         idprops:= op(idprops, 0)(op({op(idprops)}))
//       end_if
//     end_if;
    if property::Fail(idprops) then
      if Err then
        properties(ident, PropTable[ident]);
        error("assumption impossible (".expr2text(idprops).")")
      end_if
    end_if;
    properties(ident, [property::sysprop(idprops), idprops]);

    protected(hold(Global), hold(Error));
    return(idprops)
  end_proc:
  
// (rel, _Op) setzt neue Relation 
property::setrel:=
  proc(Err, PropTable, _rel, _Op = id)
    local ret, REL;
  begin
    ret:= FAIL;
    REL:= FAIL;
    // alle Eigenschaften lschen!
    if _Op = id then
      map(indets(_rel), X -> (PropTable[X]:= FAIL)); // reelle Grenzen!
    end_if;
    if indets(op(_rel, 1)) minus Type::ConstantIdents <> {} then
      if type(op(_rel, 1)) <> DOM_IDENT
         and contains(["_less", "_leequal"], type(op(_rel, 1))) <> 0 then
        // Sonderfall: 'expr rel expr'  0 < x < 1
        ret:= property::_assume(Err, PropTable, op(_rel, 1), _Op);
        map(indets(op(_rel, 1)), X -> (PropTable[X]:= properties(X)));
        // second "outer" relation
        ret:= property::_assume(Err, PropTable,
                                op(_rel, 0)(op(_rel, [1, 2]), op(_rel, 2)), _and, hold(Quiet));
        _Op:= FAIL // prevent execute else in next if statement
      else
        if indets(op(_rel, 1)) intersect indets(op(_rel, 2)) <> {} then
          error("same identifiers on both sides not allowed")
        end_if;
        REL:= property::Rel(op(_rel, 0), op(_rel, 2), TRUE);
        ret:= property::_assume(Err, PropTable, op(_rel, 1), REL, _Op, hold(Quiet))
      end_if
    end_if;
    if indets(op(_rel, 2)) minus Type::ConstantIdents <> {} then
      if type(op(_rel, 2)) <> DOM_IDENT
         and contains(["_less", "_leequal"], type(op(_rel, 2))) <> 0 then
        // Sonderfall: 'expr rel expr'
        ret:= property::_assume(Err, PropTable, op(_rel, 2), _Op);
        map(indets(op(_rel, 2)), X -> (PropTable[X]:= properties(X)));
        ret:= property::_assume(Err, PropTable,
                                op(_rel, 0)(op(_rel, 1), op(_rel, [2, 1])), _and, hold(Quiet))
      elif _Op <> FAIL then // FAIL if special case in first if statement
        if indets(op(_rel, 1)) intersect indets(op(_rel, 2)) <> {} then
          error("same identifiers on both sides not allowed")
        end_if;
        REL:= property::Rel(-op(_rel, 0), op(_rel, 1), TRUE);
        REL:= property::_assume(Err, PropTable, op(_rel, 2), REL, _Op, hold(Quiet));
      end_if
    end_if;
    if type(ret) = hold(Error) and type(REL) = hold(Error)
       or ret = FAIL and REL = FAIL then
      error("wrong relation")
    end_if;
    if ret = FAIL or ret = hold(Error) then
      REL
    else
      ret
    end_if
  end_proc:

property::_setrel:=
  proc(Rel)
  begin
    _or(_if(type(op(Rel, 1)) = DOM_IDENT, property::Rel(op(Rel, 0), op(Rel, 2), TRUE), null()),
        _if(type(op(Rel, 2)) = DOM_IDENT, property::Rel(-op(Rel, 0), op(Rel, 1), TRUE), null()))
  end_proc:

// (rel, _Op) setzt funktionale Eigenschaften 
property::setfunc:=
  proc(Err, PropTable, _func, _prop, Op = null())
    local i;
  begin
    //property::reset(0):
    if (i:= contains([hold(Re), hold(Im)], op(_func, 0))) > 0 then
      if nops(_func) <> 1 or domtype(op(_func)) <> DOM_IDENT then
        error("wrong type of argument of '".expr2text(op(_func, 0))."' (DOM_IDENT expected)")
      end_if;
      property::_assume(Err, PropTable, op(_func, 1),
                        property::Complex(op(subsop([Type::Real, Type::Real], i = _prop))),
                        Op)
    else
      hold(Error)//error("only expressions of type 'Re' or 'Im' possible")
    end_if
    //property::_assume(Err, op(_func, 1), property::Func(op(_func, 0), _prop), Op)
  end_proc:

assume:= property::assume:
