
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
/////
/////   A C H T U N G  ! ! !   A T T E N T I O N  ! ! !
/////
///////////////////////////////////////////////////////////////////////////////
/////
/////   Aenderung der Reihenfolge / Kodierung in property::SYSPROP
/////   verursacht fatale Fehler bei der automatischen Vereinfachung
/////   von Ausdruecken durch den MuPAD-Kern!!!
/////   Aenderungen muessen sofort in den Kern-Quelldateien
/////      MGS_simplify.h (Definements MGSC_SYS_PROP_....)
/////   nachgehalten werden.
/////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

// alle Grundeigenschaften 
property::SYSPROP:=
  [//alle benotigten Eigenschaften
   /* 0 */ Type::Complex                       /*( komplex       )*/,
   /* 1 */ Type::Real                          /*( reell         )*/,
   /* 2 */ Type::NonNegative                   /*( nicht-negativ )*/,
   /* 3 */ Type::Positive                      /*( positiv       )*/,
   /* 4 */ Type::Negative                      /*( negativ       )*/,
   /* 5 */ Type::Integer                       /*( ganzzahlig    )*/,
   /* 6 */ Type::Zero                          /*( = Null        )*/,
   /* 7 */ Type::NonZero                       /*( <> Null       )*/,
   /* 8 */ property::Rel(_equal, 1)            /*( = 1           )*///,
   /* 9 */ //Type::Even                          #( gerade        )#
   ]:

alias(hasBit(X, k) = bool((X mod 2^(k + 1)) div 2^k <> 0)):

// erstellt aus einer Eigenschaft fur den Kern benotigte Eigenschaften [interne Darstellung] 
property::sysprop:=
  proc(prop)
    local sysprop, P, k;
    //option remember;
  begin
    if not(property::propend(prop)) then
      return(0)
    end_if;
    k:= 0;
    sysprop:= 0;
    for P in property::SYSPROP do
      if property::implies(prop, P) = TRUE then
        sysprop:= sysprop + 2^k
      end_if;
      k:= k + 1
    end_for;
    sysprop
  end_proc:

// ident/integer: -> System-Eigenschaften
property::sysgetprop:=
  proc(ident)
    local P, i, RET;
  begin
    if domtype(ident) = DOM_IDENT then
      if properties(ident) = FAIL then
        return([])
      else
        P:= op(properties(ident), 1)
      end_if
    elif testtype(ident, Type::Property) then
      P:= property::sysprop(ident)
    elif domtype(ident) = DOM_INT then
      P:= ident
    else
      return(FAIL)
    end_if;
    RET:= [];
    for i from 1 to nops(property::SYSPROP) do
      if hasBit(P, i - 1) then
        RET:= append(RET, op(property::SYSPROP, i))
      end_if
    end_for;
    RET
  end_proc:

// property, property
property::sysimplies:=
  proc(prop, sysprop)
    local P, Q;
  begin
    if (Q:= contains(property::SYSPROP, sysprop)) > 0 then
      if (P:= property::sysprop(prop)) <> FAIL then
        return(hasBit(P, Q - 1))
      end_if
    end_if;
    FALSE
  end_proc:

// ident, property
property::sysis:=
  proc(ident:DOM_IDENT, sysprop)
    local P, Q;
  begin
    if (Q:= contains(property::SYSPROP, sysprop)) > 0 then
      if (P:= op(properties(ident), 1)) <> FAIL then
        return(hasBit(P, Q - 1))
      end_if
    end_if;
    FALSE
  end_proc:

//         # 0 # Type::Complex                       #( komplex       )#,
//         # 1 # Type::Real                          #( reell         )#,
//         # 2 # Type::NonNegative                   #( nicht-negativ )#,
//         # 3 # Type::Positive                      #( positiv       )#,
//         # 4 # Type::Negative                      #( negativ       )#,
//         # 5 # Type::Integer                       #( ganzzahlig    )#,
//         # 6 # Type::Zero                          #( = Null        )#,
//         # 7 # Type::NonZero                       #( <> Null       )#,
//         # 8 # property::Rel(_equal, 1)            #( = 1           )#

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
/////
/////   A C H T U N G  ! ! !   A T T E N T I O N  ! ! !
/////
///////////////////////////////////////////////////////////////////////////////
/////
/////   Aenderung der Reihenfolge / Kodierung in property::SYSPROP
/////   verursacht fatale Fehler bei der automatischen Vereinfachung
/////   von Ausdruecken durch den MuPAD-Kern!!!
/////   Aenderungen muessen sofort in den Kern-Quelldateien
/////      MGS_simplify.h (Definements MGSC_SYS_PROP_....)
/////   nachgehalten werden.
/////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
