// $Date: 2002/02/21 13:05:34 $ $Author: bij $ $Revision: 1.23 $

// Ersetzt in dem Ausdruck ex jeden Operanden durch seinen
// Eigenschaftsausdruck
property::Ex2Px:=
	proc(ex = null(), constId = {})
          local t, _ex_, k;
        begin
	  if domtype(ex) = DOM_IDENT then
            if contains(constId, ex) /*or property::hasprop(ex) = FALSE*/ then
              // improves relations with unknowns!
              return(property::Rel(_equal, ex))
            else
              return(property::_getprop(ex))
            end_if
          elif not property::hasprop(ex) then
            return(ex)
          elif domtype(ex) = DOM_EXPR then
	    case (t:= type(ex))
              of "_index" do
                if domtype(op(ex, 1)) = DOM_IDENT
                   and contains(property::ITABLE, ex) then
                  return(property::_getprop(ex))
                else // indexed identifier without properties
                  return(ex)
                end_if;
                break
              of "_plus" do
	        if type(op(ex)) = "_mult" and op(op(ex), 2) = -1 then
		  ex:= subsop(ex, 0 = _subtract, 2 = op(ex, [2, 1]), Unsimplified)
	        elif type(op(ex, 2)) = "_negate" then
		  ex:= subsop(ex, 0 = _subtract, 2 = op(ex, [2, 1]), Unsimplified)
	        //else
	        //  ex:= property::_getprop(ex)
	        end_if;
	        break
	      of "_mult" do
	        if op(ex, 2) = -1 and nops(ex) = 2 then
		  ex:= subsop(ex, 0 = _negate, 2 = null(), Unsimplified)
	        elif type(op(ex)) = "_power" and op(op(ex), 2) = -1 then
		  ex:= subsop(ex, 0 = _divide, 2 = op(ex, [2, 1]), Unsimplified)
	        elif type(op(ex, 2)) = "_invert" then
		  ex:= subsop(ex, 0 = _divide, 2 = op(ex, [2, 1]), Unsimplified)
                elif not iszero(op(ex, 2))
                     and type(op(ex, 2)) = DOM_RAT and op(ex, [2, 1]) = 1 then
		  ex:= subsop(ex, 0 = _divide, 2 = 1/op(ex, 2), Unsimplified)
                elif type(op(ex, 1)) = "_power" and type(op(ex, 2)) = "_power"
                     and op(ex, [2, 1]) = -1 and op(ex, [1, 2]) = op(ex, [2, 2]) then
                  ex:= subsop(ex, [1, 1] = hold(_negate)(op(ex, [1, 1])),
                                      2 = null(), Unsimplified)
                // ERROR: _invert(Intervall mit 0)
	        //elif not iszero(op(ex, 2)) and type(1/op(ex, 2)) = DOM_INT then
	        //  ex:= subsop(ex, 0 = _divide, 2 = 1/op(ex, 2), Unsimplified)
	        end_if;
	        break
	      of "_power" do
	        if op(ex, 2) = -1 then
		  ex:= subsop(ex, 0 = _invert, 2 = null(), Unsimplified)
                elif domtype(op(ex, 2)) = DOM_INT and op(ex, 2) < 0 then
                  ex:= hold(_invert)(subsop(ex, 2 = -op(ex, 2), Unsimplified))
	        end_if;
	        break
            end_case;

            // functions that are not overloaded by property domains
//             if contains({"RootOf", "int", "diff", "log", "arctan",
//                          "round", "trunc", "frac", ""}, type(ex)) then
//               return(ex)
//             end_if;

            // recursive call of Ex2Px on operands
            _ex_:= ex; // keep original
	    for k from 1 to nops(ex) do
              if op(ex, k) <> null() then
                ex:= subsop(ex, k = property::Ex2Px(op(ex, k), constId), Unsimplified);
              end_if
            end_for;

            // functions that are not overloaded by property domains
            k:= eval(op(ex));
            if k::dom::prop = TRUE and not contains(k::dom, type(_ex_)) then
              // method does not exist
// fprint(Unquoted, 0, "1 method ", type(_ex_), " does not exist for ", k::dom);
              return(_ex_)
            elif type(k) = "_exprseq"
                 and _and(map(k, X -> bool(X::dom::prop = TRUE
                                           and contains(X::dom, type(_ex_))
                                           or testtype(X, Type::Arithmetical)))) <> TRUE then
// fprint(Unquoted, 0, "2 method ", type(_ex_), " does not exist for ", [k]);
              return(_ex_)
            end_if;

            // prevent

            // relations or intervals with constants
            if (t:= indets(ex) intersect
                    (indets(_ex_) minus constId minus Type::ConstantIdents)) <> {} then
              if map(t, property::hasprop) <> {FALSE} then
                constId:= t union constId;
                // identifiers with properties
                t:= _ex_; // get original
                // work with original
                for k from 1 to nops(t) do
                  if op(t, k) <> null() then
                    t:= subsop(t,
                               k = property::Ex2Px(op(t, k),
                                                   constId /*minus indets(op(t, k))*/),
                               Unsimplified);
                  end_if
                end_for;
                // functions that are not overloaded by property domains
                k:= eval(op(t));
                if k::dom::prop = TRUE and not contains(k::dom, type(t)) then
                  // method does not exist
// fprint(Unquoted, 0, "3 method ", type(t), " does not exist for ", k::dom);
                  return(_ex_)
                elif type(k) = "_exprseq"
                     and _and(map(k, X -> bool(X::dom::prop = TRUE
                                               and contains(X::dom, type(_ex_))
                                               or testtype(X, Type::Arithmetical)))) <> TRUE then
// fprint(Unquoted, 0, "4 method ", type(_ex_), " does not exist for ", [k]);
                  return(_ex_)
                end_if;
                // evaluation
                if (t:= eval(t)) = _ex_ // second call results nothing
                   /*or (ex <> t and TRUE)*/ then // no result
                  // return previous result
                  return(eval(ex))
                else
                  return(t)
                end_if
              end_if
            end_if;

//             ex:= eval(ex);

            // minimal property
            if domtype((k:= eval(op(ex, 0)))) = DOM_FUNC_ENV
               // except for standard arithmetic
               and contains(["_plus", "_subtract", "_negate", "_mult",
                             "_divide", "_invert", "_power"], type(_ex_)) = 0 then
              // preserve illegal function call with properties
              t:= [eval(op(ex))]; // evaluate operands
                 // not only single properties?
              if contains(map(t, X -> contains(X::dom, "prop")), FALSE) <> 0
                 // no overloading method?
                 or contains(map(t, X -> contains(X::dom, type(_ex_))), TRUE) = 0 then
                if (t:= k::minprop) <> FAIL then // minimal property
                  return(t)
                else
                  // return original expression
                  return(_ex_)
                end_if
              end_if
            end_if // real func env
            
          end_if; // DOM_EXPR

          eval(ex)
        end_proc:
