// $Date: 2002/02/27 12:31:52 $ $Author: bij $ $Revision: 1.113 $

/*(
   Rel     - Domain of Relations

   op(Rel) - Relation:   1 = "_less"
                         2 = "_leequal"
                         3 = "_unequal"
                         4 = "_equal"
                         5 = "_moequal"
                         6 = "_more"
             Border:     any expression
             NOT:        negation of relation
)*/

alias(Rel = property::Rel):
alias(OPR(x) = extop(x, 1)):  // Operator
alias(BOR(x) = extop(x, 2)):  // Border
alias(REAL(x) = extop(x, 3)): // real, if border is an identifier [TRUE/FALSE]

alias(chOPR(REL, b) = extsubsop(REL, 1 = b)):
alias(chBOR(REL, b) = extsubsop(REL, 2 = b)):
alias(cbREAL(REL, b) = extsubsop(REL, 3 = (b and extop(REL, 3)))):
alias(chREAL(REL) = extsubsop(REL, 3 = not extop(REL, 3))):
// alias(invNOT(REL)   = extsubsop(REL, 3 = not extop(REL, 3))):
// alias(chNOT(REL, b) = extsubsop(REL, 3 = b)):

alias(LES = 1):
alias(LEQ = 2):
alias(UNE = 3):
alias(EQU = 4):
alias(GEQ = 5):
alias(GTH = 6):

Rel:= newDomain("property::Rel"):
Rel::create_dom:=hold(property::Rel):
Rel::info:= "Domain of algebraic property 'Relations of Identifiers'":
Rel::domtype:= ()->Type:
Rel::type:= "Rel":
Rel::prop:= TRUE:
Rel::propdom:= slot(property, "Rel"):
Rel::autoload:= TRUE:
Rel::testtype:= Type::testtype:

Rel::noTrace:= {hold(print), hold(testtype), hold(domtype)}:

Rel::ax:= []:

Rel::__op:= [hold(_less),        // 1 
             hold(_leequal),     // 2 
             hold(_unequal),     // 3 
             hold(_equal),       // 4 
             -hold(_leequal),    // 5 
             -hold(_less)]:      // 6 

Rel::__OP:= eval([_less,        // 1 
                  _leequal,     // 2
                  _unequal,     // 3
                  _equal,       // 4
                  -_leequal,    // 5
                  -_less]):     // 6

Rel::__po:= ["<",              // 1 
             "<=",             // 2 
             "<>",             // 3 
             "=",              // 4 
             ">=",             // 5 
             ">"]:             // 6 

// operator, border 
Rel::new:= 
        proc(oper = hold(_equal), border = FAIL, real = UNKNOWN)
          local x, ret;
        begin
          if real = UNKNOWN then
            real:= bool(property::_is(border, Type::Real) = TRUE)
          end_if;
          ret:= if type(oper) = "_mult" then // negiert
                  if contains({hold(_equal), hold(_unequal)},
                              (x:= op(oper, 3 - contains([op(oper)], -1)))) then
                    new(Rel, contains(Rel::__op, x), border, real)
                  elif contains(Rel::__op, x) > 0 then
                    new(Rel, 7 - contains(Rel::__op, x), border, real)
                  elif (x:=contains(Rel::__op,
                                    text2expr(op(x, 3)["type"]))) > 0 then
                    new(Rel, 7 - x, border, real)
                  else
                    error("unexpected arguments")
                  end_if
                else // nicht negiert
                  if (x:= contains(Rel::__op, oper)) > 0 then
                    new(Rel, x, border, real)
                  elif (x:= contains(Rel::__op, 
                                     (oper:= text2expr(op(oper, 3)["type"])))) > 0 then
                    new(Rel, x, border, real)
                  else
                    error("unexpected arguments")
                  end_if
                end_if;
          if OPR(ret) <> EQU and OPR(ret) <> UNE
             and real <> TRUE and Rel::Real(ret) = FALSE then
            error("relation with complex border")
          elif OPR(ret) = UNE then
            cbREAL(ret, FALSE)
          else
            ret
          end_if
        end_proc:

// operator index
Rel::index:= 
        proc(oper)
        begin
          contains(Rel::__op, oper) + contains(Rel::__OP, oper)
        end_proc:

Rel::_new:=
  proc(opr, bor = 0, real = FALSE)
  begin
    new(Rel, opr, bor, real)
  end_proc:

// Ergebnis-Tabelle fur Operatoren, wenn `Border' gleich sind 
//            "<"       "<="      "<>"      "="       ">="      ">"     
Rel::__xx:= [[TRUE,     TRUE,     TRUE,     FALSE,    FALSE,    FALSE   ],
/*( "<=" )*/ [UNKNOWN,  TRUE,     UNKNOWN,  UNKNOWN,  UNKNOWN,  FALSE   ],
/*( "<>" )*/ [UNKNOWN,  UNKNOWN,  TRUE,     FALSE,    UNKNOWN,  UNKNOWN ],
/*( "="  )*/ [FALSE,    TRUE,     FALSE,    TRUE,     TRUE,     FALSE   ],
/*( ">=" )*/ [FALSE,    UNKNOWN,  UNKNOWN,  UNKNOWN,  TRUE,     UNKNOWN ],
/*( ">"  )*/ [FALSE,    FALSE,    TRUE,     FALSE,    TRUE,     TRUE    ]]:

Rel::LESS:= (x, y) -> y < x:
Rel::LEEQUAL:= (x, y) -> y <= x:

// Verkn"upfungs-Tabelle f"ur Operatoren, wenn `Border' ungleich sind 
//            "<"       "<="      "<>"      "="       ">="      ">"     
Rel::__xy:= [[_leequal, _leequal, _leequal, _leequal, _not@_leequal, _not@_leequal ],
/*( "<=" )*/ [_less,    _leequal, _less,    _less,    _not@_less,   _not@_less ],
/*( "<>" )*/ [/*UNKNOWN,  UNKNOWN,  _equal,   UNKNOWN,  UNKNOWN,  UNKNOWN*/],
/*( "="  )*/ [/*_less,   _leequal, _unequal,  _equal,   _leequal, _less  */],
/*( ">=" )*/ [_not@_leequal, _not@_less,    _less,    Rel::LESS,  _leequal, _less /*_leequal?*/],
/*( ">"  )*/ [_not@_leequal, _not@_leequal,  _leequal, Rel::LEEQUAL,  _leequal, _less   ]]:

Rel::is:=
        proc(rel1, rel2)
          local o, BOR1, BOR2;
        begin
          if args(0) < 2 then return(UNKNOWN) end_if;

          // fast alle Relationen reell                 // implizite Annahme! nein!
          if property::implies(Type::Real, rel2) = TRUE and (o:= Rel::Real(rel1)) = TRUE
             and OPR(rel1) <> UNE and OPR(rel1) <> EQU then
            return(TRUE)
          end_if;

          // Sonderfall Intervall
          if type(rel1) = "IV" then // [x, y]
            return(property::IV::is(rel1, property::Rel::IV(rel2)))
          end_if;
          if type(rel2) = "IV" then
          // Sonderfall: Bereich weniger als real
//%%// geaendert!!
            if property::implies(property::IV::NRange(rel2), Type::Rational) = TRUE then
              return(UNKNOWN)
            end_if;
          
            return(property::IV::is(property::Rel::IV(rel1), rel2))
          end_if;
          // Sonderfall direkter Vergleich von zwei Zahlen
//           if type(rel1) = "Rel" and OPR(rel1) = EQU
//              and testtype(property::carefloat(rel2), Type::Complex) then
//             if property::carefloat(BOR(rel1)) = property::carefloat(rel2) then
//               return(TRUE)
//             end_if
//           elif type(rel2) = "Rel" and OPR(rel2) = EQU
//              and testtype(property::carefloat(rel1), Type::Complex) then
//             if property::carefloat(BOR(rel2)) = property::carefloat(rel1) then
//               return(TRUE)
//             end_if
//           end_if;

          if type(rel1) <> "Rel" and type(rel2) <> "Rel" then
            return(UNKNOWN)
          end_if;

          // numerisch 
          if type(rel1) <> "Rel" then
            // eval notwendig? 
            o:= map([/*eval*/(rel1), /*eval*/(BOR(rel2))], property::carefloat);
            if map({op(o)},
                   (()->(bool(type(args()) = DOM_FLOAT)
                       or contains({infinity, -infinity}, args())))) = {TRUE} then
              if OPR(rel2) < 5 then
                return(bool(op(Rel::__op, OPR(rel2))
                              (op(o, 1), op(o, 2))))
              else
                return(bool(op(Rel::__op, Rel::inv(OPR(rel2)))
                              (op(o, 2), op(o, 1))))
              end_if
            end_if;
            return(UNKNOWN)
          end_if;

          if type(rel2) <> "Rel" then return(UNKNOWN) end_if;

          // Ident ohne property

          // Grenze gleich
          if BOR(rel1) = BOR(rel2) then
            return(op(op(Rel::__xx, OPR(rel1)), OPR(rel2)))
          end_if;
          
          // Comparison with complex arguments
//           if contains({LES, LEQ, GEQ, GTH}, OPR(rel2)) and FALSE then
//             return(FALSE)
//           end_if;

          BOR1:= BOR(rel1);
          if domtype(BOR1) = DOM_EXPR then
            BOR1:= property::carefloat(BOR1)
          end_if;
          BOR2:= BOR(rel2);
          if domtype(BOR2) = DOM_EXPR then
            BOR2:= property::carefloat(BOR2)
          end_if;
          if BOR1 <> BOR2 then
//             NCONST:= not(testtype(BOR1, Type::Constant) and testtype(BOR1, Type::Constant))
//                      and UNKNOWN;
            if OPR(rel1) = EQU then
              return(property::isrel(Rel::expr(rel2, BOR1)))
            elif OPR(rel1) = UNE then
              return(UNKNOWN)
            elif OPR(rel2) = EQU then
              return(property::isrel(Rel::expr(rel1, BOR2)) and UNKNOWN)
            elif type((o:= op(op(Rel::__xy, OPR(rel1)), OPR(rel2)))) <> "_fconcat" then
              if (OPR(rel1) > 4) or (OPR(rel2) > 4) then
                return(property::isrel(o(BOR2, BOR1))
                       or UNKNOWN)
              else
                return(property::isrel(o(BOR1, BOR2))
                       or UNKNOWN)
              end_if
            else //if contains({LES*GEQ, LES*GTH, LEQ*GEQ, LEQ*GTH}, OPR(rel1)*OPR(rel2)) then
              // !!! excl. 6, 10 ???
              //versch. Richtungen
              o:= op(o, 2);
              if OPR(rel2) >= GEQ then
                o:= eval(op(Rel::__op, OPR(rel2) - 4));
                return((not(property::isrel(o(BOR1, BOR2)))
                        and UNKNOWN) /*or NCONST*/)
              else // <= LEQ
                return((not(property::isrel(o(BOR2, BOR1)))
                        and UNKNOWN) /*or NCONST*/)
              end_if
            //elif OPR(rel2) <> 4 then
              //return(property::_is(
                           //op(Rel::__op, OPR(rel2))
                              //BOR2, BOR1))
            end_if
          end_if;
          return(UNKNOWN)
        end_proc:

Rel::op:=
        proc(rel, ind)
        begin
          if args(0) = 1 then
            BOR(rel)
          elif ind = 0..1 then
            eval(Rel::__op[OPR(rel)]), BOR(rel)
          else
            op([eval(Rel::__op[OPR(rel)]), BOR(rel)], ind + 1)
          end_if
        end_proc:

// technical methods for 'assume'
Rel::_op:=
        proc(rel)
        begin
          OPR(rel), BOR(rel)
        end_proc:

Rel::_inv:=
        proc(oper)
        begin
          op([5, 6, 3, 4, 1, 2], oper)
        end_proc:

// Typ einer Relation 
Rel::reltype:=
        proc(rel)
        begin
          if OPR(rel) < 5 then
            Rel::__op[OPR(rel)]
          else
            _negate(Rel::__op[7 - OPR(rel)])
          end_if
        end_proc:

Rel::_sort:=
        proc(rel1, rel2)
        begin
          bool(op([1,2,5,6,4,3], OPR(rel1)) < op([1,2,5,6,4,3], OPR(rel2)))
        end_proc:

// Typ einer Relation 
Rel::open:=
        proc(oper)
        begin
          contains({1, 3, 6}, OPR(oper))
        end_proc:

// Typ einer Relation 
Rel::closed:=
        proc(oper)
        begin
          contains({2, 4, 5}, OPR(oper))
        end_proc:

// Typ einer Relation 
Rel::operator:=
        proc()
        begin
          if args(0) > 1 then
            Rel(args(2), BOR(args(1)))
          else
            Rel::reltype(args())
          end_if
        end_proc:

// ret open border (rel) or subs open border (rel, bor)
Rel::border:=
        proc()
        begin
          if args(0) > 1 then
            chBOR(args(1), args(2))
          else
            BOR(args())
          end_if
        end_proc:

// indets 
Rel::indets:=
        proc(rel)
        begin
          indets(BOR(rel))
        end_proc:

// Type::Numeric
Rel::Numeric:=
        proc(rel, OPT = FAIL)
        begin
          if OPT <> FAIL then
            if testtype(BOR(rel), Type::Numeric) then
              BOR(rel)
            else
              property::carefloat(BOR(rel))
            end_if
          else
            OPR(rel) = 4 and testtype(property::carefloat(BOR(rel)), Type::Numeric)
          end_if
        end_proc:

// Type::Constant 
Rel::constant:=
        proc(rel)
        begin
          if OPR(rel) = 4 then
            property::_is(BOR(rel), Type::Constant)
          else
            UNKNOWN
          end_if;
        end_proc:

// TRUE, if rel 'real', FALSE, if rel 'complex'
Rel::Real:=
        proc(rel)
        begin
          if REAL(rel) then
            TRUE
          elif OPR(rel) = UNE then
            if is(BOR(rel), Type::Real) <> TRUE then
              FALSE
            else
              REAL(rel) or UNKNOWN
            end_if
          elif testtype(BOR(rel), Type::Constant) and testtype(BOR(rel), Type::Arithmetical) then
            if contains({DOM_INT, DOM_RAT, DOM_FLOAT}, domtype(BOR(rel))) or
               // constant expressions, identifiers
               domtype(float(BOR(rel))) = DOM_FLOAT then
              TRUE
            else // border complex
              bool(OPR(rel) <> EQU) and UNKNOWN
            end_if
          //elif property::_is(BOR(rel), Type::Real) = TRUE then
          //  TRUE
          elif domtype(BOR(rel)) = stdlib::Infinity then
            TRUE
          else
            UNKNOWN
          end_if
        end_proc:

// TRUE, wenn </<= .. >=/> oder >=/> .. </<= 
Rel::neq:=
        proc(opr1, opr2)
        begin
          bool(opr1 < 3 and opr2 > 4) or
          bool(opr1 > 4 and opr2 < 3)
        end_proc:

//  
Rel::inv:=
        proc(oper)
        begin
          op([6, 5, 3, 4, 2, 1], oper)
        end_proc:

//  
Rel::_maxop:=
        proc(opr1, opr2)
        begin
          if specfunc::abs(opr1 - opr2) <= 1 then
            return(max(opr1, opr2))
          end_if;
          0
        end_proc:

//  
Rel::_minop:=
        proc(opr1, opr2)
        begin
          if specfunc::abs(opr1 - opr2) <= 1 then
            return(min(opr1, opr2))
          end_if;
          0
        end_proc:

// Signum analog zu Intervallen 
Rel::sign:=
        proc(rel)
        begin
          if property::_is(BOR(rel) > 0) = TRUE then
            op([{-1, 0, 1}, {-1, 0, 1}, {-1, 0, 1}, {1}, {1}, {1}], OPR(rel))
          elif property::_is(BOR(rel) < 0) = TRUE then
            op([{-1}, {-1}, {-1, 0, 1}, {-1}, {-1, 0, 1}, {-1, 0, 1}], OPR(rel))
          elif property::_is(BOR(rel) = 0) = TRUE then
            op([{-1}, {-1, 0}, {-1, 1}, {0}, {0, 1}, {1}], OPR(rel))
          else
            {-1, 0, 1}
          end_if;
        end_proc:

// internes Signum
Rel::_sign:=
        proc(rel)
        begin
          if property::_is(BOR(rel) > 0) = TRUE then
            op([0, 0, 0, 1, 1, 1], OPR(rel))
          elif property::_is(BOR(rel) < 0) = TRUE then
            op([-1, -1, 0, -1, 0, 0], OPR(rel))
          elif property::_is(BOR(rel) = 0) = TRUE then
            op([-1, -0.5, 0, 0, 0.5, 1], OPR(rel))
          elif property::_is(BOR(rel) >= 0) = TRUE then
            op([0, 0, 0, 0.5, 0.5, 1], OPR(rel))
          elif property::_is(BOR(rel) <= 0) = TRUE then
            op([-1, -0.5, 0, -0.5, 0, 0], OPR(rel))
          else
            0
          end_if;
        end_proc:

Rel::_not:=
        proc(rel, real = FALSE)
        begin
          case OPR(rel)
          of EQU do
            return(property::Rel::_new(UNE, BOR(rel), not REAL(rel)))
          of UNE do
            return(property::Rel::_new(EQU, BOR(rel), not REAL(rel)))
          end_case;
          // > infinity or < -infinity => property::Null
          if OPR(rel) = LES and BOR(rel) = infinity
             or OPR(rel) = GTH and BOR(rel) = -infinity then
            return(property::Null)
          end_if;             
          if real /*or Rel::Real(rel) = TRUE*/ then
            chREAL(chOPR(rel, modp((OPR(rel) + 4), 8)))
          else
            //invNOT(rel)
            hold(_not)(rel)
          end_if
        end_proc:

// Verkn"upfungs-Tabelle f"ur _and, wenn `Border' gleich sind 
//            "<"   "<="  "<>"  "="   ">="  ">" 
Rel::__ax:= [[LES,  LES,  LES,  FAIL, FAIL, FAIL],
/*( "<=" )*/   [LES,  LEQ,  LES,  EQU,  EQU,  FAIL],
/*( "<>" )*/   [LES,  LES,  UNE,  FAIL, GTH,  GTH ],
/*( "="  )*/   [FAIL, EUQ,  FAIL, EQU,  EQU,  FAIL],
/*( ">=" )*/   [FAIL, EQU,  GTH,  EQU,  GEQ,  GTH ],
/*( ">"  )*/   [FAIL, FAIL, GTH,  FAIL, GTH,  GTH ]]:

// #( Verkn"upfungs-Tabelle f"ur _and -> Null, wenn `Border' ungleich sind )#
// #(            "<"            "<="       "<>"  "="   ">="  ">" )#
// Rel::__ax:= [[FAIL,          FAIL                                   ],
// #( "<=" )#   [FAIL,          FAIL                                   ],
// #( "<>" )#   [                           FAIL,                      ],
// #( "="  )#   [_not@_leequal, _not@_less, FAIL, TRUE, _less, _leequal],
// #( ">=" )#   [                                       FAIL,  FAIL    ],
// #( ">"  )#   [                                       FAIL,  FAIL    ]]:

Rel::_and:=
        proc()
          local ARGS, i, f, RG, ch;
        begin
          // unequal or equal to constant/property AND range/interval
          if (op((ARGS:= split([args()], X -> type(X) = "NRange"
                                              or type(X) = "IV")), 1) <> []
              or contains(map(select(op(ARGS, 2), X -> type(X) = "Rel"), Rel::Real), TRUE) <> 0)
             and op((i:= split(op(ARGS, 2), X -> OPR(X) = UNE
                                                 or OPR(X) = EQU)), 1) <> [] then
            if nops(op(ARGS, 1)) > 1 then
              ch:= TRUE;
              RG:= _and(op(op(ARGS, 1)))
            elif op(ARGS, 1) = [] then // real mode
              ch:= FALSE; // no change
              RG:= Type::Real
            else // one range
              ch:= FALSE; // no change
              RG:= op(op(ARGS, 1))
            end_if;
            // real mode for 'not' relations
            if property::implies(RG, Type::Real) = TRUE then // real mode
              i:= subsop(i, 2 = map(op(i, 2),
                                    proc(X)
                                    begin
                                      if type(X) = "_not" and type(op(X)) = "Rel" then
                                        ch:= TRUE;
                                        Rel::_not(op(X), TRUE) // real mode
                                      else
                                        X
                                      end_if
                                    end_proc));
              // split again
              i:= split(op(i, 1).op(i, 2), X -> OPR(X) = UNE or OPR(X) = EQU)
            end_if;
            //
            f:= FALSE;
            i:= subsop(i, 1 = map(op(i, 1),
                                  proc(X)
                                    local x;
                                  begin
                                    if (x:= property::_is(BOR(X), RG)) <> UNKNOWN then
                                      if x and OPR(X) = EQU then
                                        f:= TRUE;
                                        return(X) // range unnecessary
                                      elif x and OPR(X) = UNE then
                                        return(X) // keep valid unequality
                                      elif OPR(X) = EQU then // not x
                                        ch:= TRUE;
                                        return(property::Null) // contradiction
                                      else // not x and OPR(X) = UNE
                                        ch:= TRUE;
                                        return(null()) // forget unequality
                                      end_if
                                    else
                                      return(X)
                                    end_if                    
                                  end_proc));
            if f = TRUE then // forget range
              if nops(op(i, 1)) = 1 and op(i, 2) = [] then
                return(op(op(i, 1)))
              elif ch then // 
                return(Rel::_and(op(op(i, 1)), op(op(i, 2))))
              else
                // no change - leave special case
              end_if
            elif has(i, property::Null) then // contradiction
              return(property::Null)
            elif op(i, 1) = [] and op(i, 2) = [] then // only range
              return(RG)
            elif ch then // keep range and other relations only if changed
              return(_and(RG, op(op(i, 1)), op(op(i, 2))))
            else
              // no change - leave special case
            end_if
          end_if;
          
          // ausser fur Ungleichungen!
          if (i:= contains((ARGS:= [args()]), Type::Real)) > 0 then
            // Achtung: map von alias OPR!!!
            if contains(map(subsop(ARGS, i = null()),
                            X -> bool(OPR(X) = UNE or OPR(X) = EQU)), TRUE) = 0 then
              return(Rel::_and(op(subsop(ARGS, i = null()))))
            end_if
          end_if;
          // umsortieren der Argumente - Relationen mit gleichen Grenzen zuerst
          if args(0) > 2 then
            ARGS:= split(ARGS, X -> type(X) = "Rel");
            ARGS:= subsop(ARGS, 1 = sort(op(ARGS, 1),
                                         (X, Y) -> property::isrel(BOR(X) >= BOR(Y)) = TRUE));
            for i from 1 to nops(op(ARGS, 1)) - 1 do
              if BOR(op(ARGS, [1, i])) = BOR(op(ARGS, [1, i + 1])) then
                ARGS:= subsop(ARGS, [1, i] = FAIL,
                                    [1, i + 1] = Rel::_and(op(ARGS, [1, i]), op(ARGS, [1, i + 1])));
              end_if
            end_for;
            if contains(op(ARGS, 1), property::Null) > 0 then
              return(property::Null)
            end_if;
            ARGS:= subs(op(ARGS, 1), FAIL = null()) . op(ARGS, 2)
          end_if;

          property::_Op(Rel, _and,
            proc(rel1, rel2)
              local __op, __pq, __ar;
            begin
              if (__op:= contains([TRUE, FALSE],
                                  /*property::implies*/Rel::is(rel1, rel2))) > 0 then
                return(op([rel1, property::Null], __op))
              end_if;
              if (__op:= contains([TRUE, FALSE],
                                  /*property::implies*/Rel::is(rel2, rel1))) > 0 then
                return(op([rel2, property::Null], __op))
              end_if;
              __ar:= BOR(rel1), BOR(rel2);
              if property::_is(_equal(__ar)) = TRUE then
                if (__op:= op(Rel::__ax, [OPR(rel1), OPR(rel2)]))
                   <> FAIL then
                  return(Rel::_new(__op, BOR(rel1), REAL(rel1) or REAL(rel2)))
                else
                  return(property::Null)
                end_if
              end_if;
              __pq:= OPR(rel1), OPR(rel2);
//            if (__op:= contains([__pq], 4)) > 0 then
//                 if (k:= OPR(args(3 - __op))) = 4 then
//                   return(property::Null)
//                 elif k <> 3 then
//                   if property::_is(Rel::expr(subsop(args(3 - __op),
//                                                     OP = OPR(args(3 - __op))),
//                                              op(__ar, __op))) = FALSE then
//                     return(property::Null)
//                   end_if
//                 end_if
//            end_if;
              if (__pq:= {__pq}) minus {1, 2} = {} then
                if (__op:= (contains([TRUE, FALSE], property::_is(_less(__ar))))) > 0  then
                  return(args(__op))
                end_if
              end_if;
              if __pq minus {5, 6} = {} then
                if (__op:= (contains([TRUE, FALSE], property::_is(_less(__ar))))) > 0  then
                  return(args(3 - __op))
                end_if
              end_if;
// max/min nicht schlau genug
//            if __pq intersect {1, 2} = {} then
//              if type((__op:= max(__ar))) <> "max" then
//                return(args(contains([__ar], __op)))
//              end_if
//            end_if;
//            if __pq intersect {5, 6} = {} then
//              if type((__op:= min(__ar))) <> "min" then
//                return(args(contains([__ar], __op)))
//              end_if
//            end_if;
              //if (__op:= property::_is(BOR(rel1) < BOR(rel2)))
                 //= TRUE then
                //if (__op:= property::_is(BOR(rel1) <= BOR(rel2)))
                   //= TRUE then
                  
                //end_if
              //elif (__op:= property::_is()) = TRUE then
                //if (__op:= property::_is()) = TRUE then
                  
                //end_if
              //end_if;
              //if (OPR(rel1) > 4 and OPR(rel2) < 3) then
                //return()
              //elif (OPR(rel1) > 4 and OPR(rel2) < 3) then
                //return()
              //end_if;
              //return(_and(Rel::IV(rel1), Rel::IV(rel2)))
              return(hold(_and)(args()))
            end_proc, op(ARGS))
            //        ARGS! umsortierte Argumente
        end_proc:

// Verkn"upfungs-Tabelle f"ur _and, wenn `Border' gleich sind 
//            "<"   "<="  "<>"  "="   ">="  ">" 
Rel::__ox:= [[LES,  LEQ,  UNE,  LEQ,  FAIL, UNE ],
/*( "<=" )*/   [LEQ,  LEQ,  UNE,  LEQ,  FAIL, FAIL],
/*( "<>" )*/   [UNE,  FAIL, UNE,  FAIL, FAIL, UNE ],
/*( "="  )*/   [LEQ,  LEQ,  FAIL, EQU,  GEQ,  GEQ ],
/*( ">=" )*/   [FAIL, FAIL, FAIL, GEQ,  GEQ,  GEQ ],
/*( ">"  )*/   [UNE,  FAIL, UNE,  GEQ,  GEQ,  GTH ]]:

Rel::_or:=
        proc()
          local ARGS, i, f, RG, ch; //INT, RET, RES, i, n;
        begin
          // unequal or equal to constant/property or range/interval
          if op((ARGS:= split([args()], X -> type(X) = "NRange"
                                              or type(X) = "IV")), 1) <> []
              //or contains(map(select(op(ARGS, 2), X -> type(X) = "Rel"), Rel::Real), TRUE) <> 0)
             and op((i:= split(op(ARGS, 2), X -> //OPR(X) = UNE or
                                                 OPR(X) = EQU)), 1) <> [] then
            ch:= TRUE;
            if nops(op(ARGS, 1)) > 1 then
              RG:= _and(op(op(ARGS, 1)))
            elif op(ARGS, 1) = [] then // real mode
              ch:= FALSE; // no change
              RG:= Type::Real
            else // one range
              RG:= op(op(ARGS, 1))
            end_if;
            //
            f:= FALSE;
            i:= subsop(i, 1 = map(op(i, 1),
                                  proc(X)
                                  begin
                                    if //OPR(X) = EQU and
                                       property::_is(BOR(X), RG) = TRUE then
                                      f:= TRUE;
                                      null() // element contained - unnecessary
                                    else
                                      return(X)
                                    end_if                    
                                  end_proc));
            if f = TRUE then // change
              if op(i, 1) = [] then // no equality left
                if op(i, 2) = [] then // no relation left
                  return(RG)
                else
                  return(Rel::_and(op(op(i, 2)), RG))
                end_if
              else // equalities left
                return(Rel::_and(op(op(i, 1)), op(op(i, 2)), RG))
              end_if
            else // no change - break
            end_if
//             if f = TRUE then // forget range
//               if nops(op(i, 1)) = 1 and op(i, 2) = [] then
//                 return(op(op(i, 1)))
//               elif ch then // 
//                 return(Rel::_and(op(op(i, 1)), op(op(i, 2))))
//               else
//                 // no change - leave special case
//               end_if
//             elif has(i, property::Null) then // contradiction
//               return(property::Null)
//             elif op(i, 1) = [] and op(i, 2) = [] then // only range
//               return(RG)
//             elif ch then // keep range and other relations
//               return(_and(RG, op(op(i, 1)), op(op(i, 2))))
//             else
//               // no change - leave special case
//             end_if
          end_if;

          // special case - integer values
          ARGS:= split([args()], X -> type(X) = "Rel"
                                     and OPR(X) = EQU and domtype(BOR(X)) = DOM_INT);
          if nops(op(ARGS, 1)) > 1 then // at least two points
            ch:= sort(map(op(ARGS, 1), X -> BOR(X))); // select/unify/sort integers
            RG:= [];
            // extract corners
            f:= op(ch, 1); // left bound
            for i from 1 to nops(ch) - 1 do
              if op(ch, i) + 1 < op(ch, i + 1) then // break!
                RG:= append(RG, [f, op(ch, i)]);
                f:= op(ch, i + 1);
              end_if
            end_for;
            RG:= append(RG, [f, op(ch, i)]);
            // create intervals directly
            RG:= map(RG,
                      X -> Type::Interval
                             (hold(id)
                              ([property::IVnat::_new(op(X, 1), 1,
                                                      op(X, 2), 1, TRUE),
                                property::NRange::_or(DOM_INT::NRange(op(X, 1)),
                                                      DOM_INT::NRange(op(X, 2)),
                                                      _if(op(X, 1) < 0 and op(X, 2) > 0,
                                                          Type::Zero,
                                                          null()))
                                ])));
            if nops(op(ARGS, 2)) > 0 then
              return(property::IVnat::_or(op(op(ARGS, 2)), op(RG)))
            else // ready
              if nops(RG) > 1 then
                return(hold(_or)(op(RG)))
              else
                return(op(RG))
              end_if
            end_if
          end_if;
            
          
          property::_Op(Rel, _or,
            proc(rel1, rel2)
              local __op, __pq, __ar, i;
            begin
              if (__op:= contains([TRUE, FAIL/*FALSE*/], property::implies(rel1, rel2))) > 0 then
                return(op([rel2, Type::Real], __op))
              end_if;
              if (__op:= contains([TRUE, FAIL/*FALSE*/], property::implies(rel2, rel1))) > 0 then
                return(op([rel1, Type::Real], __op))
              end_if;
              __ar:= BOR(rel1), BOR(rel2);
              if property::_is(_equal(__ar)) = TRUE then
                if {OPR(rel1), OPR(rel2)} = {EQU, UNE} then
                  return(Type::Complex)
                elif (__op:= op(Rel::__ox, [OPR(rel1), OPR(rel2)]))
                   <> FAIL then
                  return(Rel::_new(__op, BOR(rel1), REAL(rel1) and REAL(rel2)))
                else
                  return(Type::Real)
                end_if
              end_if;
              __pq:= OPR(rel1), OPR(rel2);
              if (i:= contains([__pq], 3)) > 0 then
                if domtype(BOR(args(3 - i))) <> stdlib::Infinity
                   and property::_is(Rel::expr(args(3 - i), BOR(args(i)))) = TRUE then
                  return(Type::Real)
                end_if
              end_if;
              
              if (__pq:= {__pq}) intersect {3, 4} = {} then
                if __pq intersect {1, 2} = {} then
                  if (__op:= (contains([TRUE, FALSE], property::_is(_less(__ar))))) > 0  then
                    return(args(3 - __op))
                  end_if
                end_if;
                if __pq intersect {5, 6} = {} then
                  if (__op:= (contains([TRUE, FALSE], property::_is(_less(__ar))))) > 0  then
                    return(args(__op))
                  end_if
                end_if;
                if property::_is(Rel::expr(rel1, BOR(rel2))) = TRUE then
                  return(Type::Real)
                end_if
              end_if;
// min/max nicht schlau genug
//            if __pq intersect {1, 2} = {} then
//              if type((__op:= min(__ar))) <> "min" then
//                return(args(contains([__ar], __op)))
//              end_if
//            end_if;
//            if __pq intersect {5, 6} = {} then
//              if type((__op:= max(__ar))) <> "max" then
//                return(args(contains([__ar], __op)))
//              end_if
//            end_if;
              //return(_or(Rel::IV(rel1), Rel::IV(rel2)))
              return(hold(_or)(args()))
            end_proc, args())
        end_proc:

Rel::_plus:=
        proc()
        begin
          property::_Op(Rel, _plus,
            proc(rel1, rel2)
            begin
              if OPR(rel1) = OPR(rel2) then
                if OPR(rel1) <> 3 then
                  return(chBOR(rel1, BOR(rel1) + BOR(rel2)))
                end_if
              // 1+2=3,1*2=2; 5+6mod8=3,5*6mod25=5 
              elif modp(OPR(rel1) + OPR(rel2), 8) = 3 then
                return(Rel::_new(_if(OPR(rel1) < 3, 1, 6),
                                 BOR(rel1) + BOR(rel2), REAL(rel1) and REAL(rel2)))
              elif OPR(rel1) = 4 then
                return(chBOR(rel2, BOR(rel1) + BOR(rel2)))
              elif OPR(rel2) = 4 then
                return(chBOR(rel1, BOR(rel1) + BOR(rel2)))
              end_if;
              return(Type::Real)
              //return(hold(_plus)(args()))
            end_proc, args())
        end_proc:

Rel::_subtract:=
        proc()
        begin
          property::_Op(Rel, _subtract,
            proc(rel1, rel2)
            begin
              if Rel::neq(OPR(rel1), OPR(rel2)) then
                                         // prov.
                return(Rel::_new(op(Rel::__ax, [OPR(rel1), Rel::inv(OPR(rel2))]),
                                 BOR(rel1) - BOR(rel2), REAL(rel1) and REAL(rel2)))
              // < > 
              elif OPR(rel1) = EQU then
                return(Rel::_new(Rel::inv(OPR(rel2)),
                                 BOR(rel1) - BOR(rel2), REAL(rel1) and REAL(rel2)))
              elif OPR(rel2) = EQU then
                return(chBOR(rel1, BOR(rel1) - BOR(rel2)))
              end_if;
              return(Type::Real)
              //return(hold(_subtract)(args()))
            end_proc, args())
        end_proc:

Rel::_negate:=
        proc(rel)
        begin
          return(chBOR(chOPR(rel, Rel::inv(OPR(rel))),
                       -BOR(rel)))
        end_proc:

// _leequal eines Nulloperanden 
// sign_1, sign_2, op_1, op_2, op_alt 
Rel::__muop:=
        proc(sign_1, sign_2, op_1, op_2, op_alt)
        begin
          if sign_1 = 0.5 and (op_1 mod 5) <> 1 then op_1
          elif sign_1 = -0.5 and (op_1 mod 5) <> 1 then Rel::inv(op_1)
          elif sign_2 = 0.5 and (op_2 mod 5) <> 1 then op_2
          elif sign_2 = -0.5 and (op_2 mod 5) <> 1 then Rel::inv(op_2)
          else op_alt
          end_if
        end_proc:

Rel::_mult:=
        proc()
        begin
          property::_Op
           (Rel, _mult,
            proc(rel1, rel2)
              local __ar, __s1, __s2;
            begin
              __s1:= Rel::_sign(rel1);
              __s2:= Rel::_sign(rel2);
              __ar:= [OPR(rel1), OPR(rel2)];

              // (= x) * (> y) => (> x*y)
              if OPR(rel1) = EQU then //!!! _sign(= I/x) = 0 !!!
                if OPR(rel2) = EQU then // (= x) * (= y)
                  return(chBOR(rel1, BOR(rel1)*BOR(rel2)))
                elif __s1 = 0 and Rel::Real(rel1) <> TRUE then
                  return(property::Complex::_mult(property::convert_to(rel1, property::Complex),
                                                  property::convert_to(rel2, property::Complex)))
                elif __s1 = 0 and BOR(rel1) = 0 then
                  // (= 0) * (> y) => (= 0)
                  return(rel1)
                else
                  return(Rel::_new(_if(__s1 = -1, Rel::inv(OPR(rel2)), OPR(rel2)),
                                   BOR(rel1)*BOR(rel2), REAL(rel1) and REAL(rel2)))
                end_if
              // (> x) * (= y) => (> x*y)
              elif OPR(rel2) = EQU then //!!! _sign(= I/x) = 0 !!!
                if __s2 = 0 and Rel::Real(rel2) <> TRUE then
                  return(property::Complex::_mult(property::convert_to(rel1, property::Complex),
                                                  property::convert_to(rel2, property::Complex)))
                elif __s2 = 0 and BOR(rel2) = 0 then
                  // (> x) * (= 0) => (= 0)
                  return(rel2)
                else
                  return(Rel::_new(_if(__s2 = -1, Rel::inv(OPR(rel1)), OPR(rel1)),
                                   BOR(rel1)*BOR(rel2), REAL(rel1) and REAL(rel2)))
                end_if
              end_if;

              if __s1 > 0 then
                if __s2 > 0 then
                  if {op(__ar)} minus {5, 6} = {} then
                    return(Rel::_new(Rel::__muop(__s1, __s2, op(__ar), max(op(__ar))),
                                     BOR(rel1)*BOR(rel2), REAL(rel1) and REAL(rel2)))
                  end_if
                elif __s2 < 0 then
                  if {op(__ar, 1)} minus {5, 6} = {} and
                     {op(__ar, 2)} minus {1, 2} = {} then
                    return(Rel::_new(Rel::__muop(__s1, __s2, op(__ar),
                                                 min(Rel::inv(op(__ar, 1)), op(__ar, 2))),
                                     BOR(rel1)*BOR(rel2), REAL(rel1) and REAL(rel2)))
                  end_if
                end_if
              elif __s1 < 0 then
                if __s2 > 0 then
                  if {op(__ar, 2)} minus {5, 6} = {} and
                     {op(__ar, 1)} minus {1, 2} = {} then
                    return(Rel::_new(Rel::__muop(__s1, __s2, op(__ar),
                                                 max(Rel::inv(op(__ar, 2)), op(__ar, 1))),
                                     BOR(rel1)*BOR(rel2), REAL(rel1) and REAL(rel2)))
                  end_if
                elif __s2 < 0 then
                  if {op(__ar)} minus {1, 2} = {} then
                    return(Rel::_new(Rel::__muop(__s1, __s2, op(__ar),
                                                 Rel::inv(min(op(__ar)))),
                                     BOR(rel1)*BOR(rel2), REAL(rel1) and REAL(rel2)))
                  end_if
                end_if
              end_if;

              // special case both unequal to zero
              if OPR(rel1) = UNE and BOR(rel1) = 0
                 and Rel::is(rel2, rel1) = TRUE then
                return(rel1)
              elif OPR(rel2) = UNE and BOR(rel2) = 0
                   and Rel::is(rel1, rel2) = TRUE then
                return(rel2)
              end_if;

              return(Type::Real)
              //return(hold(_mult)(args()))
            end_proc, args())
        end_proc:

Rel::_divide:=
        proc(rel1, rel2)
        begin
          // Sonderfall Divisor numerisch
          if testtype(rel2, Type::Real) then
            if iszero(rel2) then // division by zero
              return(property::Null)
            else // division by real number
              return(chBOR(rel1, BOR(rel1)/rel2))
            end_if
          end_if;
          property::_Op
           (Rel, _divide,
            proc(rel1, rel2)
              local __ar, __s1, __s2;
            begin
              __s2:= Rel::_sign(rel2);
              // Null Teiler 
              if specfunc::abs(__s2) < 1 then
                if contains({2, 4, 5}, OPR(rel2)) then
                  return(property::Null)
                elif OPR(rel2) = 3 and
                     property::_is(BOR(rel2) <> 0) = TRUE then
                  return(property::Null)
                end_if
              end_if;

              __s1:= Rel::_sign(rel1);
              __ar:= [OPR(rel1), OPR(rel2)];
              // =x 
              if OPR(rel1) = 4 then
                if OPR(rel2) = 4 and Rel::_sign(rel2) <> 0 then
                  return(chBOR(rel1, BOR(rel1)/BOR(rel2)))
                end_if;
                if specfunc::abs(__s2) = 1 then
                  if sign(__s1*__s2) < 0 then
                    return(Rel::_new(1, 0, TRUE))
                  elif sign(__s1*__s2) > 0 then
                    return(Rel::_new(6, 0, TRUE))
                  elif property::_is(BOR(rel1) = 0) = TRUE then
                    return(chBOR(rel1, 0))
                  end_if
                end_if
              elif OPR(rel2) = 4 then
                if specfunc::abs(__s1) = 1 then
                  if sign(__s1*__s2) < 0 then
                    return(Rel::_new(1, 0, TRUE))
                  elif sign(__s1*__s2) > 0 then
                    return(Rel::_new(6, 0, TRUE))
                  elif property::_is(BOR(rel1) = 0) = TRUE then
                    return(chBOR(rel2, 0))
                  end_if
                end_if
              end_if;

              if __s1 > 0 then
                if __s2 > 0 then
                  if {op(__ar)} minus {5, 6} = {} then
                    return(Rel::_new(6, 0, TRUE))
                  end_if
                elif __s2 < 0 then
                  if {op(__ar, 1)} minus {5, 6} = {} and
                     {op(__ar, 2)} minus {1, 2} = {} then
                    return(Rel::_new(1, 0, TRUE))
                  end_if
                end_if
              elif __s1 < 0 then
                if __s2 > 0 then
                  if {op(__ar, 2)} minus {5, 6} = {} and
                     {op(__ar, 1)} minus {1, 2} = {} then
                    return(Rel::_new(1, 0, TRUE))
                  end_if
                elif __s2 < 0 then
                  if {op(__ar)} minus {1, 2} = {} then
                    return(Rel::_new(6, 0, TRUE))
                  end_if
                end_if
              end_if;

              // genau (un)gleich 
              if {op(__ar)} minus {3, 4} = {} then
                if {op(__ar)} = {4} then
                  return(chBOR(rel1, BOR(rel1)/BOR(rel2)))
                elif {op(__ar)} = {3, 4} then
                  return(Rel::_new(3, BOR(rel1)/BOR(rel2), REAL(rel1) and REAL(rel2)))
                end_if
              end_if;

              // <> 0
              if OPR(rel1) = 3 and property::_is(BOR(rel1) = 0) = TRUE then
                return(rel1)
              end_if;

              return(Type::Real)
              //return(hold(_divide)(args()))
            end_proc, args())
        end_proc:

Rel::_invert:=
        proc(rel)
          local k;
        begin
          if Rel::_sign(rel) > 0 then
            if OPR(rel) = 4 then
              return(chBOR(rel, 1/BOR(rel)))
            elif OPR(rel) > 4 then
              if property::_is(BOR(rel) >= 1) = TRUE then
                return(property::IV(0, _if(OPR(rel) > 5, 1/BOR(rel), [1/BOR(rel)])))
              else
                return(Rel::_new(6, 0, TRUE))
              end_if
            end_if
          elif Rel::_sign(rel) < 0 then
            if OPR(rel) = 4 then
              return(chBOR(rel, 1/BOR(rel)))
            elif OPR(rel) < 3 then
              if property::_is(BOR(rel) <= -1) = TRUE then
                return(property::IV(_if(OPR(rel) < 2, 1/BOR(rel), [1/BOR(rel)]), 0))
              else
                return(Rel::_new(1, 0, TRUE))
              end_if
            end_if
          end_if;
          if (k:= property::_is(BOR(rel) = 0)) = FALSE then
            k:= property::IV(-1, 1) and rel;
            if type(k) = "IV" then
              k:= property::IV::sign(k)
            elif k = property::Null then
              k:= {0}
            else
              k:= {-1, 0, 1}
            end_if;
            if k = property::Null then
              return(chBOR(rel, 1/BOR(rel)))
            elif not contains(k, -1) then
              return(property::Rel(-hold(_less), 0))
            elif not contains(k, 1) then
              return(property::Rel(hold(_less), 0))
            else
              return(property::IV(-infinity, infinity))
            end_if
          elif k = TRUE then
            if OPR(rel) = 3 then
              return(chBOR(rel, 0))
            end_if
          end_if;

          return(Type::Complex)
        end_proc:

Rel::_power:=
        proc(rel, pow)
          local s, sp, real;
        begin
          if type(rel) <> "Rel" then
            if type((s:= property::_convert(FAIL, pow, Rel))) <> "Rel" then
              return(hold(_power)(rel, pow))
            else
              return(Rel::_power(s, pow))
            end_if
          end_if;

          s:= Rel::_sign(rel);
          sp:= property::_is(pow > 0);
          if type(pow) <> "Rel" then
            // Quadrat einer Relation
            if (real:= property::_is(pow, Type::Even)) = TRUE then
              // > 0
              if OPR(rel) = UNE then
                return(rel)
              end_if;
              if s > 0 then
                if sp = TRUE then // pow > 0
                  return(chBOR(rel, BOR(rel)^pow))
                elif sp = FALSE then // pow < 0
                  if BOR(rel) <> 0 then
                    return(chBOR(rel, 1/(BOR(rel)^-pow)))
                  else
                    return(Rel::_invert(Rel::_power(rel, -pow)))
                  end_if
                else
                  return(chBOR(rel, BOR(rel)^pow))
                end_if
              // < 0
              elif s < 0 then // negative Zahl
                if sp = TRUE then // pow > 0
                  // Re(.) > ..
                  if property::_is(pow, Type::Integer) = TRUE then
                    return(Rel::_new(7 - OPR(rel), BOR(rel)^pow, REAL(rel)))
                  else
                    
                  end_if
                elif sp = FALSE then
                  if BOR(rel) <> 0 then
                    return(chBOR(rel, 1/(BOR(rel)^-pow)))
                  else
                    return(Rel::_invert(Rel::_power(rel, -pow)))
                  end_if
                else
                  return(chBOR(rel, BOR(rel)^pow))
                end_if
              elif testtype(BOR(rel), Type::Real) then
                return(Rel::abs(rel))
              end_if
            // pow ungerade
            elif real = FALSE then
              // > 0
              if s > 0 then
                if sp = TRUE then // pow > 0
                  return(chBOR(rel, BOR(rel)^pow))
                elif sp = FALSE then // pow < 0
                  if BOR(rel) <> 0 then
                    //return(chBOR(rel, 1/(BOR(rel)^-pow)))
                  else
                    //return(Rel::_invert(Rel::_power(rel, -pow)))
                  end_if
                else
                  //return(chBOR(rel, BOR(rel)^pow))
                end_if
              // < 0
              elif s < 0 then
                if sp = TRUE then // pow > 0
                  //return(Rel::_new(7 - OPR(rel), BOR(rel)^pow))
                elif sp = FALSE then
                  if BOR(rel) <> 0 then
                    //return(chBOR(rel, 1/(BOR(rel)^-pow)))
                  else
                    //return(Rel::_invert(Rel::_power(rel, -pow)))
                  end_if
                else
                  return(chBOR(rel, 0))
                end_if
              end_if
            end_if;
            // Quadrat-Wurzel
// >> getprop(x^a)
// Re(.) > 0 // hier kann man hchstens Re(.) >= 0 sagen 
// Regeln: - x < 0 und 0    <= Re(a) <= 1   ==> Im(x^a) >= 0
// - x < 0 und 0    <  Re(a) <  1   ==> Im(x^a) >  0
// - x < 0 und -1   <= Re(a) <= 0   ==> Im(x^a) <= 0
// - x < 0 und -1   <  Re(a) <  0   ==> Im(x^a) <  0
// - x < 0 und -1/2 <= Re(a) <= 1/2 ==> Re(x^a) >= 0
// - x < 0 und -1/2 <  Re(a) <  1/2 ==> Re(x^a) >  0
            if domtype(pow) = DOM_RAT or domtype(pow) = DOM_FLOAT then
              if domtype(pow) = DOM_RAT and op(pow, 2) = 2 then
                return(Rel::sqrt(rel, op(pow, 1)))
              elif abs(pow) < 1/2 then // power less than 1/2, but positive!
                return(property::Complex(Rel::_new(GTH, 0, TRUE)))
              elif s < 0 then // negative Zahl
                return(Type::Complex)
              end_if
            end_if;

            // hoch Null 
            if property::_is(pow = 0) = TRUE then
              return(chBOR(rel, BOR(rel)^0))
            elif property::_is(pow < 0) = TRUE then
              return(Rel::_invert(Rel::_power(rel, -pow)))
            end_if;

            // pow numerisch
            if testtype(pow, Type::Constant) and testtype(property::carefloat(pow), Type::Real) then
              if s > 0 then
                // > 0
                //%%//
                if numeric::isless(pow,0)=FALSE then
                  return(chBOR(rel, BOR(rel)^pow))
                else // pow < 0
                  return(Rel::_invert(chBOR(rel, BOR(rel)^-pow)))
                end_if
              elif s < 0 then
                // <= 0
                if domtype(pow/2) = DOM_INT then
                  if pow >= 0 then
                    return(Rel::_new(Rel::inv(OPR(rel)), BOR(rel)^pow, REAL(rel)))
                  else // pow < 0
                    return(Rel::_invert(Rel::_power(rel, -pow)))
                  end_if
                else
                  if pow >= 0 then
                    return(chBOR(rel, BOR(rel)^pow))
                  else // pow < 0
                    return(Rel::_invert(chBOR(rel, BOR(rel)^-pow)))
                  end_if
                end_if
              else // Type::Real
                if domtype(pow/2) = DOM_INT then
                  return(Rel::_new(GEQ, 0, TRUE))
                elif testtype(BOR(rel), Type::Real) then
                  return(chBOR(rel, BOR(rel)^pow))
                else
                  return(hold(_power)(rel, pow))
                end_if
              end_if
            // pow numerisch
            elif testtype(pow, Type::Numeric) then // Complex
              return(Type::Complex)
            // pow NRange
            elif type(pow) = "NRange" then
              real:= property::NRange::is(pow, Type::Real);
              //return(property::NRange::_power(Rel::NRange(rel), pow));
              if not contains((sp:= property::NRange::sign(pow)), -1) then
                // pow >= 0
                if not contains(sp, 0) and property::NRange::is(pow, Type::Integer) = TRUE then
                  // pow >= 1
                  if s > 0 then // rel > 0
                    return(rel)
                  elif s < 0 then // rel < 0
                    return(Type::Real)
                  else
                    return(Type::Complex)
                  end_if
                else // pow >= 0
                  if s > 0 then // rel > 0
                    return(Rel::_new(GTH, 0, TRUE))
                  elif s < 0 then // rel < 0
                    return(Type::Complex)
                  else
                    return(Type::Complex)
                  end_if
                end_if
              elif not contains(sp, 1) then
                // pow <= 0
                return(Rel::_invert(Rel::_power(rel, -pow)))
              elif property::NRange::is(pow, Type::Integer) = TRUE then
                // pow - integer
                if s > 0 then // rel >= 0
                  return(Rel::_new(_if(s > 0.5, GTH, GEQ), 0, TRUE))
                elif s < 0 then // rel < 0
                  return(Type::Real)
                else 
                  return(Type::Real)
                end_if
              elif property::NRange::is(pow, Type::Real) = TRUE then
                // pow - real
                if s > 0 then // rel >= 0
                  return(Rel::_new(_if(s > 0.5, GTH, GEQ), 0, TRUE))
                elif s < 0 then // rel < 0
                  return(Type::Complex)
                else 
                  Type::Real
                end_if
              else
                return(Type::Complex)
              end_if
            elif type(pow) = "Residue" then
              if property::Residue::constant(pow) = TRUE then
                return(Rel::_power(rel, property::Residue::remainder(pow)))
              else
                // Verallgemeinerung
                return(Rel::_power(rel, property::Residue::range(pow)))
              end_if
            elif type(pow) = "IV" then
              //
              return(property::IV::_power(Rel::IV(rel), pow))
            end_if
          else // rel^rel
            sp:= Rel::_sign(pow);
            if s > 0 then
              // > 0
              if sp > 0 then
                return(chBOR(rel, BOR(rel)^BOR(pow)))
              else // pow < 0
                return(Rel::_invert(chBOR(rel, BOR(rel)^-BOR(pow))))
              end_if
            elif s < 0 then
              // <= 0
              if sp > 0 then
                return(chBOR(rel, BOR(rel)^BOR(pow)))
              elif sp < 0 then // pow < 0
                return(Rel::_invert(chBOR(rel, BOR(rel)^-BOR(pow))))
              else // pow ??
                return(Type::Complex)
              end_if
            end_if
          end_if;
          return(hold(_power)(args()))
        end_proc:

Rel::evaluate:=
        proc(rel)
          local bor;
        begin
          bor:= eval(BOR(rel));
          if type(bor) = "Rel" then
            // can be evaluated to '= BOR'
            chBOR(rel, BOR(bor))
          else
            chBOR(rel, bor)
          end_if
        end_proc:

Rel::float:=
        proc(rel)
          local f;
        begin
          if type((f:= float(BOR(rel)))) <> "float" then
            chBOR(rel, f)
          else
            rel
          end_if
        end_proc:

Rel::Integer:=
        proc(rel)
        begin
          if contains({1, 2}, OPR(rel)) then
            property::Rel(_leequal, floor(BOR(rel)))
          elif contains({5, 6}, OPR(rel)) then
            property::Rel(-_leequal, ceil(BOR(rel)))
          else
            property::Null
          end_if
        end_proc:

// Attribute
Rel::min:=
        proc(XX)
        begin
          if args(0) = 1 then
            return(XX)
          else
            return(Rel::_min(XX, Rel::min(args(2..args(0)))))
          end_if;
          FAIL
        end_proc:

Rel::_min:=
        proc(rel1, rel2)
          local _op;
        begin
          if (_op:= Rel::_minop(OPR(rel1), OPR(rel2))) <> 0 then
            if property::_is(BOR(rel1) = BOR(rel2)) = TRUE then
              return(chOPR(rel1, _op))
            elif property::_is(BOR(rel1) >= BOR(rel2)) = TRUE then
              return(rel2)
            elif property::_is(BOR(rel1) <= BOR(rel2)) = TRUE then
              return(rel1)
            else
              return(Rel::_new(_op, hold(min)(BOR(rel1), BOR(rel2)))) // !!REAL
            end_if
          end_if;
          return(hold(min)(rel1, rel2))
        end_proc:

Rel::max:=
        proc(XX)
        begin
          if args(0) = 1 then
            return(XX)
          else
            return(Rel::_max(XX, Rel::max(args(2..args(0)))))
          end_if;
          FAIL
        end_proc:

Rel::_max:=
        proc(rel1, rel2)
          local _op;
        begin
          if (_op:= Rel::_maxop(OPR(rel1), OPR(rel2))) <> 0 then
            if property::_is(BOR(rel1) = BOR(rel2)) = TRUE then
              return(chOPR(rel1, _op))
            elif property::_is(BOR(rel1) >= BOR(rel2)) = TRUE then
              return(rel1)
            elif property::_is(BOR(rel1) <= BOR(rel2)) = TRUE then
              return(rel2)
            else
              return(Rel::_new(_op, hold(max)(BOR(rel1), BOR(rel2)))) //!!REAL
            end_if
          end_if;
          return(hold(max)(rel1, rel2))
        end_proc:

Rel::sin:=
        proc(rel)
        begin
          if contains({3, 4}, OPR(rel)) then
            chBOR(rel, sin(BOR(rel)))
          else
            property::IV([-1, 1])
          end_if
        end_proc:

Rel::cos:=
        proc(rel)
        begin
          if contains({3, 4}, OPR(rel)) then
            chBOR(rel, cos(BOR(rel)))
          else
            property::IV([-1, 1])
          end_if
        end_proc:

Rel::tan:=
        proc(rel)
        begin
          if contains({3, 4}, OPR(rel)) then
            chBOR(rel, tan(BOR(rel)))
          else
            property::IV([-1, 1])
          end_if
        end_proc:

Rel::sqrt:=
        proc(rel)
        begin
          if Rel::_sign(rel) > 0 then
            chBOR(rel, sqrt(BOR(rel)))
          else // !!
            Type::Complex
          end_if
        end_proc:

Rel::ln:=
        proc(rel)
        begin
          if property::_is(BOR(rel) >= 1) = TRUE then
            if OPR(rel) >= EQU then
              return(chBOR(rel, BOR(rel) - 1))
            end_if
          elif property::_is(BOR(rel) >= 0) = TRUE then
            return(Type::Real)
          end_if;
          hold(ln)(rel)
//        if Rel::_sign(chBOR(rel, BOR(rel) - 1)) <> 0 then
//          chBOR(rel, 0)
//        else
//          Type::Real
//        end_if
        end_proc:

Rel::exp:=
        proc(rel)
        begin
          if Rel::neq(OPR(rel), 1) or contains({3, 4}, OPR(rel)) then // >/>=
            return(chBOR(rel, exp(BOR(rel))))
          else //if Rel::neq(OPR(rel), 6) then // </<=
            property::IV(0, exp(BOR(rel)))
          end_if
        end_proc:

Rel::abs:=
        proc(rel)
          local s;
        begin
          if OPR(rel) = 4 then // =
            chBOR(rel, abs(BOR(rel)))
          elif OPR(rel) = 3 then // <>
            rel and property::Rel(-_leequal, 0)
          elif contains({5, 6}, OPR(rel)) then // >/>=
            if contains((s:= Rel::sign(rel)), -1) then
              property::Rel(-_leequal, 0)
            else
              rel
            end_if
          else //elif contains({1, 2}, OPR(rel)) then // </<=
            if contains((s:= Rel::sign(rel)), 1) then
              property::Rel(-_leequal, 0)
            else
              -rel
            end_if
          end_if
        end_proc:

// Konvertierungen
Rel::NRange:=
        proc(rel1, Opt = hold(Exact))
        begin
          if Rel::Real(rel1) = FALSE then
            return(FAIL)
          end_if;
          // 
          if Opt = hold(Exact) then
            if (not(contains({-infinity, 0, 0.0, infinity}, OPR(rel1)))
                or contains({DOM_EXPR, DOM_IDENT}, domtype(OPR(rel1)))) then
              if property::_is(BOR(rel1) = 0) = TRUE
                 and OPR(rel1) <> LEQ then
                return(property::NRange(op(["Negative", "Real", "NonZero",
                                            "Zero", "NonNegative", "Positive"], OPR(rel1))))
              end_if
            end_if;
            return(Rel::IV(rel1))
          else
            case OPR(rel1)
              of EQU do
                return((BOR(rel1))::dom::NRange(BOR(rel1), Opt))
              of LES do // < 
                if property::_is(BOR(rel1) <= 0) = TRUE then
                  return(property::NRange("Negative"))
                end_if; break
              of LEQ do // <= 
                if property::_is(BOR(rel1) < 0) = TRUE then
                  return(property::NRange("Negative"))
                elif property::_is(BOR(rel1) <= 0) = TRUE then
                  return(hold(_or)(property::NRange("Negative"),
                                   property::NRange("Zero")))
                end_if; break
              of UNE do
                if property::_is(BOR(rel1) = 0) = TRUE then
                  return(property::NRange("NonZero"))
                else
                  return(FAIL)
                end_if; break
              of GEQ do // >= 
                if property::_is(BOR(rel1) > 0) = TRUE then
                  return(property::NRange("Positive"))
                elif property::_is(BOR(rel1) >= 0) = TRUE then
                  return(property::NRange("NonNegative"))
                end_if; break
              of GTH do // > 
                if property::_is(BOR(rel1) >= 0) = TRUE then
                  return(property::NRange("Positive"))
                end_if; break
            end_case;
            //if domtype(BOR(rel1)) = DOM_IDENT then return(FAIL) end_if;
            //return(FAIL);
            //if property::propend then
              property::NRange("Real")
            //else
            //  FAIL
            //end_if
          end_if
        end_proc:

Rel::Residue:=
        proc(rel, OPT = hold(Exact))
        begin
          if OPT = hold(Exact) then
            if OPR(rel) = EQU then
              if domtype(BOR(rel)) = DOM_INT then
                property::Residue(BOR(rel), 0)
              elif domtype(BOR(rel)) = DOM_RAT then
                hold(_divide)(property::Residue(op(BOR(rel), 1), 0),
                              property::Residue(op(BOR(rel), 2), 0))
              else
                FAIL
              end_if
            else
              FAIL
            end_if
          else
            Rel::NRange(rel)
          end_if
        end_proc:

Rel::IVnat:=
        proc(rel1, OPT = FAIL)
        begin
          if Rel::Real(rel1) = FALSE then
            return(FAIL)
          end_if;
          
          case OPR(rel1)
            of LES do return(property::IVnat(-infinity, BOR(rel1)))
            of LEQ do return(property::IVnat(-infinity, [BOR(rel1)]))
            of UNE do
              if Rel::Real(rel1) = TRUE or OPT = hold(Real) then
                return(hold(_or)(property::IVnat(-infinity, BOR(rel1)),
                                 property::IVnat(BOR(rel1), infinity)))
              else
                return(FAIL)
              end_if
            of EQU do return(property::IVnat([BOR(rel1)], [BOR(rel1)]))
            of GEQ do return(property::IVnat([BOR(rel1)], infinity))
            of GTH do return(property::IVnat(BOR(rel1), infinity))
          end_case
        end_proc:

Rel::IV:=
        proc(rel, OPT = FAIL)
          local ret;
        begin
          if Rel::Real(rel) = FALSE then
            return(FAIL)
          end_if;
          ret:= Rel::IVnat(rel, OPT);
          if type(ret) = "IVnat" then
            if OPR(rel) = EQU then // only equal
              if (rel:= property::convert_to(BOR(rel), property::NRange)) = "NRange" then
                property::IV::check(ret, rel)
              else
                property::IV::check(ret, Type::Real)
              end_if
            else
              property::IV::check(ret, Type::Real)
            end_if
          elif ret = FAIL then // cannot convert to IVnat!
            return(FAIL)
          else
            map(ret, property::IV::check, Type::Real)
          end_if
        end_proc:

Rel::Complex:=
        proc(rel)
        begin
          case Rel::Real(rel)
            of TRUE do
              property::Complex(rel, Type::Zero);
              break
            of FALSE do // = Complex constant
              //if OPR(rel) = EQU then
                property::Complex(property::Rel(hold(_equal), Re(BOR(rel))),
                                  property::Rel(hold(_equal), Im(BOR(rel))));
              //else
              //  property::Complex()
              //end_if;
              break
            otherwise
              property::Complex()
          end_case
        end_proc:

// Relation -> Ausdruck 
Rel::expr:=
        proc(rel, ident = null())
        begin
//           if NOT(rel) then
//             return(Rel::expr(invNOT(rel), ident))
//           end_if;
          if domtype(ident) <> DOM_NULL then
            if type(rel) = "Rel" then 
              if OPR(rel) > 4 then
                eval(op(Rel::__op, 7 - OPR(rel)))(BOR(rel), ident)
              else
                if OPR(rel) = UNE and REAL(rel) then
                  eval(op(Rel::__op, OPR(rel)))(ident, BOR(rel)) and ident in R_
                else
                  eval(op(Rel::__op, OPR(rel)))(ident, BOR(rel))
                end_if
              end_if
            else
              rel
            end_if
          else
            rel
          end_if
        end_proc:

//Rel::expr2text:=
//        proc(rel1)
//        begin
//          "property::Rel(".
//          expr2text(op(Rel::__op, OPR(rel1))).
//          ", ".expr2text(BOR(rel1)).")"
//        end_proc:

Rel::hull:=
        proc(rel)
        begin
          if OPR(rel) = UNE then
            RD_NINF...RD_INF + I*(RD_NINF...RD_INF)
          elif OPR(rel) = EQU then
            hull(BOR(rel))
          elif OPR(rel) > 4 then // >=, >
            BOR(rel)...RD_INF
          else // <=, <
            RD_NINF...BOR(rel)
          end_if
        end_proc:

Rel::prop2set:=
        proc(rel)
        begin
          if OPR(rel) = UNE then
            C_ minus {BOR(rel)}
          elif OPR(rel) = EQU then
            {BOR(rel)}
          else
            Dom::Interval::convert(Rel::IVnat(rel))
          end_if
        end_proc:

Rel::Test:=
        proc(ex, ident = hold(x))
          //option hold;
        begin
          if testtype(ex, Type::Relation) then
            if op(ex, 1) = ident then
              return(Rel(op(ex, 0), op(ex, 2)))
            else
              return(Rel(-op(ex, 0), op(ex, 1)))
            end_if
          else
            map(ex, Rel::Test, ident)
          end_if
        end_proc:

//Rel::Z:= "":

Rel::print:=
        proc(rel)
        begin
          //_if(NOT(rel), "not ", "").
          _if(contains({LES,LEQ,UNE,EQU,GEQ,GTH}, OPR(rel)),
              op(Rel::__po, OPR(rel)), "?").
          " ".expr2text(BOR(rel))
          ._if(OPR(rel) = UNE and REAL(rel), " and Type::Real", "")
          //debug --- ._if(REAL(rel), " and real", "")
        end_proc:

unalias(LES):
unalias(LEQ):
unalias(UNE):
unalias(EQU):
unalias(GEQ):
unalias(GTH):
unalias(REAL):
unalias(chREAL):
unalias(cbREAL):
// unalias(invNOT):
// unalias(chNOT):
// unalias(NOT):
unalias(chBOR):
unalias(BOR):
unalias(chOPR):
unalias(OPR):
unalias(Rel):
