// $Date: 2001/06/07 17:56:50 $ $Author: stefanw $ $Revision: 1.4 $

// solvelib::vectorForm - writes the output of the system solver
// as a set of vectors
// a solution var1=value1,..., varn=valuen
// corresponds to the vector [value1, ...,valuen]
// if varlist was [var1,...,varn]


solvelib::vectorForm:=
proc(solution, varlist)
  local x, Rhs;
begin
case type(solution)
  of piecewise do
    return(piecewise::extmap(solution, solvelib::vectorForm, varlist))
  of "_in" do
    x:=op(solution,1);
    Rhs:=op(solution,2);
    case type(Rhs)
      of DOM_SET do
      // expand
        return({subs(varlist, x=op(Rhs, i)) $i=1..nops(Rhs)})
      of piecewise do
        return(map(Rhs, S-> solvelib::vectorForm(hold(_in)(x,S), varlist)))
      otherwise
        return(Dom::ImageSet(varlist, x, Rhs))
    end_case
  of DOM_SET do
    // solution consists of lists of equations
    return(map(solution, eqlist -> subs(varlist, op(eqlist))))
end_case;

// NOT REACHED

  error("Unknown type of solution")

end_proc:
  