alias(MeijerG=specfunc::MeijerG):
MeijerG:=newDomain("specfunc::MeijerG"):
MeijerG::create_dom:=hold(specfunc::MeijerG):

alias(meijerG_symbolic=MeijerG::meijerG_symbolic):
alias(meijerG_cancel=MeijerG::meijerG_cancel):

meijerG:=proc(as,bs,cs,ds,z)
  local answer;
begin
  if args(0)<>5 then
    error("Illegal number of args");
  elif (type(as)=DOM_LIST and type(bs)=DOM_LIST and type(cs)=DOM_LIST and
	type(ds)=DOM_LIST and has([map((op(z),op(map(as,op)),op(map(bs,op)),
		op(map(cs,op)),op(map(ds,op))),type)],DOM_FLOAT)) then
    answer:=meijerG::float(as,bs,cs,ds,z);
  else
    answer:=meijerG_symbolic(as,bs,cs,ds,z);
  end_if;
  return(answer);
end_proc:

meijerG_symbolic:=proc(as,bs,cs,ds,z)
  local as1,bs1,cs1,ds1,answer;
begin
  if type(as)=DOM_LIST then
    as1:=sort(as);
  else
    as1:=as;
  end_if;
  if type(ds)=DOM_LIST then
    ds1:=sort(ds);
  else
    ds1:=ds;
  end_if;
  if type(as1)=DOM_LIST and type(ds1)=DOM_LIST then
    answer:=meijerG_cancel(as1,ds1);
    as1:=answer[1];
    ds1:=answer[2];
  end_if;
  if type(bs)=DOM_LIST then
    bs1:=sort(bs);
  else
    bs1:=bs;
  end_if;
  if type(cs)=DOM_LIST then
    cs1:=sort(cs);
  else
    cs1:=cs;
  end_if;
  if type(bs1)=DOM_LIST and type(cs1)=DOM_LIST then
    answer:=meijerG_cancel(bs1,cs1);
    bs1:=answer[1];
    cs1:=answer[2];
  end_if;
  if as1=[] and bs1=[] and cs1=[] and ds1=[] then
    answer:=0;
  else
    answer:=hold(meijerG)(as1,bs1,cs1,ds1,z);
  end_if;
  return(answer);
end_proc:

meijerG_cancel:=proc(as,bs)
  // Delete parameters that as and bs have in common.
  local as1,bs1,b,p,answer;
begin
  as1:=as;
  bs1:=[];
  for b in bs do
    //if member(b,as1,'p') then
    p:=contains(as1,b):
    if p<>0 then
      as1:=subsop(as1,p=null());
    else
      bs1:=[op(bs1),b];
    end_if;
  end_for;
  answer:=[as1,bs1];
  return(answer);
end_proc:

meijerG := funcenv(meijerG):
meijerG:= slot(meijerG,"type","meijerG"):
meijerG:= slot(meijerG,"print","meijerG"):
meijerG:= slot(meijerG,"info",
"meijerG(as,bs,cs,cd,z) -- Meijer G function with lists of parameters as,bs,cs,ds and argument z"):

meijerG := slot(meijerG, "float",
    loadproc(slot(meijerG, "float"),pathname("STDLIB","FLOAT"),"meijerG")
):

meijerG := slot(meijerG,"diff",
    loadproc(slot(meijerG,"diff"),pathname("STDLIB","DIFF"),"meijerG")
):

