// $Id: frandom.mu,v 1.2 2001/07/18 08:59:34 ccr Exp $

/*++
   frandom -- random number generator of floats, uniformly
              distributed in [0,1].  Uses the kernel function
              stdlib::frandom.

   frandom() returns a DOM_FLOAT chosen as specified above

   frandom(integer) returns a generator returning floats as specified above
++*/

frandom := proc()
 local seed;
 option escape;
begin
 if args(0) = 0 then
   stdlib::frandom();
 else
   seed := args(1);
   if seed::dom <> DOM_INT
   then error("illegal type of argument (integer expected)");
   end_if;

   seed := seed + 10:

   proc()
     local val;
   begin;
     [seed, val] := stdlib::frandom(seed);
     val;
   end_proc;
 end_if;
end_proc:

frandom:= funcenv(frandom):
frandom::type:= "frandom":

