_xor:= funcenv
(proc()
   name _xor;
   local argv : DOM_LIST,
         result;
 begin
   // FALSE is the neutral element
   argv:= select([args()], _unequal, FALSE);

   if contains(argv, UNKNOWN) > 0 then
     return(UNKNOWN)
   end_if;

   result := select(argv, _unequal, TRUE);

   case nops(result)
       of 0 do
       result := FALSE;
       break
     of 1 do
       result:= op(result, 1);
       break
     otherwise
       result:= procname(op(result))
   end_case;
   
 
   if nops(select(argv, _equal, TRUE)) mod 2 = 0 then
     result
   else
     not result
   end_if;
 end_proc,
 builtin(1100, 150, " xor ", "_xor" )):

_xor::type  := "_xor":
_xor::print := "_xor":
_xor::bool  := proc()
               begin
                 _xor(map(args(), bool))
               end_proc:

_xor::TeX        :=
  (arg1, arg2, arg3) -> generate::TeXoperator(" xor ", arg3,
                                              output::Priority::Xor, op(arg2)):
_xor::Content := (Out, data) ->
                 Out::Capply(Out::Cxor, map(op(data), Out)):

