// Dirk Mueller, olorien, 28/10/96, v1.0 
// laplace(Ei(a*t), t, s) = ln(1 + s/a)/s)

Ei:=slot(Ei, "transform::laplace",
  proc(f, t, s) 
    local g, a, b;
  begin
    // f = Ei(g); g = g(t)
    g:=op(f);
    // only g = a*t + b can be treated:
    a:= diff(g, t);
    if has(a, t) then
       return(FAIL);
    end_if;
    // In fact, only b = 0 can be treated:
    b:= eval(subs(g, t = 0));
    if not iszero(b) then
       return(FAIL);
    end_if;

    userinfo(10, "formula 19.1 from R&K");
    // Note that MuPAD's Ei(t) = -Ei_standard(-t) - I*PI (for t > 0)
    // The standard Ei_standard has the laplace transform - ln(1-s)/s,
    // but MuPAD's Ei has:  laplace(Ei(t), t, s) = ln(1 + s)/s !


    // The following formula holds for arbitrary complex values
    // of a and arbitrary complex s with Re(s) > Re(-a). Do *not*
    // change it to something like ln(1 + s/a)/s (as Maple does)!

    return( ln(a + s)/s - ln(a)/s );
  
    FAIL;
  end_proc):

// end of file 
