// $Date: 2001/07/31 09:48:56 $ $Author: stefanw $ $Revision: 1.7 $


/*

    Type::Set

    the type of set-theoretic formulas



*/

Type::Set:=
new(Type, "Set",
    proc(t, x)
      option noDebug;
    begin
      if args(0) <> 2 then
        return(FALSE)
      end_if;

      case domtype(x)
        of stdlib::Universe do // universe is a set expression
        of DOM_SET do
        of DOM_INTERVAL do
          return(TRUE)
        of DOM_IDENT do
          return(not contains(Type::ConstantIdents, x))
        of DOM_EXPR do
          case type(x)
            of "_union" do
            of "_intersect" do
            of "_minus" do
              t:= map([op(x)], testtype, Type::Set);
              if contains(t, FALSE) > 0 then
                return(FALSE)
              elif contains(t, FAIL) > 0 then
                return(FAIL)
              else
                return(TRUE)
              end_if;

              // also represents a set
            of "solve" do
            of "discont" do
            of "RootOf" do
            of "Union" do
              return(TRUE)
            otherwise
              return(FALSE)
          end_case
       end_case;
    
       if x::dom::hasProp(Cat::Set) = TRUE
         or x::dom::set2expr <> FAIL then
         TRUE
       else
         FALSE
       end_if

    end_proc,

    FALSE, FALSE

    ):
