
// Because here scilab is still a loadproc node we have to use hold
// If the module cannot be loaded it is not legalized and the rest
// of the code is not executed, because it makes no sense.

if traperror( module( hold(scilab) ) ) = 0 then

// Setting architecture independent variables
scilab::MUParch := sysname(Arch):
if scilab::MUParch = "MSDOS" then
scilab::MUPpvm_f772sci := "udx_f772sci" ;
scilab::MUPpvm_sci2f77 := "udx_sci2f77" ;
else
scilab::MUPpvm_f772sci := "pvm_f772sci" ;
scilab::MUPpvm_sci2f77 := "pvm_sci2f77" ;
end_if:

// Setting values for the stack management in Scilab
scilab::MUPincrementStacksize:=1000000 :
scilab::MUPScilabTmpDir:="" :

// Predefine some necessary slots, because make_slot exist
scilab::exported:= {};
scilab::_exported:= {};

// Removes the last component of a given path
// No error checking, adapted only to the special situation we have
// here to get the main package directory 
scilab::MUPRemoveLastPathComponent:=
proc(path:DOM_STRING) local l;
begin
  l:=length(path)-1 ;
  if (l >= 0) and (path[l] = stdlib::PathSep) then
    l:=l-1;
  end_if;
  while (l >= 0) and (path[l] <> stdlib::PathSep) do
    l:=l-1;
  end_while;
  if (l >= 0) and (path[l] = stdlib::PathSep) then
    l:=l-1;
  end_if;
  return(substring(path,0,l+1)) ;
end_proc:

// Setting the package main directory
scilab::MUPPackageDir:= FILEPATH:
// Remove the last two path components
scilab::MUPPackageDir:= scilab::MUPRemoveLastPathComponent(
                                             scilab::MUPPackageDir):
scilab::MUPPackageDir:= scilab::MUPRemoveLastPathComponent(
                                             scilab::MUPPackageDir):
scilab::MUPPackageDir:=scilab::MUPPackageDir.stdlib::PathSep:

// Initialize the necessary functions
scilab::Tlist:=loadproc(scilab::Tlist, pathname("SCILAB"), "tlist" ) :
scilab::avail:=loadproc(scilab::avail, pathname("SCILAB"), "utils" ) :
scilab::start:=loadproc(scilab::start, pathname("SCILAB"), "utils" ) :
scilab::MUPstopit:=loadproc(scilab::MUPstopit, pathname("SCILAB"), "utils" ) :
scilab::MUPSetCallOnExit:=loadproc(scilab::MUPSetCallOnExit,
                                   pathname("SCILAB"), "utils" ) :
scilab::MUPcreateRePoMatrix:=loadproc(scilab::MUPcreateRePoMatrix,
                                      pathname("SCILAB"), "utils" ) :
scilab::MUPtestarg:=loadproc(scilab::MUPtestarg, pathname("SCILAB"),
                             "utils" ) :
scilab::MUPgetdomtype:=loadproc(scilab::MUPgetdomtype, pathname("SCILAB"),
                                "utils" ) :
scilab::MUPcoeff2list:=loadproc(scilab::MUPcoeff2list, pathname("SCILAB"),
                                "utils" ) :
scilab::MUPcreateRealPoly:=loadproc(scilab::MUPcreateRealPoly,
                                    pathname("SCILAB"), "utils" ) :

scilab::MUPcreateSparseMatrix:=loadproc(scilab::MUPcreateSparseMatrix,
                                        pathname("SCILAB"), "utils" ) :

scilab::MUPincStacksize:=loadproc(scilab::MUPincStacksize,
                                pathname("SCILAB"), "utils" ) :

scilab::MUPgetScilabTmpDir:=loadproc(scilab::MUPgetScilabTmpDir,
                                   pathname("SCILAB"), "utils" ) :

// define some methods to avoid creation via make_slot 
scilab::evaluate:= FAIL:
scilab::posteval:= FAIL:
scilab::undefinedEntries := FAIL:
scilab::allEntries := FAIL:
scilab::whichEntry := FAIL:
scilab::new_extelement := FAIL:
scilab::create_dom_elem := FAIL:
scilab::Content:=FAIL:
scilab::eval := FAIL:
scilab::domtype:= FAIL:
scilab::type:= FAIL:
scilab::slot:= FAIL:
scilab::expr2text:= FAIL: 
scilab::print:= FAIL: 
scilab::indets:= FAIL:
scilab::bool :=FAIL:
scilab::rectform:= FAIL:
scilab::contains:= FAIL:
scilab::expose := FAIL:
scilab::hastype := FAIL:
scilab::maprec := FAIL:
scilab::op := FAIL:
scilab::nops := FAIL:
scilab::subsop :=  FAIL:

scilab::make_slot:=loadproc(scilab::make_slot, pathname("SCILAB"),
                            "makeslot" ) :

scilab::func:=loadproc(scilab::func, pathname("SCILAB"), "func" ) :

// Set the used matrix type of MuPAD
// 0: Dom::Matrix() <> Dom::SparseMatrix()
// 1: Dom::Matrix() = Dom::SparseMatrix()
(proc()
begin
  if expr2text(domtype(matrix([1]))) = "Dom::Matrix()" then
    // Dom::Matrix() <> Dom::SparseMatrix()
    scilab::MUPSetMatrixType(0);
  else
    // Dom::Matrix() = Dom::SparseMatrix()
    scilab::MUPSetMatrixType(1);
  end_if:
end_proc()):

null():
else
  scilab:=FAIL ;
end_if:
